# Integrals.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/Integrals/stable/)

[![codecov](https://codecov.io/gh/SciML/Integrals.jl/branch/master/graph/badge.svg)](https://app.codecov.io/gh/SciML/Integrals.jl)
[![Build Status](https://github.com/SciML/Integrals.jl/workflows/CI/badge.svg)](https://github.com/SciML/Integrals.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

Integrals.jl is an instantiation of the SciML common `IntegralProblem`
interface for the common numerical integration packages of Julia, including
both those based upon quadrature as well as Monte-Carlo approaches. By using
Integrals.jl, you get a single predictable interface where many of the
arguments are standardized throughout the various integrator libraries. This
can be useful for benchmarking or for library implementations, since libraries
which internally use a quadrature can easily accept an integration method as an
argument.

## Tutorials and Documentation

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/Integrals/stable/). Use the
[in-development documentation](https://docs.sciml.ai/Integrals/dev/) for the version of
the documentation, which contains the unreleased features.

## Examples

To perform one-dimensional quadrature, we can simply construct an `IntegralProblem`. The code below evaluates $\int_{-2}^5 \sin(xp)~\mathrm{d}x$ with $p = 1.7$. This argument $p$ is passed
into the problem as the third argument of `IntegralProblem`.

```julia
using Integrals
f(x, p) = sin(x * p)
p = 1.7
domain = (-2, 5) # (lb, ub)
prob = IntegralProblem(f, domain, p)
sol = solve(prob, QuadGKJL())
```

For basic multidimensional quadrature we can construct and solve a `IntegralProblem`. Since we are using no arguments `p` in this example, we omit the third argument of `IntegralProblem`
from above. The lower and upper bounds are now passed as vectors, with the `i`th elements of
the bounds giving the interval of integration for `x[i]`.

```julia
using Integrals
f(x, p) = sum(sin.(x))
domain = (ones(2), 3ones(2)) # (lb, ub)
prob = IntegralProblem(f, domain)
sol = solve(prob, HCubatureJL(), reltol = 1e-3, abstol = 1e-3)
```

If we would like to parallelize the computation, we can use the batch interface
to compute multiple points at once. For example, here we do allocation-free
multithreading with Cubature.jl:

```julia
using Integrals, Cubature, Base.Threads
function f(dx, x, p)
    Threads.@threads for i in 1:size(x, 2)
        dx[i] = sum(sin, @view(x[:, i]))
    end
end
domain = (ones(2), 3ones(2)) # (lb, ub)
prob = IntegralProblem(BatchIntegralFunction(f, zeros(0)), domain)
sol = solve(prob, CubatureJLh(), reltol = 1e-3, abstol = 1e-3)
```

If we would like to compare the results against Cuba.jl's `Cuhre` method, then
the change is a one-argument change:

```julia
using Cuba
sol = solve(prob, CubaCuhre(), reltol = 1e-3, abstol = 1e-3)
```

module IntegralsCubatureExt

using Integrals
using Cubature: Cubature

using Integrals: CubatureJLh, AbstractCubatureJLAlgorithm
using SciMLLogging: @SciMLMessage

function Integrals.__solvebp_call(
        prob::IntegralProblem,
        alg::AbstractCubatureJLAlgorithm,
        sensealg, domain, p;
        reltol = 1.0e-8, abstol = 1.0e-8,
        maxiters = typemax(Int),
        verbose = Integrals.DEFAULT_VERBOSE
    )
    lb, ub = domain
    mid = (lb + ub) / 2

    @SciMLMessage(
        lazy"$(typeof(alg).name.name): starting $(mid isa Number ? \"1D\" : \"multi-dimensional\") integration with reltol=$reltol, abstol=$abstol",
        verbose, :algorithm_selection
    )

    # we get to pick fdim or not based on the IntegralFunction and its output dimensions
    f = prob.f
    prototype = Integrals.get_prototype(prob)

    @assert eltype(prototype) <: Real "Cubature.jl is only compatible with real-valued integrands"

    if f isa BatchIntegralFunction
        @SciMLMessage("Using batch evaluation mode", verbose, :batch_mode)
        if prototype isa AbstractVector # this branch could be omitted since the following one should work similarly
            if isinplace(f)
                # dx is a Vector, but we provide the integrand a vector of the same type as
                # y, which needs to be resized since the number of batch points changes.
                _f = let y = similar(prototype)
                    (u, v) -> begin
                        resize!(y, length(v))
                        f(y, u, p)
                        v .= y
                    end
                end
            else
                _f = (u, v) -> (v .= f(u, p))
            end
            if mid isa Number
                if alg isa CubatureJLh
                    val,
                        err = Cubature.hquadrature_v(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                else
                    val,
                        err = Cubature.pquadrature_v(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                end
            else
                if alg isa CubatureJLh
                    val,
                        err = Cubature.hcubature_v(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                else
                    val,
                        err = Cubature.pcubature_v(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                end
            end
        elseif prototype isa AbstractArray
            fsize = size(prototype)[begin:(end - 1)]
            fdim = prod(fsize)
            if isinplace(f)
                # dx is a Matrix, but to provide a buffer of the same type as y, we make
                # would like to make views of a larger buffer, but CubatureJL doesn't set
                # a hard limit for max_batch, so we allocate a new buffer with the needed size
                _f = let fsize = fsize
                    (u, v) -> begin
                        y = similar(prototype, fsize..., size(v, 2))
                        f(y, u, p)
                        v .= reshape(y, fdim, size(v, 2))
                    end
                end
            else
                _f = (u, v) -> (v .= reshape(f(u, p), fdim, size(v, 2)))
            end
            if mid isa Number
                if alg isa CubatureJLh
                    val_,
                        err = Cubature.hquadrature_v(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                else
                    val_,
                        err = Cubature.pquadrature_v(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                end
            else
                if alg isa CubatureJLh
                    val_,
                        err = Cubature.hcubature_v(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                else
                    val_,
                        err = Cubature.pcubature_v(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                end
            end
            val = reshape(val_, fsize...)
        else
            error("BatchIntegralFunction integrands must be arrays for Cubature.jl")
        end
    else
        if prototype isa Real
            # no inplace in this case, since the integrand_prototype would be mutable
            _f = u -> f(u, p)
            if lb isa Number
                if alg isa CubatureJLh
                    val,
                        err = Cubature.hquadrature(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                else
                    val,
                        err = Cubature.pquadrature(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                end
            else
                if alg isa CubatureJLh
                    val,
                        err = Cubature.hcubature(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                else
                    val,
                        err = Cubature.pcubature(
                        _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters
                    )
                end
            end
        elseif prototype isa AbstractArray
            fsize = size(prototype)
            fdim = length(prototype)
            if isinplace(prob)
                _f = let y = similar(prototype)
                    (u, v) -> (f(y, u, p); v .= vec(y))
                end
            else
                _f = (u, v) -> (v .= vec(f(u, p)))
            end
            if mid isa Number
                if alg isa CubatureJLh
                    val_,
                        err = Cubature.hquadrature(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                else
                    val_,
                        err = Cubature.pquadrature(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                end
            else
                if alg isa CubatureJLh
                    val_,
                        err = Cubature.hcubature(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                else
                    val_,
                        err = Cubature.pcubature(
                        fdim, _f, lb, ub;
                        reltol = reltol, abstol = abstol,
                        maxevals = maxiters, error_norm = alg.error_norm
                    )
                end
            end
            val = reshape(val_, fsize)
        else
            error("IntegralFunctions must be scalars or arrays for Cubature.jl")
        end
    end

    @SciMLMessage(
        lazy"$(typeof(alg).name.name) converged: val=$val, err=$err",
        verbose, :convergence_result
    )

    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end

end

module IntegralsForwardDiffExt
using Integrals
using ForwardDiff: ForwardDiff
### Forward-Mode AD Intercepts

function Integrals._evaluate!(
        f, y, u,
        p::Union{D, AbstractArray{<:D}}
    ) where {T, V, P, D <: ForwardDiff.Dual{T, V, P}}
    dy = similar(y, replace_dualvaltype(eltype(p), eltype(y)))
    f(dy, u, p)
    return dy
end

# Default to direct AD on solvers
function Integrals.__solvebp(
        cache, alg, sensealg, domain,
        p::Union{D, AbstractArray{<:D}};
        kwargs...
    ) where {T, V, P, D <: ForwardDiff.Dual{T, V, P}}
    return if isinplace(cache.f)
        prototype = cache.f.integrand_prototype
        elt = eltype(prototype)
        ForwardDiff.can_dual(elt) ||
            throw(ArgumentError("ForwardDiff of in-place integrands only supports prototypes with real elements"))
        dprototype = similar(prototype, replace_dualvaltype(D, elt))
        df = if cache.f isa BatchIntegralFunction
            BatchIntegralFunction{true}(cache.f.f, dprototype)
        else
            IntegralFunction{true}(cache.f.f, dprototype)
        end
        prob = Integrals.build_problem(cache)
        dcache = Integrals.IntegralCache(
            cache.iip,
            df,
            domain,
            p,
            cache.prob_kwargs,
            alg,
            sensealg,
            cache.kwargs,
            cache.cacheval,
            cache.verbosity
        )
        Integrals.__solvebp_call(dcache, alg, sensealg, domain, p; kwargs...)
    else
        Integrals.__solvebp_call(cache, alg, sensealg, domain, p; kwargs...)
    end
end

# TODO: add the pushforward for derivative w.r.t lb, and ub (and then combinations?)

# Manually split for the pushforward
function Integrals.__solvebp(
        cache, alg::Integrals.AbstractIntegralCExtensionAlgorithm, sensealg, domain,
        p::Union{D, AbstractArray{<:D}};
        kwargs...
    ) where {T, V, P, D <: ForwardDiff.Dual{T, V, P}}

    # we need the output type to avoid perturbation confusion while unwrapping nested duals
    # We compute a vector-valued integral of the primal and dual simultaneously
    if isinplace(cache)
        y = cache.f.integrand_prototype
        elt = eltype(cache.f.integrand_prototype)
        DT = replace_dualvaltype(eltype(p), elt)
        len = duallen(p)
        dual_prototype = similar(
            cache.f.integrand_prototype,
            len,
            size(cache.f.integrand_prototype)...
        )

        dfdp_ = function (out, x, _p)
            dualp = reinterpret(ForwardDiff.Dual{T, V, P}, _p)
            dout = reinterpret(reshape, DT, out)
            cache.f(dout, x, p isa D ? only(dualp) : reshape(dualp, size(p)))
            return
        end
        dfdp = if cache.f isa BatchIntegralFunction
            BatchIntegralFunction{true}(dfdp_, dual_prototype)
        else
            IntegralFunction{true}(dfdp_, dual_prototype)
        end
    else
        lb, ub = domain
        mid = (lb + ub) / 2
        y = if cache.f isa BatchIntegralFunction
            mid isa Number ? cache.f(eltype(mid)[], p) :
                cache.f(Matrix{eltype(mid)}(undef, length(mid), 0), p)
        else
            cache.f(mid, p)
        end
        DT = y isa AbstractArray ? eltype(y) : typeof(y)
        elt = unwrap_dualvaltype(DT)

        dfdp_ = function (x, _p)
            dualp = reinterpret(ForwardDiff.Dual{T, V, P}, _p)
            ys = cache.f(x, p isa D ? only(dualp) : reshape(dualp, size(p)))
            ys_ = ys isa AbstractArray ? ys : [ys]
            # we need to reshape in order for batching to be consistent
            return reinterpret(reshape, elt, ys_)
        end
        dfdp = if cache.f isa BatchIntegralFunction
            BatchIntegralFunction{false}(dfdp_, nothing)
        else
            IntegralFunction{false}(dfdp_, nothing)
        end
    end

    DT <: Real || throw(ArgumentError("differentiating algorithms in C"))
    ForwardDiff.can_dual(elt) || ForwardDiff.throw_cannot_dual(elt)
    rawp = p isa D ? reinterpret(V, [p]) : copy(reinterpret(V, vec(p)))

    prob = Integrals.build_problem(cache)
    dp_prob = remake(prob, f = dfdp, p = rawp)
    dp_cache = init(
        dp_prob,
        alg;
        sensealg = sensealg,
        cache.kwargs...
    )
    dual = solve!(dp_cache)

    res = reinterpret(reshape, DT, dual.u)
    # unwrap the dual when the primal would return a scalar
    out = if (cache.f isa BatchIntegralFunction && y isa AbstractVector) ||
            !(y isa AbstractArray)
        only(res)
    else
        res
    end
    return SciMLBase.build_solution(prob, alg, out, dual.resid)
end

duallen(::Type{T}) where {T} = 1
duallen(::T) where {T} = duallen(T)
duallen(::AbstractArray{T}) where {T} = duallen(T)
function duallen(::Type{ForwardDiff.Dual{T, V, P}}) where {T, V, P}
    len = duallen(V)
    return len * (P + 1)
end

replace_dualvaltype(::Type{T}, ::Type{S}) where {T, S} = S
function replace_dualvaltype(
        ::Type{ForwardDiff.Dual{T, V, P}},
        ::Type{S}
    ) where {T, V, P, S}
    return ForwardDiff.Dual{T, replace_dualvaltype(V, S), P}
end

unwrap_dualvaltype(::Type{T}) where {T} = T
function unwrap_dualvaltype(::Type{ForwardDiff.Dual{T, V, P}}) where {T, V, P}
    return unwrap_dualvaltype(V)
end
end

"""
    AbstractWeights

Abstract supertype for all quadrature weight types used in sampled integration methods.
"""
abstract type AbstractWeights end

"""
    UniformWeights <: AbstractWeights

Abstract type for quadrature weights with uniform (equally-spaced) sampling points.

Implementations must have:

  - field `n` for the number of points
  - field `h` for the step size between points
"""
abstract type UniformWeights <: AbstractWeights end
@inline Base.iterate(w::UniformWeights) = (0 == w.n) ? nothing : (w[1], 1)
@inline Base.iterate(w::UniformWeights, i) = (i == w.n) ? nothing : (w[i + 1], i + 1)
Base.length(w::UniformWeights) = w.n
Base.eltype(w::UniformWeights) = typeof(w.h)
Base.size(w::UniformWeights) = (length(w),)

"""
    NonuniformWeights <: AbstractWeights

Abstract type for quadrature weights with non-uniform (arbitrarily-spaced) sampling points.

Implementations must have:

  - field `x` containing the sampling points
"""
abstract type NonuniformWeights <: AbstractWeights end
@inline Base.iterate(w::NonuniformWeights) = (0 == length(w.x)) ? nothing :
    (w[firstindex(w.x)], firstindex(w.x))
@inline Base.iterate(w::NonuniformWeights, i) = (i == lastindex(w.x)) ? nothing :
    (w[i + 1], i + 1)
Base.length(w::NonuniformWeights) = length(w.x)
Base.eltype(w::NonuniformWeights) = eltype(w.x)
Base.size(w::NonuniformWeights) = (length(w),)

_eachslice(data::AbstractArray; dims = ndims(data)) = eachslice(data; dims = dims)
_eachslice(data::AbstractArray{T, 1}; dims = ndims(data)) where {T} = data

# these can be removed when the Val(dim) is removed from SciMLBase
dimension(::Val{D}) where {D} = D
dimension(D::Int) = D

# Specialized evalrule for 1D arrays (Vector) - returns scalar
function evalrule(data::AbstractVector, weights, dim)
    # Only use fast indexing path when scalar indexing is efficient (e.g., not on GPU arrays)
    if ArrayInterface.fast_scalar_indexing(data)
        n = length(data)
        n == 0 && throw(ArgumentError("No points to integrate"))
        out = data[1] * weights[1]
        @inbounds for i in 2:n
            out += weights[i] * data[i]
        end
        return out
    else
        return _evalrule_general(data, weights, dim)
    end
end

# Specialized evalrule for 2D arrays (Matrix) integrating over last dimension
# This is the most common case for vector-valued integrands
function evalrule(data::AbstractMatrix{T}, weights, dim) where {T}
    # Only use fast indexing path when scalar indexing is efficient (e.g., not on GPU arrays)
    if ArrayInterface.fast_scalar_indexing(data)
        m, n = size(data)
        n == 0 && throw(ArgumentError("No points to integrate"))
        if dim == 2 || dim == ndims(data)
            # Integration over columns (last dimension) - the common case
            w1 = weights[1]
            out_type = m == 0 ? typeof(w1 * zero(T)) : typeof(w1 * data[1, 1])
            out = Vector{out_type}(undef, m)
            @inbounds @simd for j in 1:m
                out[j] = w1 * data[j, 1]
            end
            @inbounds for i in 2:n
                w = weights[i]
                @simd for j in 1:m
                    out[j] += w * data[j, i]
                end
            end
            return out
        else
            # Integration over rows (dim=1) - less common
            # Fall back to general implementation
            return _evalrule_general(data, weights, dim)
        end
    else
        return _evalrule_general(data, weights, dim)
    end
end

# General fallback for higher-dimensional arrays
function evalrule(data::AbstractArray, weights, dim)
    return _evalrule_general(data, weights, dim)
end

function _evalrule_general(data::AbstractArray, weights, dim)
    fw = zip(_eachslice(data, dims = dim), weights)
    next = iterate(fw)
    next === nothing && throw(ArgumentError("No points to integrate"))
    (f1, w1), state = next
    out = w1 * f1
    next = iterate(fw, state)
    if isbits(out)
        while next !== nothing
            (fi, wi), state = next
            out += wi * fi
            next = iterate(fw, state)
        end
    else
        while next !== nothing
            (fi, wi), state = next
            out .+= wi .* fi
            next = iterate(fw, state)
        end
    end
    return out
end

# can be reused for other sampled rules, which should implement find_weights(x, alg)

function init_cacheval(
        alg::SciMLBase.AbstractIntegralAlgorithm,
        prob::SampledIntegralProblem
    )
    return find_weights(prob.x, alg)
end

function __solvebp_call(
        cache::SampledIntegralCache,
        alg::SciMLBase.AbstractIntegralAlgorithm;
        kwargs...
    )
    dim = dimension(cache.dim)
    err = nothing
    data = cache.y
    grid = cache.x
    if cache.isfresh
        @SciMLMessage(
            lazy"Computing $(typeof(alg).name.name) weights for grid with $(length(grid)) points",
            cache.verbosity, :weight_computation
        )
        cache.cacheval = find_weights(grid, alg)
        cache.isfresh = false
    end
    weights = cache.cacheval

    @SciMLMessage(
        lazy"$(typeof(alg).name.name): evaluating sampled integral",
        cache.verbosity, :algorithm_selection
    )

    I = evalrule(data, weights, dim)

    @SciMLMessage(
        lazy"$(typeof(alg).name.name) completed: val=$I",
        cache.verbosity, :convergence_result
    )

    prob = build_problem(cache)
    return SciMLBase.build_solution(prob, alg, I, err, retcode = ReturnCode.Success)
end

module IntegralsDifferentiationInterfaceExt

using Integrals
using LinearAlgebra: dot
using DifferentiationInterface: DifferentiationInterface
using ADTypes: ADTypes, AbstractADType
import ChainRulesCore
import ChainRulesCore: Tangent, NoTangent, ProjectTo

batch_unwrap(x::AbstractArray) = dropdims(x; dims = ndims(x))

# Define rrule for __solvebp when sensealg is an ADTypes backend
function ChainRulesCore.rrule(
        ::typeof(Integrals.__solvebp), cache, alg, sensealg::AbstractADType, domain, p;
        kwargs...
    )
    # Compute the primal value
    out = Integrals.__solvebp_call(cache, alg, sensealg, domain, p; kwargs...)

    # The adjoint computes the integral of the input sensitivities
    function quadrature_adjoint(Δ)
        # Extract the tangent of the integral value from the solution tangent
        # Δ is a NamedTuple representing tangent of IntegralSolution
        Δu = hasproperty(Δ, :u) ? Δ.u : Δ

        # Handle the sensitivity computation using DifferentiationInterface
        if Integrals.isinplace(cache)
            # For in-place integrands, build an out-of-place wrapper for the pullback
            if cache.f isa SciMLBase.BatchIntegralFunction
                dx = similar(
                    cache.f.integrand_prototype,
                    size(cache.f.integrand_prototype)[begin:(end - 1)]..., 1
                )
                _f = x -> (cache.f(dx, x, p); dx)
                dfdp_ = function (x, p)
                    x_ = x isa AbstractArray ? reshape(x, size(x)..., 1) : [x]
                    Δ_ = Δu isa AbstractArray ? reshape(Δu, size(Δu)..., 1) : Δu
                    # Use DI.pullback: pullback(f, backend, x, ty) -> tx
                    return DifferentiationInterface.pullback(
                        p -> (cache.f(dx, x_, p); copy(dx)),
                        sensealg, p, (Δ_,)
                    )[1]
                end
                dfdp = SciMLBase.IntegralFunction{false}(dfdp_, nothing)
            else
                dx = similar(cache.f.integrand_prototype)
                _f = x -> (cache.f(dx, x, p); dx)
                dfdp_ = function (x, p)
                    # Use DI.pullback: pullback(f, backend, x, ty) -> tx
                    return DifferentiationInterface.pullback(
                        p -> (cache.f(dx, x, p); copy(dx)),
                        sensealg, p, (Δu,)
                    )[1]
                end
                dfdp = SciMLBase.IntegralFunction{false}(dfdp_, nothing)
            end
        else
            # Out-of-place integrand
            _f = x -> cache.f(x, p)
            if cache.f isa SciMLBase.BatchIntegralFunction
                dfdp_ = function (x, p)
                    x_ = x isa AbstractArray ? reshape(x, size(x)..., 1) : [x]
                    Δ_ = Δu isa AbstractArray ? reshape(Δu, size(Δu)..., 1) : [Δu]
                    # Use DI.pullback: pullback(f, backend, x, ty) -> tx
                    return DifferentiationInterface.pullback(
                        p -> cache.f(x_, p),
                        sensealg, p, (Δ_,)
                    )[1]
                end
                dfdp = SciMLBase.IntegralFunction{false}(dfdp_, nothing)
            else
                dfdp_ = function (x, p)
                    Δ_ = Δu isa Number ? Δu : only(Δu)
                    # Use DI.pullback: pullback(f, backend, x, ty) -> tx
                    return DifferentiationInterface.pullback(
                        p -> cache.f(x, p),
                        sensealg, p, (Δ_,)
                    )[1]
                end
                dfdp = SciMLBase.IntegralFunction{false}(dfdp_, nothing)
            end
        end

        # Compute dp (gradient w.r.t. p) only if p is not NullParameters
        if p isa SciMLBase.NullParameters
            dp = NoTangent()
        else
            prob = Integrals.build_problem(cache)
            dp_prob = SciMLBase.IntegralProblem(dfdp, prob.domain, prob.p; prob.kwargs...)
            # The infinity transformation was already applied to f so we don't apply it to dfdp
            dp_cache = SciMLBase.init(
                dp_prob,
                alg;
                sensealg = sensealg,
                cache.kwargs...
            )

            project_p = ProjectTo(p)
            dp = project_p(SciMLBase.solve!(dp_cache).u)
        end

        lb, ub = domain
        if lb isa Number
            # Compute boundary gradients using fundamental theorem of calculus
            dlb = cache.f isa SciMLBase.BatchIntegralFunction ? -batch_unwrap(_f([lb])) :
                -_f(lb)
            dub = cache.f isa SciMLBase.BatchIntegralFunction ? batch_unwrap(_f([ub])) :
                _f(ub)
            return (
                NoTangent(),
                NoTangent(),
                NoTangent(),
                NoTangent(),
                Tangent{typeof(domain)}(dot(dlb, Δu), dot(dub, Δu)),
                dp,
            )
        else
            # For multivariate bounds, boundary derivatives are not yet implemented
            return (NoTangent(), NoTangent(), NoTangent(), NoTangent(), NoTangent(), dp)
        end
    end
    return out, quadrature_adjoint
end

end # module

"""
    AbstractSampledIntegralAlgorithm <: SciMLBase.AbstractIntegralAlgorithm

Abstract type for integration algorithms that work with sampled data points,
such as the trapezoidal rule and Simpson's rule.

## Interface

Concrete subtypes are used with `SampledIntegralProblem` and must support
`find_weights(x, alg)`, where `x` is the problem sampling grid and `alg` is the
concrete algorithm. The returned weights must:

  - have the same length as the integration axis of the sampled data,
  - support `iterate`, `length`, `eltype`, `size`, and scalar indexing, and
  - be valid inputs to `evalrule(data, weights, dim)`.

The generic sampled solver calls `find_weights` during `init` and recomputes weights
when the cache grid `x` is replaced.
"""
abstract type AbstractSampledIntegralAlgorithm <: SciMLBase.AbstractIntegralAlgorithm end

"""
    TrapezoidalRule

Composite trapezoidal rule for integrating sampled data.

## Returns

Returns a `TrapezoidalRule` algorithm object for
`solve(prob::SampledIntegralProblem, alg)`.

## Example

```julia
using Integrals

f = x -> x^2
x = range(0, 1, length = 20)
y = f.(x)
prob = SampledIntegralProblem(y, x)
sol = solve(prob, TrapezoidalRule())
```
"""
struct TrapezoidalRule <: AbstractSampledIntegralAlgorithm end

"""
    SimpsonsRule

Composite Simpson rule for integrating sampled data.

For evenly spaced `AbstractRange` grids this uses the composite Simpson 1/3 and 3/8
rules. For non-equidistant grids it uses a composite Simpson 1/3 construction.

## Returns

Returns a `SimpsonsRule` algorithm object for
`solve(prob::SampledIntegralProblem, alg)`.

## Example

```julia
using Integrals

f = x -> x^2
x = range(0, 1, length = 21)
y = f.(x)
prob = SampledIntegralProblem(y, x)
sol = solve(prob, SimpsonsRule())
```
"""
struct SimpsonsRule <: AbstractSampledIntegralAlgorithm end

"""
    SimpsonUniformWeights{T} <: UniformWeights

Quadrature weights for Simpson's composite 1/3-3/8 rule with uniformly spaced points.

# Fields

  - `n::Int`: Number of points
  - `h::T`: Step size between points
"""
struct SimpsonUniformWeights{T} <: UniformWeights
    n::Int
    h::T
end

@inline function Base.getindex(w::SimpsonUniformWeights, i)
    # evenly spaced simpson's 1/3, 3/8 rule
    h = w.h
    n = w.n
    (i == 1 || i == n) && return 17h / 48
    (i == 2 || i == n - 1) && return 59h / 48
    (i == 3 || i == n - 2) && return 43h / 48
    (i == 4 || i == n - 3) && return 49h / 48
    return h
end

"""
    SimpsonNonuniformWeights{X <: AbstractArray} <: NonuniformWeights

Quadrature weights for Simpson's composite 1/3 rule with non-uniformly spaced points.

# Fields

  - `x::X`: Array of sampling points
"""
struct SimpsonNonuniformWeights{X <: AbstractArray} <: NonuniformWeights
    x::X
end

@inline function Base.getindex(w::SimpsonNonuniformWeights, i)
    # composite 1/3 rule for irregular grids

    checkbounds(w.x, i)
    x = w.x
    j = i - firstindex(x)
    @assert length(w.x) > 2 "The length of the grid must exceed 2 for simpsons rule."
    i == firstindex(x) && return (x[begin + 2] - x[begin + 0]) / 6 *
        (2 - (x[begin + 2] - x[begin + 1]) / (x[begin + 1] - x[begin + 0]))

    if isodd(length(x)) # even number of subintervals
        i == lastindex(x) && return (x[end] - x[end - 2]) / 6 *
            (2 - (x[end - 1] - x[end - 2]) / (x[end] - x[end - 1]))
    else # odd number of subintervals, we add additional terms
        i == lastindex(x) && return (x[end] - x[end - 1]) *
            (2 * (x[end] - x[end - 1]) + 3 * (x[end - 1] - x[end - 2])) /
            (x[end] - x[end - 2]) / 6
        i == lastindex(x) - 1 && return (x[end - 1] - x[end - 3]) / 6 *
            (2 - (x[end - 2] - x[end - 3]) / (x[end - 1] - x[end - 2])) +
            (x[end] - x[end - 1]) *
            ((x[end] - x[end - 1]) + 3 * (x[end - 1] - x[end - 2])) /
            (x[end - 1] - x[end - 2]) / 6
        i == lastindex(x) - 2 &&
            return (x[end - 1] - x[end - 3])^3 / (x[end - 2] - x[end - 3]) /
            (x[end - 1] - x[end - 2]) / 6 -
            (x[end] - x[end - 1])^3 / (x[end - 1] - x[end - 2]) /
            (x[end] - x[end - 2]) / 6
    end
    isodd(j) &&
        return (x[begin + j + 1] - x[begin + j - 1])^3 / (x[begin + j] - x[begin + j - 1]) /
        (x[begin + j + 1] - x[begin + j]) / 6
    return iseven(j) &&
        return (x[begin + j] - x[begin + j - 2]) / 6 *
        (
        2 -
            (x[begin + j - 1] - x[begin + j - 2]) / (x[begin + j] - x[begin + j - 1])
    ) +
        (x[begin + j + 2] - x[begin + j]) / 6 *
        (
        2 -
            (x[begin + j + 2] - x[begin + j + 1]) / (x[begin + j + 1] - x[begin + j])
    )
end

function find_weights(x::AbstractVector, ::SimpsonsRule)
    x isa AbstractRange && return SimpsonUniformWeights(length(x), step(x))
    return SimpsonNonuniformWeights(x)
end

using Integrals, Test

reltol = 1.0e-6
abstol = 1.0e-6

@testset "Alternative Infinity Transformations" begin
    @testset "transformation_tan_inf" begin
        # Test doubly-infinite integral: ∫_{-∞}^{∞} exp(-x²) dx = √π
        f_gaussian = (x, p) -> exp(-x^2)
        prob = IntegralProblem(f_gaussian, (-Inf, Inf))
        alg = ChangeOfVariables(transformation_tan_inf, QuadGKJL())
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, sqrt(π), rtol = 1.0e-5)

        # Test Lorentzian: ∫_{-∞}^{∞} 1/(1+x²) dx = π
        f_lorentz = (x, p) -> 1 / (1 + x^2)
        prob = IntegralProblem(f_lorentz, (-Inf, Inf))
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, π, rtol = 1.0e-5)

        # Test semi-infinite upper: ∫_0^{∞} exp(-x) dx = 1
        f_exp = (x, p) -> exp(-x)
        prob = IntegralProblem(f_exp, (0.0, Inf))
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, 1.0, rtol = 1.0e-4)

        # Test semi-infinite lower: ∫_{-∞}^0 exp(x) dx = 1
        f_exp_neg = (x, p) -> exp(x)
        prob = IntegralProblem(f_exp_neg, (-Inf, 0.0))
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, 1.0, rtol = 1.0e-4)

        # Test semi-infinite with non-zero bound: ∫_2^{∞} 1/((x-2)² + 1) dx = π/2
        f_shifted_lorentz = (x, p) -> 1 / ((x - 2)^2 + 1)
        prob = IntegralProblem(f_shifted_lorentz, (2.0, Inf))
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, π / 2, rtol = 1.0e-4)

        # Test with negative semi-infinite bound: ∫_{-∞}^{-1} exp(x) dx = exp(-1)
        f_exp_shifted = (x, p) -> exp(x)
        prob = IntegralProblem(f_exp_shifted, (-Inf, -1.0))
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, exp(-1), rtol = 1.0e-4)
    end

    @testset "transformation_cot_inf" begin
        # Test doubly-infinite integral: ∫_{-∞}^{∞} exp(-x²) dx = √π
        f_gaussian = (x, p) -> exp(-x^2)
        prob = IntegralProblem(f_gaussian, (-Inf, Inf))
        alg = ChangeOfVariables(transformation_cot_inf, QuadGKJL())
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, sqrt(π), rtol = 1.0e-5)

        # Test semi-infinite upper: ∫_0^{∞} exp(-x) dx = 1
        f_exp = (x, p) -> exp(-x)
        prob = IntegralProblem(f_exp, (0.0, Inf))
        sol = solve(prob, alg; reltol = 1.0e-4, abstol = 1.0e-4)
        @test isapprox(sol.u, 1.0, rtol = 1.0e-3)

        # Test semi-infinite lower: ∫_{-∞}^0 exp(x) dx = 1
        f_exp_neg = (x, p) -> exp(x)
        prob = IntegralProblem(f_exp_neg, (-Inf, 0.0))
        sol = solve(prob, alg; reltol = 1.0e-4, abstol = 1.0e-4)
        @test isapprox(sol.u, 1.0, rtol = 1.0e-3)

        # Test half Gaussian: ∫_0^{∞} exp(-x²) dx = √π/2
        prob = IntegralProblem(f_gaussian, (0.0, Inf))
        sol = solve(prob, alg; reltol = 1.0e-4, abstol = 1.0e-4)
        @test isapprox(sol.u, sqrt(π) / 2, rtol = 1.0e-3)
    end

    @testset "Finite domains unchanged" begin
        # Finite domains should work the same with all transformations
        f = (x, p) -> x^2
        prob = IntegralProblem(f, (0.0, 1.0))

        sol_default = solve(prob, QuadGKJL(); reltol, abstol)
        sol_tan = solve(
            prob, ChangeOfVariables(transformation_tan_inf, QuadGKJL());
            reltol, abstol
        )
        sol_cot = solve(
            prob, ChangeOfVariables(transformation_cot_inf, QuadGKJL());
            reltol, abstol
        )

        @test isapprox(sol_default.u, 1 / 3, rtol = 1.0e-8)
        @test isapprox(sol_tan.u, 1 / 3, rtol = 1.0e-8)
        @test isapprox(sol_cot.u, 1 / 3, rtol = 1.0e-8)
    end

    @testset "Flipped infinite limits" begin
        # Test with flipped bounds (negative orientation)
        f = (x, p) -> exp(-x^2)

        # ∫_{∞}^{-∞} exp(-x²) dx = -√π
        prob = IntegralProblem(f, (Inf, -Inf))
        alg = ChangeOfVariables(transformation_tan_inf, QuadGKJL())
        sol = solve(prob, alg; reltol, abstol)
        @test isapprox(sol.u, -sqrt(π), rtol = 1.0e-5)
    end

    @testset "Works with different algorithms" begin
        f = (x, p) -> exp(-x^2)
        prob = IntegralProblem(f, (-Inf, Inf))

        # Test with HCubatureJL
        alg_hcub = ChangeOfVariables(transformation_tan_inf, HCubatureJL())
        sol = solve(prob, alg_hcub; reltol, abstol)
        @test isapprox(sol.u, sqrt(π), rtol = 1.0e-4)
    end

    @testset "ChangeOfVariables exported" begin
        # Verify ChangeOfVariables is exported and accessible
        @test ChangeOfVariables isa UnionAll  # Has type parameters
        @test transformation_if_inf isa Function
        @test transformation_tan_inf isa Function
        @test transformation_cot_inf isa Function
    end
end

using Integrals
using Cuba, Cubature, Arblib, FastGaussQuadrature, FastTanhSinhQuadrature, MCIntegration
using Test

max_dim_test = 2
max_nout_test = 2
reltol = 1.0e-5
abstol = 1.0e-5

alg_req = Dict(
    QuadGKJL() => (
        nout = Inf, allows_batch = true, min_dim = 1, max_dim = 1,
        allows_iip = true,
    ),
    QuadratureRule(
        gausslegendre,
        n = 50
    ) => (
        nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
        allows_iip = false,
    ),
    GaussLegendre() => (
        nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
        allows_iip = false,
    ),
    HCubatureJL() => (
        nout = Inf, allows_batch = false, min_dim = 1,
        max_dim = Inf, allows_iip = true,
    ),
    VEGAS(seed = 109) => (
        nout = 1, allows_batch = true, min_dim = 2, max_dim = Inf,
        allows_iip = true,
    ),
    VEGASMC(seed = 42) => (
        nout = Inf, allows_batch = false, min_dim = 1, max_dim = Inf,
        allows_iip = true,
    ),
    CubatureJLh() => (
        nout = Inf, allows_batch = true, min_dim = 1,
        max_dim = Inf, allows_iip = true,
    ),
    CubatureJLp() => (
        nout = Inf, allows_batch = true, min_dim = 1,
        max_dim = Inf, allows_iip = true,
    ),
    CubaVegas() => (
        nout = Inf, allows_batch = true, min_dim = 1, max_dim = Inf,
        allows_iip = true,
    ),
    CubaSUAVE() => (
        nout = Inf, allows_batch = true, min_dim = 1, max_dim = Inf,
        allows_iip = true,
    ),
    CubaDivonne() => (
        nout = Inf, allows_batch = true, min_dim = 2,
        max_dim = Inf, allows_iip = true,
    ),
    CubaCuhre() => (
        nout = Inf, allows_batch = true, min_dim = 2, max_dim = Inf,
        allows_iip = true,
    ),
    ArblibJL() => (
        nout = 1, allows_batch = false, min_dim = 1, max_dim = 1, allows_iip = false,
    ),
    FastTanhSinhQuadratureJL() => (
        nout = 0, allows_batch = false, min_dim = 1, max_dim = 3, allows_iip = false,
    )
)

integrands = [
    (x, p) -> 1.0,
    (x, p) -> x isa Number ? cos(x) : prod(cos.(x)),
]
iip_integrands = [(dx, x, p) -> (dx .= f(x, p)) for f in integrands]

integrands_v = [
    (x, p, nout) -> collect(1.0:nout)
    let f = integrands[2]
        (x, p, nout) -> f(x, p) * collect(1.0:nout)
    end
]
iip_integrands_v = [(dx, x, p, nout) -> (dx .= f(x, p, nout)) for f in integrands_v]

exact_sol = [
    (ndim, nout, lb, ub) -> prod(ub - lb),
    (ndim, nout, lb, ub) -> prod(sin.(ub) - sin.(lb)),
]

exact_sol_v = [
    (ndim, nout, lb, ub) -> prod(ub - lb) * collect(1.0:nout),
    (ndim, nout, lb, ub) -> exact_sol[2](ndim, nout, lb, ub) * collect(1:nout),
]

batch_f(f) = (pts, p) -> begin
    fevals = zeros(size(pts, ndims(pts)))
    for i in axes(pts, ndims(pts))
        x = pts isa Vector ? pts[i] : pts[:, i]
        fevals[i] = f(x, p)
    end
    fevals
end

batch_iip_f(f) = (fevals, pts, p) -> begin
    ax = axes(pts)
    for i in ax[end]
        x = pts[ax[begin:(end - 1)]..., i]
        fevals[i] = f(x, p)
    end
    nothing
end

batch_f_v(f, nout) = (pts, p) -> begin
    fevals = zeros(nout, size(pts, ndims(pts)))
    for i in axes(pts, ndims(pts))
        x = pts isa Vector ? pts[i] : pts[:, i]
        fevals[:, i] .= f(x, p, nout)
    end
    fevals
end

batch_iip_f_v(f, nout) = (fevals, pts, p) -> begin
    for i in axes(pts, ndims(pts))
        x = pts isa Vector ? pts[i] : pts[:, i]
        fevals[:, i] .= f(x, p, nout)
    end
    return
end

@testset "Standard Single Dimension Integrands" begin
    lb, ub = (1.0, 3.0)
    nout = 1
    dim = 1
    for (alg, req) in pairs(alg_req)
        if req.min_dim > 1
            continue
        end
        for i in 1:length(integrands)
            prob = IntegralProblem(integrands[i], (lb, ub))
            @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
            sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
            @test sol.alg == alg
            @test sol.u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
        end
    end
end

@testset "Standard Integrands" begin
    nout = 1
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands)
            for dim in 1:max_dim_test
                lb, ub = (ones(dim), 3ones(dim))
                prob = IntegralProblem(integrands[i], (lb, ub))
                if dim > req.max_dim || dim < req.min_dim
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                @test sol.u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
            end
        end
    end
end

@testset "In-place Standard Integrands" begin
    nout = 1
    for (alg, req) in pairs(alg_req)
        for i in 1:length(iip_integrands)
            for dim in 1:max_dim_test
                lb, ub = (ones(dim), 3ones(dim))
                prob = IntegralProblem(iip_integrands[i], (lb, ub))
                if dim > req.max_dim || dim < req.min_dim || !req.allows_iip
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                if sol.u isa Number
                    @test sol.u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
                else
                    @test sol.u ≈ [exact_sol[i](dim, nout, lb, ub)] rtol = 1.0e-2
                end
            end
        end
    end
end

@testset "Batched Single Dimension Integrands" begin
    (lb, ub) = (1.0, 3.0)
    (dim, nout) = (1, 1)
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands)
            prob = IntegralProblem(BatchIntegralFunction(batch_f(integrands[i])), (lb, ub))
            if req.min_dim > 1 || !req.allows_batch
                continue
            end
            @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
            sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
            @test sol.alg == alg
            @test sol.u[1] ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
        end
    end
end

@testset "Batched Standard Integrands" begin
    nout = 1
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands)
            for dim in 1:max_dim_test
                (lb, ub) = (ones(dim), 3ones(dim))
                prob = IntegralProblem(
                    BatchIntegralFunction(batch_f(integrands[i])), (
                        lb, ub,
                    )
                )
                if dim > req.max_dim || dim < req.min_dim || !req.allows_batch
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                if sol.u isa Number
                    @test sol.u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
                else
                    @test sol.u ≈ [exact_sol[i](dim, nout, lb, ub)] rtol = 1.0e-2
                end
            end
        end
    end
end

@testset "In-Place Batched Standard Integrands" begin
    nout = 1
    for (alg, req) in pairs(alg_req)
        for i in 1:length(iip_integrands)
            for dim in 1:max_dim_test
                (lb, ub) = (ones(dim), 3ones(dim))
                prob = IntegralProblem(
                    BatchIntegralFunction(batch_iip_f(integrands[i]), zeros(0), max_batch = 1000),
                    (lb, ub)
                )
                if dim > req.max_dim || dim < req.min_dim || !req.allows_batch ||
                        !req.allows_iip
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                if sol.u isa Number
                    @test sol.u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
                else
                    @test sol.u ≈ [exact_sol[i](dim, nout, lb, ub)] rtol = 1.0e-2
                end
            end
        end
    end
end

######## Vector Valued Integrands
@testset "Standard Single Dimension Vector Integrands" begin
    lb, ub = (1.0, 3.0)
    dim = 1
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands_v)
            for nout in 1:max_nout_test
                integrand_f = let f = integrands_v[i], nout = nout
                    IntegralFunction((x, p) -> f(x, p, nout), zeros(nout))
                end
                prob = IntegralProblem(integrand_f, (lb, ub))
                if req.min_dim > 1 || req.nout < nout
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                if nout == 1
                    @test sol.u[1] ≈ exact_sol_v[i](dim, nout, lb, ub)[1] rtol = 1.0e-2
                else
                    @test sol.u ≈ exact_sol_v[i](dim, nout, lb, ub) rtol = 1.0e-2
                end
            end
        end
    end
end

@testset "Standard Vector Integrands" begin
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands_v)
            for dim in 1:max_dim_test
                lb, ub = (ones(dim), 3ones(dim))
                for nout in 1:max_nout_test
                    if dim > req.max_dim || dim < req.min_dim || req.nout < nout
                        continue
                    end
                    integrand_f = let f = integrands_v[i], nout = nout
                        IntegralFunction((x, p) -> f(x, p, nout), zeros(nout))
                    end
                    prob = IntegralProblem(integrand_f, (lb, ub))
                    @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                    sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                    @test sol.alg == alg
                    if nout == 1
                        @test sol.u[1] ≈ exact_sol_v[i](dim, nout, lb, ub)[1] rtol = 1.0e-2
                    else
                        @test sol.u ≈ exact_sol_v[i](dim, nout, lb, ub) rtol = 1.0e-2
                    end
                end
            end
        end
    end
end

@testset "In-place Standard Vector Integrands" begin
    for (alg, req) in pairs(alg_req)
        for i in 1:length(iip_integrands_v)
            for dim in 1:max_dim_test
                lb, ub = (ones(dim), 3ones(dim))
                for nout in 1:max_nout_test
                    integrand_f = let f = iip_integrands_v[i]
                        IntegralFunction((dx, x, p) -> f(dx, x, p, nout), zeros(nout))
                    end
                    prob = IntegralProblem(integrand_f, (lb, ub))
                    if dim > req.max_dim || dim < req.min_dim || req.nout < nout ||
                            !req.allows_iip
                        continue
                    end
                    @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                    sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                    @test sol.alg == alg
                    if nout == 1
                        @test sol.u[1] ≈ exact_sol_v[i](dim, nout, lb, ub)[1] rtol = 1.0e-2
                    else
                        @test sol.u ≈ exact_sol_v[i](dim, nout, lb, ub) rtol = 1.0e-2
                    end
                end
            end
        end
    end
end

@testset "Batched Single Dimension Vector Integrands" begin
    (lb, ub) = (1.0, 3.0)
    (dim, nout) = (1, 2)
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands_v)
            prob = IntegralProblem(
                BatchIntegralFunction(batch_f_v(integrands_v[i], nout)), (
                    lb, ub,
                )
            )
            if req.min_dim > 1 || !req.allows_batch || req.nout < nout
                continue
            end
            @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
            sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
            @test sol.alg == alg
            @test sol.u ≈ exact_sol_v[i](dim, nout, lb, ub) rtol = 1.0e-2
        end
    end
end

@testset "Batched Standard Vector Integrands" begin
    nout = 2
    for (alg, req) in pairs(alg_req)
        for i in 1:length(integrands_v)
            for dim in 1:max_dim_test
                (lb, ub) = (ones(dim), 3ones(dim))
                prob = IntegralProblem(
                    BatchIntegralFunction(batch_f_v(integrands_v[i], nout)), (
                        lb, ub,
                    )
                )
                if dim > req.max_dim || dim < req.min_dim || !req.allows_batch ||
                        req.nout < nout
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                @test sol.u ≈ exact_sol_v[i](dim, nout, lb, ub) rtol = 1.0e-2
            end
        end
    end
end

@testset "In-Place Batched Standard Vector Integrands" begin
    nout = 2
    for (alg, req) in pairs(alg_req)
        for i in 1:length(iip_integrands_v)
            for dim in 1:max_dim_test
                (lb, ub) = (ones(dim), 3ones(dim))
                prob = IntegralProblem(
                    BatchIntegralFunction(batch_iip_f_v(integrands_v[i], nout), zeros(nout, 0)),
                    (lb, ub)
                )
                if dim > req.max_dim || dim < req.min_dim || !req.allows_batch ||
                        !req.allows_iip || req.nout < nout
                    continue
                end
                @info "Alg = $(nameof(typeof(alg))), Integrand = $i, Dimension = $dim, Output Dimension = $nout"
                sol = @inferred solve(prob, alg, reltol = reltol, abstol = abstol)
                @test sol.alg == alg
                @test sol.u ≈ exact_sol_v[i](dim, nout, lb, ub) rtol = 1.0e-2
            end
        end
    end
end

@testset "Allowed keyword test" begin
    f(u, p) = sum(sin.(u))
    prob = IntegralProblem(f, (ones(3), 3ones(3)))
    @test_throws Integrals.CommonKwargError((:relztol => 1.0e-3, :abstol => 1.0e-3)) solve(
        prob,
        HCubatureJL();
        relztol = 1.0e-3,
        abstol = 1.0e-3
    )
end

@testset "Caching interface" begin
    lb, ub = (1.0, 3.0)
    p = NaN # the integrands don't actually use this
    nout = 1
    dim = 1
    for (alg, req) in pairs(alg_req)
        if req.min_dim > 1
            continue
        end
        for i in 1:length(integrands)
            prob = IntegralProblem(integrands[i], (lb, ub), p)
            cache = init(prob, alg, reltol = reltol, abstol = abstol)
            @test solve!(cache).u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
            lb = 0.5
            cache.domain = (lb, ub)
            @test solve!(cache).u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
            ub = 3.5
            cache.domain = (lb, ub)
            @test solve!(cache).u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
            cache.p = Inf
            @test solve!(cache).u ≈ exact_sol[i](dim, nout, lb, ub) rtol = 1.0e-2
        end
    end
end

@testset "issue242" begin
    f242(x, p) = p / (x^2 + p^2)
    domain242 = (-1, 1)
    p242 = 1.0e-3
    for abstol in [1.0e-2, 1.0e-4, 1.0e-6, 1.0e-8]
        @test solve(IntegralProblem(f242, domain242, p242; abstol), QuadGKJL()).u ==
            solve(IntegralProblem(f242, domain242, p242), QuadGKJL(); abstol).u
    end
end

@testset "Numeric Type Interface" begin
    @testset "BigFloat support" begin
        # Test QuadGKJL with BigFloat bounds
        f_bf = (x, p) -> sin(x)
        lb_bf = BigFloat("0.0")
        ub_bf = BigFloat("1.0")
        prob_bf = IntegralProblem(f_bf, (lb_bf, ub_bf))
        sol_bf = solve(prob_bf, QuadGKJL())
        expected_bf = 1 - cos(BigFloat(1))
        @test sol_bf.u isa BigFloat
        @test sol_bf.u ≈ expected_bf rtol = 1.0e-10

        # Test HCubatureJL with BigFloat scalar bounds
        sol_hc_bf = solve(prob_bf, HCubatureJL())
        @test sol_hc_bf.u isa BigFloat
        @test sol_hc_bf.u ≈ expected_bf rtol = 1.0e-10

        # Test HCubatureJL with BigFloat vector bounds
        f_bf_2d = (x, p) -> sin(x[1]) * cos(x[2])
        lb_bf_2d = BigFloat[0, 0]
        ub_bf_2d = BigFloat[1, 1]
        prob_bf_2d = IntegralProblem(f_bf_2d, (lb_bf_2d, ub_bf_2d))
        sol_bf_2d = solve(prob_bf_2d, HCubatureJL())
        @test sol_bf_2d.u isa BigFloat

        # Test SampledIntegralProblem with BigFloat
        x_bf = range(BigFloat("0.0"), BigFloat("1.0"), length = 11)
        y_bf = sin.(x_bf)
        prob_sampled_bf = SampledIntegralProblem(y_bf, x_bf)
        sol_sampled_bf = solve(prob_sampled_bf, TrapezoidalRule())
        @test sol_sampled_bf.u isa BigFloat
        @test eltype(x_bf) == BigFloat
        @test eltype(y_bf) == BigFloat

        # Test SimpsonsRule with BigFloat
        sol_simpson_bf = solve(prob_sampled_bf, SimpsonsRule())
        @test sol_simpson_bf.u isa BigFloat

        # Test BigFloat matrix for vector-valued sampled integration
        y_bf_matrix = BigFloat[sin(xi) * j for j in 1:3, xi in x_bf]
        prob_sampled_bf_2d = SampledIntegralProblem(y_bf_matrix, x_bf; dim = 2)
        sol_sampled_bf_2d = solve(prob_sampled_bf_2d, TrapezoidalRule())
        @test eltype(sol_sampled_bf_2d.u) == BigFloat
    end

    @testset "Complex number support" begin
        # Test SampledIntegralProblem with Complex numbers
        x_c = range(0.0, 1.0, length = 11)
        y_c = complex.(sin.(x_c), cos.(x_c))
        prob_c = SampledIntegralProblem(y_c, x_c)
        sol_c = solve(prob_c, TrapezoidalRule())
        @test sol_c.u isa Complex
        @test real(sol_c.u) > 0
        @test imag(sol_c.u) > 0

        # Test QuadGKJL with complex-valued integrand
        f_c = (x, p) -> exp(im * x)
        prob_quadgk_c = IntegralProblem(f_c, (0.0, 1.0))
        sol_quadgk_c = solve(prob_quadgk_c, QuadGKJL())
        expected_c = (exp(im) - 1) / im
        @test sol_quadgk_c.u isa Complex
        @test sol_quadgk_c.u ≈ expected_c rtol = 1.0e-8
    end

    @testset "Float32 type preservation" begin
        # Test SampledIntegralProblem preserves Float32
        x_f32 = range(0.0f0, 1.0f0, length = 11)
        y_f32 = sin.(x_f32)
        prob_f32 = SampledIntegralProblem(y_f32, x_f32)
        sol_f32 = solve(prob_f32, TrapezoidalRule())
        @test sol_f32.u isa Float32

        # Test Float32 matrix
        y_f32_matrix = Float32[sin(xi) * j for j in 1:3, xi in x_f32]
        prob_f32_2d = SampledIntegralProblem(y_f32_matrix, x_f32; dim = 2)
        sol_f32_2d = solve(prob_f32_2d, TrapezoidalRule())
        @test eltype(sol_f32_2d.u) == Float32
    end

    @testset "SubArray support" begin
        # Test that views/SubArrays work correctly
        x_full = range(0.0, 1.0, length = 11)
        y_full = sin.(x_full)
        y_view = @view y_full[:]
        prob_view = SampledIntegralProblem(y_view, x_full)
        sol_view = solve(prob_view, TrapezoidalRule())
        prob_regular = SampledIntegralProblem(y_full, x_full)
        sol_regular = solve(prob_regular, TrapezoidalRule())
        @test sol_view.u ≈ sol_regular.u
    end
end

# generic change of variables code

function substitute_u(u2v, lb, ub)
    bounds = map(u2v, lb, ub)
    lb_sub = lb isa Number ? first(bounds) : map(first, bounds)
    ub_sub = ub isa Number ? last(bounds) : map(last, bounds)
    return (lb_sub, ub_sub)
end

# without batching point container type should match the inputs
substitute_v(v2ujac, v, lb::Number, ub::Number) = v2ujac(only(v), lb, ub)
function substitute_v(v2ujac, v, lb::AbstractVector, ub::AbstractVector)
    xjac = map((l, u, v) -> v2ujac(v, l, u), lb, ub, v) # ordering may influence container type
    x = map(first, xjac)
    jac = prod(last, xjac)
    return x, jac
end

function substitute_f(f::IntegralFunction{false}, v2ujac, lb, ub)
    _f = f.f
    return IntegralFunction{false}(f.integrand_prototype) do v, p
        u, jac = substitute_v(v2ujac, v, lb, ub)
        return _f(u, p) * jac
    end
end
function substitute_f(f::IntegralFunction{true}, v2ujac, lb, ub)
    _f = f.f
    prototype = similar(f.integrand_prototype)
    vol = prod((ub - lb) / 2) # just to get the type of the jacobian determinant
    return IntegralFunction{true}(prototype * vol) do y, v, p
        u, jac = substitute_v(v2ujac, v, lb, ub)
        _y = _evaluate!(_f, prototype, u, p)
        y .= _y .* jac
        return
    end
end

# with batching the point container type is assumed to be mutable
function substitute_bv(v2ujac, v::AbstractArray, lb::Number, ub::Number)
    x = similar(v, typeof(one(eltype(v)) * (first(lb) + first(ub))))
    jac = similar(x)
    for i in axes(v, 1)
        x[i], jac[i] = v2ujac(v[i], lb, ub)
    end
    return x, jac
end
function substitute_bv(v2ujac, v::AbstractArray, lb::AbstractVector, ub::AbstractVector)
    x = similar(v, typeof(one(eltype(v)) * (first(lb) + first(ub))))
    jac = similar(v, typeof(zero(eltype(v)) * prod(lb)), size(v)[end])
    idx = CartesianIndices(axes(v)[begin:(end - 1)])
    for i in axes(v)[end]
        _jac = one(eltype(jac))
        for (ii, l, u) in zip(idx, lb, ub)
            x[ii, i], j = v2ujac(v[ii, i], l, u)
            _jac *= j
        end
        jac[i] = _jac
    end
    return x, jac
end

function substitute_f(f::BatchIntegralFunction{false}, v2ujac, lb, ub)
    _f = f.f
    return BatchIntegralFunction{false}(f.integrand_prototype, max_batch = f.max_batch) do v, p
        u, jac = substitute_bv(v2ujac, v, lb, ub)
        y = _f(u, p)
        return y .* reshape(jac, ntuple(d -> d == ndims(y) ? length(jac) : 1, ndims(y)))
    end
end
function substitute_f(f::BatchIntegralFunction{true}, v2ujac, lb, ub)
    _f = f.f
    prototype = similar(f.integrand_prototype)
    vol = prod((ub - lb) / 2) # just to get the type of the jacobian determinant
    return BatchIntegralFunction{true}(prototype * vol, max_batch = f.max_batch) do y, v, p
        u, jac = substitute_bv(v2ujac, v, lb, ub)
        _prototype = similar(prototype, size(y))
        _y = _evaluate!(_f, _prototype, u, p)
        y .= _y .* reshape(jac, ntuple(d -> d == ndims(y) ? length(jac) : 1, ndims(y)))
        return
    end
end

# we need this function for autodiff compatibility where internal buffers need special types
function _evaluate!(f, y, u, p)
    f(y, u, p)
    return y
end

# specific changes of variables

function u2t(lb, ub)
    mid = (lb + ub) / 2 # floating-point promotion
    if isinf(lb) && isinf(ub)
        lb_sub = flipsign(one(mid), lb)
        ub_sub = flipsign(one(mid), ub)
    elseif isinf(lb)
        lb_sub = flipsign(one(mid), lb)
        ub_sub = zero(one(mid))
    elseif isinf(ub)
        lb_sub = zero(one(mid))
        ub_sub = flipsign(one(mid), ub)
    else
        lb_sub = -one(mid)
        ub_sub = one(mid)
    end
    return lb_sub, ub_sub # unitless
end

function t2ujac(t::Number, lb::Number, ub::Number)
    u = oneunit(eltype(lb))
    # apply correct units
    return if isinf(lb) && isinf(ub)
        den = inv(1 - t^2)
        t * den * u, (1 + t^2) * den^2 * u
    elseif isinf(lb)
        den = inv(1 - flipsign(t, lb))
        ub + t * den * u, den^2 * u
    elseif isinf(ub)
        den = inv(1 - flipsign(t, ub))
        lb + t * den * u, den^2 * u
    else
        den = (ub - lb) * oftype(float(one(u)), 0.5)
        lb + (1 + t) * den, den
    end
end

"""
    transformation_if_inf(f, domain)

Default infinity transformation using rational functions. Maps infinite domains to finite
intervals using the following substitutions:

  - For doubly-infinite domains `(-∞, ∞)`: `u = t/(1-t²)`, so `∫_{-∞}^{∞} f(u) du = ∫_{-1}^{1} f(t/(1-t²)) (1+t²)/(1-t²)² dt`
  - For semi-infinite domains `[a, ∞)`: `u = a + t/(1-t)`, so `∫_a^∞ f(u) du = ∫_0^1 f(a+t/(1-t)) 1/(1-t)² dt`
  - For semi-infinite domains `(-∞, b]`: `u = b + t/(1+t)`, so `∫_{-∞}^b f(u) du = ∫_{-1}^0 f(b+t/(1+t)) 1/(1+t)² dt`

This is the default transformation applied by algorithms like `QuadGKJL` and `HCubatureJL`
when encountering infinite integration bounds.

## Arguments

  - `f`: `IntegralFunction` or `BatchIntegralFunction` to transform.
  - `domain`: Original integration domain, usually `(lb, ub)`.

## Returns

Returns `(g, tdomain)`, where `g` is the transformed integrand and `tdomain` is the
finite transformed domain.

## Example

```julia
using Integrals

f(x, p) = exp(-x^2)
prob = IntegralProblem(f, (-Inf, Inf))

# Explicitly use the default transformation
alg = ChangeOfVariables(transformation_if_inf, QuadGKJL())
sol = solve(prob, alg)
```

See also: [`transformation_tan_inf`](@ref), [`transformation_cot_inf`](@ref), [`ChangeOfVariables`](@ref)
"""
function transformation_if_inf(f, domain)
    lb, ub = promote(domain...)
    tdomain = substitute_u(u2t, lb, ub)
    g = substitute_f(f, t2ujac, lb, ub)
    return g, tdomain
end

# to implement more transformations, define functions u2v and v2ujac and then a wrapper
# similar to transformation_if_inf to pass to ChangeOfVariables

# Alternative transformation using arctan for doubly-infinite domains
# This uses t = (2/π) * arctan(u), giving u = tan(πt/2)
# ∫_{-∞}^{∞} f(u) du = (π/2) ∫_{-1}^{1} sec²(πt/2) f(tan(πt/2)) dt
#
# For semi-infinite domains [a, ∞), we use u = a + tan(π(t+1)/4) mapping [−1, 1] → [a, ∞)
# For semi-infinite domains (−∞, b], we use u = b − tan(π(1−t)/4) mapping [−1, 1] → (−∞, b]

function u2t_tan(lb, ub)
    mid = (lb + ub) / 2 # floating-point promotion
    # All cases map to [-1, 1]
    if isinf(lb) && isinf(ub)
        lb_sub = flipsign(one(mid), lb)
        ub_sub = flipsign(one(mid), ub)
    elseif isinf(lb)
        lb_sub = flipsign(one(mid), lb)
        ub_sub = zero(one(mid))
    elseif isinf(ub)
        lb_sub = zero(one(mid))
        ub_sub = flipsign(one(mid), ub)
    else
        lb_sub = -one(mid)
        ub_sub = one(mid)
    end
    return lb_sub, ub_sub
end

function t2ujac_tan(t::Number, lb::Number, ub::Number)
    u = oneunit(eltype(lb))
    return if isinf(lb) && isinf(ub)
        # Doubly-infinite: t ∈ [-1, 1] → u ∈ (-∞, ∞)
        # u = tan(πt/2), du/dt = (π/2) sec²(πt/2)
        halfpi = oftype(float(one(u)), π / 2)
        arg = halfpi * t
        tan_val = tan(arg)
        sec2 = 1 + tan_val^2  # sec² = 1 + tan²
        tan_val * u, halfpi * sec2 * u
    elseif isinf(lb)
        # Lower infinite: t ∈ [-1, 0] → u ∈ (-∞, ub] (when lb = -Inf)
        # or t ∈ [0, 1] → u ∈ (ub, ∞) (when lb = +Inf, flipped)
        # Use u = ub + tan(π*t/2), mapping:
        # t = 0 → u = ub + tan(0) = ub
        # t = -1 → u = ub + tan(-π/2) = -∞
        halfpi = oftype(float(one(u)), π / 2)
        arg = halfpi * t
        tan_val = tan(arg)
        sec2 = 1 + tan_val^2
        ub + tan_val * u, halfpi * sec2 * u
    elseif isinf(ub)
        # Upper infinite: t ∈ [0, 1] → u ∈ [lb, ∞) (when ub = +Inf)
        # or t ∈ [-1, 0] → u ∈ (-∞, lb] (when ub = -Inf, flipped)
        # Use u = lb + tan(π*t/2), mapping:
        # t = 0 → u = lb + tan(0) = lb
        # t = 1 → u = lb + tan(π/2) = ∞
        halfpi = oftype(float(one(u)), π / 2)
        arg = halfpi * t
        tan_val = tan(arg)
        sec2 = 1 + tan_val^2
        lb + tan_val * u, halfpi * sec2 * u
    else
        den = (ub - lb) * oftype(float(one(u)), 0.5)
        lb + (1 + t) * den, den
    end
end

"""
    transformation_tan_inf(f, domain)

Alternative infinity transformation using arctan/tan. Maps infinite domains to [-1, 1]
using the transformation:

  - For doubly-infinite domains: `u = tan(πt/2)`, so `∫_{-∞}^{∞} f(u) du = (π/2) ∫_{-1}^{1} sec²(πt/2) f(tan(πt/2)) dt`
  - For semi-infinite domains `[a, ∞)`: `u = a + tan(π(t+1)/4)`
  - For semi-infinite domains `(-∞, b]`: `u = b - tan(π(1-t)/4)`

This transformation can provide better accuracy than the default rational transformation
for some integrands, particularly those that decay like `1/(1+x²)`.

## Arguments

  - `f`: `IntegralFunction` or `BatchIntegralFunction` to transform.
  - `domain`: Original integration domain, usually `(lb, ub)`.

## Returns

Returns `(g, tdomain)`, where `g` is the transformed integrand and `tdomain` is the
finite transformed domain.

## Example

```julia
using Integrals

f(x, p) = 1 / (1 + x^2)  # Lorentzian
prob = IntegralProblem(f, (-Inf, Inf))

# Use tan transformation instead of default
alg = ChangeOfVariables(transformation_tan_inf, QuadGKJL())
sol = solve(prob, alg)
```

See also: [`transformation_if_inf`](@ref), [`transformation_cot_inf`](@ref), [`ChangeOfVariables`](@ref)
"""
function transformation_tan_inf(f, domain)
    lb, ub = promote(domain...)
    tdomain = substitute_u(u2t_tan, lb, ub)
    g = substitute_f(f, t2ujac_tan, lb, ub)
    return g, tdomain
end

# Alternative transformation using cotangent for semi-infinite domains
# Based on the transformations from Issue #149:
# For [a, ∞): s = -cot[(π - 2arctan(a))(ξ-1)/4], ξ ∈ [-1, 1]
# For (-∞, a]: s = -cot[(π + 2arctan(a))(ξ+1)/4], ξ ∈ [-1, 1]
#
# These give:
# ∫_a^∞ g(s)ds = (π - 2arctan(a))/4 ∫_{-1}^1 csc²[(π - 2arctan(a))(ξ-1)/4] g(...) dξ
# ∫_{-∞}^a g(s)ds = (π + 2arctan(a))/4 ∫_{-1}^1 csc²[(π + 2arctan(a))(ξ+1)/4] g(...) dξ

function u2t_cot(lb, ub)
    mid = (lb + ub) / 2 # floating-point promotion
    # All cases map to [-1, 1]
    if isinf(lb) && isinf(ub)
        lb_sub = flipsign(one(mid), lb)
        ub_sub = flipsign(one(mid), ub)
    elseif isinf(lb)
        lb_sub = flipsign(one(mid), lb)
        ub_sub = zero(one(mid))
    elseif isinf(ub)
        lb_sub = zero(one(mid))
        ub_sub = flipsign(one(mid), ub)
    else
        lb_sub = -one(mid)
        ub_sub = one(mid)
    end
    return lb_sub, ub_sub
end

function t2ujac_cot(t::Number, lb::Number, ub::Number)
    u = oneunit(eltype(lb))
    return if isinf(lb) && isinf(ub)
        # For doubly-infinite, use the tan transformation
        # u = tan(πt/2), du/dt = (π/2) sec²(πt/2)
        halfpi = oftype(float(one(u)), π / 2)
        arg = halfpi * t
        tan_val = tan(arg)
        sec2 = 1 + tan_val^2
        tan_val * u, halfpi * sec2 * u
    elseif isinf(lb)
        # Lower infinite: t ∈ [-1, 0] → u ∈ (-∞, ub]
        # Using cotangent transformation based on Issue #149:
        # u = -cot[(π + 2arctan(ub))(t+1)/4]
        # At t = -1: arg = 0, cot → ∞, u → -∞ ✓
        # At t = 0: arg = (π + 2arctan(ub))/4
        # For this to give u = ub at t = 0, we need to adjust
        # Instead, use simpler: u = ub + tan(πt/2) (same as tan transformation)
        # This falls back to tan for robustness
        halfpi = oftype(float(one(u)), π / 2)
        arg = halfpi * t
        tan_val = tan(arg)
        sec2 = 1 + tan_val^2
        ub + tan_val * u, halfpi * sec2 * u
    elseif isinf(ub)
        # Upper infinite: t ∈ [0, 1] → u ∈ [lb, ∞)
        # Using cotangent with scaling based on lb:
        # u = lb + cot[scale * (1 - t)]
        # At t = 0: arg = scale, cot(scale) = finite value
        # At t = 1: arg = 0, cot → ∞, u → ∞ ✓
        # We need u = lb at t = 0, so adjust: use cot approaching 0 as t→0
        # Use: u = lb + cot[π(1-t)/2] where cot(π/2) = 0
        # At t = 0: arg = π/2, cot(π/2) = 0, u = lb ✓
        # At t = 1: arg = 0, cot(0) → ∞, u → ∞ ✓
        halfpi = oftype(float(one(u)), π / 2)
        arg = halfpi * (1 - t)
        cot_val = cot(arg)
        csc2 = 1 + cot_val^2  # csc² = 1 + cot²
        # Jacobian: du/dt = csc²(arg) * π/2
        lb + cot_val * u, halfpi * csc2 * u
    else
        den = (ub - lb) * oftype(float(one(u)), 0.5)
        lb + (1 + t) * den, den
    end
end

"""
    transformation_cot_inf(f, domain)

Alternative infinity transformation using cotangent for semi-infinite domains.
Based on the transformations suggested in Issue #149:

  - For doubly-infinite domains: Uses tan transformation (same as `transformation_tan_inf`)
  - For semi-infinite domains: Uses cotangent-based transformations that can provide
    better accuracy for integrands with oscillations or singularities.

For `[a, ∞)`:

```math
s = \\cot\\left[\\frac{(\\pi - 2\\arctan(a))(1-\\xi)}{4}\\right] + a, \\quad \\xi \\in [-1, 1]
```

For `(-\\infty, a]`:

```math
s = -\\cot\\left[\\frac{(\\pi + 2\\arctan(a))(\\xi+1)}{4}\\right], \\quad \\xi \\in [-1, 1]
```

## Arguments

  - `f`: `IntegralFunction` or `BatchIntegralFunction` to transform.
  - `domain`: Original integration domain, usually `(lb, ub)`.

## Returns

Returns `(g, tdomain)`, where `g` is the transformed integrand and `tdomain` is the
finite transformed domain.

## Example

```julia
using Integrals

f(x, p) = exp(-x^2)  # Gaussian tail
prob = IntegralProblem(f, (0.0, Inf))

# Use cotangent transformation
alg = ChangeOfVariables(transformation_cot_inf, QuadGKJL())
sol = solve(prob, alg)
```

See also: [`transformation_if_inf`](@ref), [`transformation_tan_inf`](@ref), [`ChangeOfVariables`](@ref)
"""
function transformation_cot_inf(f, domain)
    lb, ub = promote(domain...)
    tdomain = substitute_u(u2t_cot, lb, ub)
    g = substitute_f(f, t2ujac_cot, lb, ub)
    return g, tdomain
end

module IntegralsFastTanhSinhQuadratureExt

using Integrals
import FastTanhSinhQuadrature
import FastTanhSinhQuadrature: quad

function Integrals.__solvebp_call(
        prob::IntegralProblem, alg::Integrals.FastTanhSinhQuadratureJL,
        sensealg, domain, p;
        reltol = nothing, abstol = nothing,
        maxiters = nothing,
        verbose = Integrals.DEFAULT_VERBOSE
    )
    lb, ub = domain
    f = prob.f

    @assert f isa IntegralFunction "FastTanhSinhQuadratureJL does not support BatchIntegralFunction"
    @assert !isinplace(prob) "FastTanhSinhQuadratureJL does not support in-place integrands"

    # Determine the effective tolerances
    _rtol = reltol !== nothing ? reltol : alg.rtol
    _atol = abstol !== nothing ? abstol : alg.atol
    max_levels = alg.max_levels

    # Determine dimensionality
    dim = lb isa Number ? 1 : length(lb)

    if dim == 1
        # 1D integration
        _lb = lb isa Number ? lb : only(lb)
        _ub = ub isa Number ? ub : only(ub)
        _f = x -> f.f(x, p)
        val = quad(_f, _lb, _ub; rtol = _rtol, atol = _atol, max_levels = max_levels)
    elseif dim == 2
        # 2D integration - use Vectors which quad() converts to SVector internally
        _lb = collect(lb)
        _ub = collect(ub)
        _f = (x, y) -> f.f([x, y], p)
        val = quad(_f, _lb, _ub; rtol = _rtol, atol = _atol, max_levels = max_levels)
    elseif dim == 3
        # 3D integration - use Vectors which quad() converts to SVector internally
        _lb = collect(lb)
        _ub = collect(ub)
        _f = (x, y, z) -> f.f([x, y, z], p)
        val = quad(_f, _lb, _ub; rtol = _rtol, atol = _atol, max_levels = max_levels)
    else
        error("FastTanhSinhQuadratureJL only supports 1D, 2D, and 3D integration. Got dimension = $dim")
    end

    err = nothing
    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end

end

pages = [
    "index.md",
    "Tutorials" => Any[
        "tutorials/numerical_integrals.md",
        "tutorials/differentiating_integrals.md",
        "tutorials/caching_interface.md",
        "tutorials/infinity_transforms.md",
    ],
    "Basics" => Any[
        "basics/IntegralProblem.md",
        "basics/IntegralFunction.md",
        "basics/SampledIntegralProblem.md",
        "basics/solve.md",
        "basics/verbosity.md",
        "basics/FAQ.md",
    ],
    "Solvers" => Any["solvers/IntegralSolvers.md"],
]

"""
    QuadGKJL(; order = 7, norm = norm, buffer = nothing)

One-dimensional adaptive Gauss-Kronrod integration from QuadGK.jl.

## Keyword Arguments

  - `order`: Order of the embedded Gauss-Kronrod rule. Higher values reduce the number
    of subintervals for smooth integrands and increase work per subinterval.
  - `norm`: Function used by QuadGK.jl to turn the integral estimate and error estimate
    into scalar convergence criteria. This is most useful for array-valued integrands.
  - `buffer`: If non-`nothing`, allocate and cache a QuadGK segment buffer during
    `init`. This avoids repeated buffer allocation when `solve!` is called on the same
    cache. Buffer construction may evaluate the integrand unless the problem supplies an
    `integrand_prototype`.

## Fields

  - `order::Int`: Stored quadrature rule order.
  - `norm`: Stored convergence norm.
  - `buffer`: Stored buffer option.

## Returns

Returns a `QuadGKJL` algorithm object for use with
`solve(prob::IntegralProblem, alg)`, `init`, and `solve!`.

## Example

```julia
using Integrals

prob = IntegralProblem((x, p) -> x^2, (0.0, 1.0))
sol = solve(prob, QuadGKJL(order = 9); reltol = 1e-10)
```

## References

```tex
@article{laurie1997calculation,
title={Calculation of Gauss-Kronrod quadrature rules},
author={Laurie, Dirk},
journal={Mathematics of Computation},
volume={66},
number={219},
pages={1133--1145},
year={1997}
}
```
"""
struct QuadGKJL{F, B} <: SciMLBase.AbstractIntegralAlgorithm
    order::Int
    norm::F
    buffer::B
end
QuadGKJL(; order = 7, norm = norm, buffer = nothing) = QuadGKJL(order, norm, buffer)

"""
    HCubatureJL(; norm=norm, initdiv=1, buffer = nothing)

Multidimensional h-adaptive integration from HCubature.jl.

## Keyword Arguments

  - `initdiv`: Initial number of segments used to divide each integration dimension.
  - `norm`: Function used by HCubature.jl to turn integral and error estimates into
    scalar convergence criteria. This is most useful for array-valued integrands.
  - `buffer`: If non-`nothing`, allocate and cache HCubature work buffers during
    `init`. The buffer is managed by Integrals.jl; callers should not pass an HCubature
    buffer directly.

## Fields

  - `initdiv::Int`: Stored initial subdivision count.
  - `norm`: Stored convergence norm.
  - `buffer`: Stored buffer option.

## Returns

Returns an `HCubatureJL` algorithm object for `IntegralProblem`s over scalar or vector
box domains.

## Example

```julia
using Integrals

f(x, p) = x[1]^2 + x[2]^2
prob = IntegralProblem(f, ([0.0, 0.0], [1.0, 1.0]))
sol = solve(prob, HCubatureJL(initdiv = 2))
```

## References

```tex
@article{genz1980remarks,
title={Remarks on algorithm 006: An adaptive algorithm for numerical integration over an N-dimensional rectangular region},
author={Genz, Alan C and Malik, Aftab Ahmad},
journal={Journal of Computational and Applied mathematics},
volume={6},
number={4},
pages={295--302},
year={1980},
publisher={Elsevier}
}
```
"""
struct HCubatureJL{F, B} <: SciMLBase.AbstractIntegralAlgorithm
    initdiv::Int
    norm::F
    buffer::B
end
function HCubatureJL(; initdiv = 1, norm = norm, buffer = nothing)
    return HCubatureJL(initdiv, norm, buffer)
end

"""
    VEGAS(; nbins = 100, ncalls = 1000, debug=false, seed = nothing)

Multidimensional adaptive Monte Carlo integration from MonteCarloIntegration.jl.
Importance sampling is used to reduce variance.

## Keyword Arguments

  - `nbins`: Initial number of bins used for each integration dimension.
  - `ncalls`: Number of integrand calls requested per Monte Carlo iteration.
  - `debug`: Whether to request debug output from MonteCarloIntegration.jl.
  - `seed`: Optional random seed passed to the underlying algorithm.

## Fields

  - `nbins::Int`: Stored bin count.
  - `ncalls::Int`: Stored calls-per-iteration target.
  - `debug::Bool`: Stored debug-output flag.
  - `seed`: Stored seed value.

## Returns

Returns a `VEGAS` algorithm object for multidimensional scalar Monte Carlo
integration.

## Example

```julia
using Integrals

f(x, p) = exp(-sum(abs2, x))
prob = IntegralProblem(f, (zeros(3), ones(3)))
sol = solve(prob, VEGAS(ncalls = 2_000); reltol = 1e-2)
```

## Limitations

This algorithm can only integrate scalar `Float64`-valued functions.

## References

```tex
@article{lepage1978new,
title={A new algorithm for adaptive multidimensional integration},
author={Lepage, G Peter},
journal={Journal of Computational Physics},
volume={27},
number={2},
pages={192--203},
year={1978},
publisher={Elsevier}
}
```
"""
struct VEGAS{S} <: SciMLBase.AbstractIntegralAlgorithm
    nbins::Int
    ncalls::Int
    debug::Bool
    seed::S
end
function VEGAS(; nbins = 100, ncalls = 1000, debug = false, seed = nothing)
    return VEGAS(nbins, ncalls, debug, seed)
end

"""
    GaussLegendre(; n = 250, subintervals = 1, nodes = nothing, weights = nothing)
    GaussLegendre(nodes, weights, subintervals = 1)

Fixed-order Gauss-Legendre quadrature, optionally applied on a composite partition of
the integration interval.

## Arguments

  - `nodes`: Quadrature nodes on the standard interval `[-1, 1]`.
  - `weights`: Quadrature weights corresponding to `nodes`.
  - `subintervals`: Number of equally sized subintervals used for composite
    Gauss-Legendre quadrature.

## Keyword Arguments

  - `n`: Number of quadrature nodes to construct when `nodes` or `weights` is
    `nothing`.
  - `subintervals`: Number of subintervals used for composite quadrature. Must be
    positive.
  - `nodes`: Optional precomputed nodes. If omitted, `gausslegendre(n)` is used.
  - `weights`: Optional precomputed weights. If omitted, `gausslegendre(n)` is used.

## Fields

  - `nodes`: Stored quadrature nodes.
  - `weights`: Stored quadrature weights.
  - `subintervals::Int64`: Stored number of subintervals.

The type parameter `C` is `true` when `subintervals > 1` and `false` otherwise.
Composite mode splits `[a, b]` into `subintervals` pieces and applies the same rule to
each piece.

## Returns

Returns a `GaussLegendre` algorithm object. `GaussLegendre(; n=...)` requires
FastGaussQuadrature.jl to be loaded so that the `gausslegendre` extension method is
available.

## Example

```julia
using Integrals, FastGaussQuadrature

prob = IntegralProblem((x, p) -> cos(x), (0.0, pi / 2))
sol = solve(prob, GaussLegendre(n = 64))
```
"""
struct GaussLegendre{C, N, W} <: SciMLBase.AbstractIntegralAlgorithm
    nodes::N
    weights::W
    subintervals::Int64
    function GaussLegendre(nodes::N, weights::W, subintervals = 1) where {N, W}
        if subintervals > 1
            return new{true, N, W}(nodes, weights, subintervals)
        elseif subintervals == 1
            return new{false, N, W}(nodes, weights, subintervals)
        else
            throw(ArgumentError("Cannot use a nonpositive number of subintervals."))
        end
    end
end
function gausslegendre end
function GaussLegendre(; n = 250, subintervals = 1, nodes = nothing, weights = nothing)
    if isnothing(nodes) || isnothing(weights)
        nodes, weights = gausslegendre(n)
    end
    return GaussLegendre(nodes, weights, subintervals)
end

"""
    QuadratureRule(q; n=250)

Evaluate a user-supplied fixed quadrature rule.

The rule function `q` must support `nodes, weights = q(n)` and return nodes and weights
for the standard interval or hypercube `[-1, 1]^d`. Integrals.jl rescales the nodes to
the problem domain before evaluating the integrand. Nodes may be scalars in one
dimension or vectors in multiple dimensions; weights must be scalar.

## Arguments

  - `q`: Function that returns `(nodes, weights)` for a requested node count.

## Keyword Arguments

  - `n`: Number of quadrature nodes requested from `q`. Must be positive.

## Fields

  - `q`: Stored quadrature rule constructor.
  - `n::Int`: Stored quadrature node count.

## Returns

Returns a `QuadratureRule` algorithm object. The method computes the fixed quadrature
sum and reports success; callers are responsible for checking convergence by changing
`n` or otherwise validating the chosen rule.

## Example

```julia
using Integrals, FastGaussQuadrature

prob = IntegralProblem((x, p) -> x^4, (-1.0, 1.0))
sol = solve(prob, QuadratureRule(gausslegendre; n = 8))
```
"""
struct QuadratureRule{Q} <: SciMLBase.AbstractIntegralAlgorithm
    q::Q
    n::Int
    function QuadratureRule(q::Q, n::Integer) where {Q}
        n > 0 ||
            throw(ArgumentError("Cannot use a nonpositive number of quadrature nodes."))
        return new{Q}(q, n)
    end
end
QuadratureRule(q; n = 250) = QuadratureRule(q, n)

using Integrals, FiniteDiff, ForwardDiff, Cubature, Cuba, Zygote, Mooncake, Test

my_parameters = [1.0, 2.0]
my_function(x, p) = x^2 + p[1]^3 * x + p[2]^2
function my_integration(p)
    my_problem = IntegralProblem(my_function, (-1.0, 1.0), p)
    # return solve(my_problem, HCubatureJL(), reltol=1e-3, abstol=1e-3)  # Works
    return solve(my_problem, CubatureJLh(), reltol = 1.0e-3, abstol = 1.0e-3)  # Errors
end
my_solution = my_integration(my_parameters)
@test ForwardDiff.jacobian(my_integration, my_parameters) ≈ [0.0 8.0]
@test ForwardDiff.jacobian(x -> ForwardDiff.jacobian(my_integration, x), my_parameters) ≈
    [
    0.0 0.0
    0.0 4.0
]

ff(x, p) = sum(sin.(x .* p))
lb = ones(2)
ub = 3ones(2)
p = [1.5, 2.0]

function testf(p)
    prob = IntegralProblem(ff, (lb, ub), p)
    return sin(solve(prob, CubaCuhre(), reltol = 1.0e-6, abstol = 1.0e-6)[1])
end

hp1 = FiniteDiff.finite_difference_hessian(testf, p)
hp2 = ForwardDiff.hessian(testf, p)
@test hp1 ≈ hp2 atol = 1.0e-4

ff2(x, p) = x * p[1] .+ p[2] * p[3]
lb = 1.0
ub = 3.0
p = [2.0, 3.0, 4.0]
_ff3 = BatchIntegralFunction(ff2)
prob = IntegralProblem(_ff3, (lb, ub), p)

function testf3(lb, ub, p; f = _ff3)
    prob = IntegralProblem(_ff3, (lb, ub), p)
    return solve(prob, CubatureJLh(); reltol = 1.0e-3, abstol = 1.0e-3)[1]
end

dp1 = ForwardDiff.gradient(p -> testf3(lb, ub, p), p)
dp2 = Zygote.gradient(p -> testf3(lb, ub, p), p)[1]
dp3 = FiniteDiff.finite_difference_gradient(p -> testf3(lb, ub, p), p)

@test dp1 ≈ dp3
@test dp2 ≈ dp3

function testf3_mooncake(lb, ub, p)
    prob = IntegralProblem(_ff3, (lb, ub), p)
    return solve(
        prob, CubatureJLh(); reltol = 1.0e-3, abstol = 1.0e-3,
        sensealg = Integrals.ReCallVJP(Integrals.MooncakeVJP())
    )[1]
end

if pkgversion(Mooncake) >= v"0.5.26"
    testf3_mooncake_p = p -> testf3_mooncake(lb, ub, p)
    cache = Mooncake.prepare_gradient_cache(testf3_mooncake_p, p)
    _, grads = Mooncake.value_and_gradient!!(cache, testf3_mooncake_p, p)
    dp4 = grads[2]
    @test dp4 ≈ dp3
end

using Integrals, Distributions, Test, Cubature, FastGaussQuadrature, StaticArrays

reltol = 0.0
abstol = 1.0e-3

# not all quadratures are compatible with infinities if they evaluate the endpoints
alg_req = Dict(
    QuadratureRule(
        gausslegendre,
        n = 50
    ) => (
        nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
        allows_iip = false, allows_inf = true,
    ),
    QuadGKJL() => (
        nout = Inf, allows_batch = true, min_dim = 1, max_dim = 1,
        allows_iip = true, allows_inf = true,
    ),
    HCubatureJL() => (
        nout = Inf, allows_batch = false, min_dim = 1,
        max_dim = Inf, allows_iip = true, allows_inf = true,
    ),
    CubatureJLh() => (
        nout = Inf, allows_batch = true, min_dim = 1,
        max_dim = Inf, allows_iip = true, allows_inf = true,
    )
)
# GaussLegendre(n=50) => (nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
#     allows_iip = false, allows_inf=true),
# VEGAS() => (nout = 1, allows_batch = true, min_dim = 2, max_dim = Inf,
# allows_iip = true),
# CubatureJLp() => (nout = Inf, allows_batch = true, min_dim = 1,
#     max_dim = Inf, allows_iip = true, allows_inf=false),
# CubaVegas() => (nout = Inf, allows_batch = true, min_dim = 1, max_dim = Inf,
#     allows_iip = true),
# CubaSUAVE() => (nout = Inf, allows_batch = true, min_dim = 1, max_dim = Inf,
#     allows_iip = true),
# CubaDivonne() => (nout = Inf, allows_batch = true, min_dim = 2,
#     max_dim = Inf, allows_iip = true),
# CubaCuhre() => (nout = Inf, allows_batch = true, min_dim = 2, max_dim = Inf,
#     allows_iip = true),
problems = (
    (;
        # 1. multi-variate infinite limits: Gaussian
        f = (x, p) -> pdf(MvNormal([0.0, 0.0], [0.4 0.0; 0.0 0.4]), x),
        domain = (@SVector[-Inf, -Inf], @SVector[Inf, Inf]),
        solution = 1.0
    ),
    (;
        # 2. multi-variate flipped infinite limits: Gaussian
        f = (x, p) -> pdf(MvNormal([0.0, 0.0], [0.4 0.0; 0.0 0.4]), x),
        domain = (@SVector[Inf, Inf], @SVector[-Inf, -Inf]),
        solution = 1.0
    ),
    (;
        # 3. multi-variate mixed infinite/semi-infinite upper limit: Gaussian
        f = (x, p) -> pdf(MvNormal([0.0, 0.0], [0.4 0.0; 0.0 0.4]), x),
        domain = (@SVector[-Inf, 0], @SVector[Inf, Inf]),
        solution = 0.5
    ),
    (;
        # 4. multi-variate mixed infinite/semi-infinite lower limit: Gaussian
        f = (x, p) -> pdf(MvNormal([0.0, 0.0], [0.4 0.0; 0.0 0.4]), x),
        domain = (@SVector[-Inf, -Inf], @SVector[Inf, 0]),
        solution = 0.5
    ),
    (;
        # 5. multi-variate mixed infinite/finite: Gaussian * quadratic
        f = (x, p) -> pdf(Normal(0.0, 1.0), x[1]) * x[2]^2,
        domain = (@SVector[-Inf, 1], @SVector[Inf, 4]),
        solution = 21.0
    ),
    (;
        # 6. multi-variate mixed semi-infinite lower limit/finite: Gaussian * quadratic
        f = (x, p) -> pdf(Normal(0.0, 1.0), x[1]) * x[2]^2,
        domain = (@SVector[0.0, 1], @SVector[Inf, 4]),
        solution = 10.5
    ),
    (;
        # 7. multi-variate mixed semi-infinite upper limit/finite: Gaussian * quadratic
        f = (x, p) -> pdf(Normal(0.0, 1.0), x[1]) * x[2]^2,
        domain = (@SVector[-Inf, 1], @SVector[0.0, 4]),
        solution = 10.5
    ),
    (;
        # 8. single-variable infinite limit: Gaussian
        f = (x, p) -> pdf(Normal(0.0, 1.0), x),
        domain = (-Inf, Inf),
        solution = 1.0,
    ),
    (;
        # 9. single-variable flipped infinite limit: Gaussian
        f = (x, p) -> pdf(Normal(0.0, 1.0), x),
        domain = (Inf, -Inf),
        solution = -1.0,
    ),
    (;
        # 10. single-variable semi-infinite upper limit: Gaussian
        f = (x, p) -> pdf(Normal(0.0, 1.0), x),
        domain = (0.0, Inf),
        solution = 0.5,
    ),
    (;
        # 11. single-variable flipped, semi-infinite upper limit: Gaussian
        f = (x, p) -> pdf(Normal(0.0, 1.0), x),
        domain = (0.0, -Inf),
        solution = -0.5,
    ),
    (;
        # 12. single-variable semi-infinite lower limit: Gaussian
        f = (x, p) -> pdf(Normal(0.0, 1.0), x),
        domain = (-Inf, 0.0),
        solution = 0.5,
    ),
    (;
        # 13. single-variable flipped, semi-infinite lower limit: Gaussian
        f = (x, p) -> pdf(Normal(0.0, 1.0), x),
        domain = (Inf, 0.0),
        solution = -0.5,
    ),
    (;
        # 14. single-variable infinite limit: Lorentzian
        f = (x, p) -> 1 / (x^2 + 1),
        domain = (-Inf, Inf),
        solution = pi / 1,
    ),
    (;
        # 15. single-variable shifted, semi-infinite lower limit: Lorentzian
        f = (x, p) -> 1 / ((x - 2)^2 + 1),
        domain = (-Inf, 2),
        solution = pi / 2,
    ),
    (;
        # 16. single-variable shifted, semi-infinite upper limit: Lorentzian
        f = (x, p) -> 1 / ((x - 2)^2 + 1),
        domain = (2, Inf),
        solution = pi / 2,
    ),
    (;
        # 17. single-variable flipped, shifted, semi-infinite lower limit: Lorentzian
        f = (x, p) -> 1 / ((x - 2)^2 + 1),
        domain = (Inf, 2),
        solution = -pi / 2,
    ),
    (;
        # 18. single-variable flipped, shifted, semi-infinite upper limit: Lorentzian
        f = (x, p) -> 1 / ((x - 2)^2 + 1),
        domain = (2, -Inf),
        solution = -pi / 2,
    ),
    (;
        # 19. single-variable finite limits: quadratic
        f = (x, p) -> x^2,
        domain = (1, 4),
        solution = 21,
    ),
    (;
        # 20. single-variable flipped, finite limits: quadratic
        f = (x, p) -> x^2,
        domain = (4, 1),
        solution = -21,
    ),
)

function f_helper!(f, y, x, p)
    y[] = f(x, p)
    return
end

function batch_helper(f, x, p)
    return map(i -> f(x[axes(x)[begin:(end - 1)]..., i], p), axes(x)[end])
end

function batch_helper!(f, y, x, p)
    y .= batch_helper(f, x, p)
    return
end

do_tests = function (; f, domain, alg, abstol, reltol, solution)
    prob = IntegralProblem(f, domain)
    sol = solve(prob, alg; reltol, abstol)
    @test abs(only(sol) - solution) < max(abstol, reltol * abs(solution))
    cache = @test_nowarn @inferred init(prob, alg)
    @test_nowarn @inferred solve!(cache)
    return @test_nowarn @inferred solve(prob, alg)
end

# IntegralFunction{false}
for (alg, req) in pairs(alg_req), (j, (; f, domain, solution)) in enumerate(problems)

    req.allows_inf || continue
    req.nout >= length(solution) || continue
    req.min_dim <= length(first(domain)) <= req.max_dim || continue

    @info "oop infinity test" alg = nameof(typeof(alg)) problem = j
    do_tests(; f, domain, solution, alg, abstol, reltol)
end

# IntegralFunction{true}
for (alg, req) in pairs(alg_req), (j, (; f, domain, solution)) in enumerate(problems)

    req.allows_inf || continue
    req.nout >= length(solution) || continue
    req.allows_iip || continue
    req.min_dim <= length(first(domain)) <= req.max_dim || continue

    @info "iip infinity test" alg = nameof(typeof(alg)) problem = j
    fiip = IntegralFunction((y, x, p) -> f_helper!(f, y, x, p), zeros(size(solution)))
    do_tests(; f = fiip, domain, solution, alg, abstol, reltol)
end

# BatchIntegralFunction{false}
for (alg, req) in pairs(alg_req), (j, (; f, domain, solution)) in enumerate(problems)

    req.allows_inf || continue
    req.nout >= length(solution) || continue
    req.allows_batch || continue
    req.min_dim <= length(first(domain)) <= req.max_dim || continue

    @info "Batched, oop infinity test" alg = nameof(typeof(alg)) problem = j
    bf = BatchIntegralFunction((x, p) -> batch_helper(f, x, p))
    do_tests(; f = bf, domain, solution, alg, abstol, reltol)
end

# BatchIntegralFunction{true}
for (alg, req) in pairs(alg_req), (j, (; f, domain, solution)) in enumerate(problems)

    req.allows_inf || continue
    req.nout >= length(solution) || continue
    req.allows_batch || continue
    req.allows_iip || continue
    req.min_dim <= length(first(domain)) <= req.max_dim || continue

    @info "Batched, iip infinity test" alg = nameof(typeof(alg)) problem = j
    bfiip = BatchIntegralFunction((y, x, p) -> batch_helper!(f, y, x, p), zeros(0))
    do_tests(; f = bfiip, domain, solution, alg, abstol, reltol)
end

@testset "Caching interface" begin
    # two distinct semi-infinite transformations should still work as expected
    f = (x, p) -> pdf(Normal(0.0, 1.0), x)
    domain = (0.0, -Inf)
    solution = -0.5
    prob = IntegralProblem(f, domain)
    alg = QuadGKJL()
    cache = init(prob, alg; abstol, reltol)
    sol = solve!(cache)
    @test abs(only(sol.u) - solution) < max(abstol, reltol * abs(solution))
    @test sol.prob == IntegralProblem(f, domain)
    @test sol.alg == alg
    domain = (-Inf, 0.0)
    solution = 0.5
    cache.domain = domain
    sol = solve!(cache)
    @test abs(only(sol.u) - solution) < max(abstol, reltol * abs(solution))
    @test sol.prob == IntegralProblem(f, domain)
    @test sol.alg == alg
end

function evalrule(f, p, lb, ub, nodes, weights)
    scale = map((u, l) -> (u - l) / 2, ub, lb)
    shift = (lb + ub) / 2
    f_ = x -> f(x, p)
    xw = ((map(*, scale, x) + shift, w) for (x, w) in zip(nodes, weights))
    # we are basically computing sum(w .* f.(x))
    # unroll first loop iteration to get right types
    next = iterate(xw)
    next === nothing && throw(ArgumentError("empty quadrature rule"))
    (x0, w0), state = next
    I = w0 * f_(x0)
    next = iterate(xw, state)
    while next !== nothing
        (xi, wi), state = next
        I += wi * f_(xi)
        next = iterate(xw, state)
    end
    return prod(scale) * I
end

function init_cacheval(alg::QuadratureRule, ::IntegralProblem)
    return alg.q(alg.n)
end

function Integrals.__solvebp_call(
        cache::IntegralCache, alg::QuadratureRule,
        sensealg, domain, p;
        reltol = nothing, abstol = nothing,
        maxiters = nothing
    )
    prob = build_problem(cache)
    if isinplace(prob)
        error("QuadratureRule does not support inplace integrands.")
    end
    @assert prob.f isa IntegralFunction

    @SciMLMessage(
        lazy"QuadratureRule: evaluating with $(length(cache.cacheval[1])) nodes",
        cache.verbosity, :algorithm_selection
    )

    lb, ub = domain
    val = evalrule(cache.f, cache.p, lb, ub, cache.cacheval...)

    @SciMLMessage(
        lazy"QuadratureRule completed: val=$val",
        cache.verbosity, :convergence_result
    )

    err = nothing
    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end

module IntegralsFastGaussQuadratureExt
using Integrals
import FastGaussQuadrature
using SciMLLogging: @SciMLMessage

Integrals.gausslegendre(n) = FastGaussQuadrature.gausslegendre(n)

function gauss_legendre(f::F, p, lb, ub, nodes, weights) where {F}
    scale = (ub - lb) / 2
    shift = (lb + ub) / 2
    # TODO reuse Integrals.evalrule instead
    x0, xs = Iterators.peel(nodes)
    w0, ws = Iterators.peel(weights)
    I = w0 * f(scale * x0 + shift, p)
    for (w, x) in zip(ws, xs)
        I += w * f(scale * x + shift, p)
    end
    return scale * I
end
function composite_gauss_legendre(f::F, p, lb, ub, nodes, weights, subintervals) where {F}
    h = (ub - lb) / subintervals
    I = gauss_legendre(f, p, lb, lb + h, nodes, weights)
    for i in 1:(subintervals - 1)
        _lb = lb + i * h
        _ub = _lb + h
        I += gauss_legendre(f, p, _lb, _ub, nodes, weights)
    end
    return I
end

function Integrals.__solvebp_call(
        prob::IntegralProblem, alg::Integrals.GaussLegendre{C},
        sensealg, domain, p;
        reltol = nothing, abstol = nothing,
        maxiters = nothing,
        verbose = Integrals.DEFAULT_VERBOSE
    ) where {C}
    if !all(isone ∘ length, domain)
        error("GaussLegendre only accepts one-dimensional quadrature problems.")
    end
    @assert prob.f isa IntegralFunction
    @assert !isinplace(prob)

    lb, ub = map(only, domain)

    if C
        @SciMLMessage(
            lazy"GaussLegendre: composite Gauss-Legendre quadrature with $(length(alg.nodes)) nodes and $(alg.subintervals) subintervals",
            verbose, :algorithm_selection
        )
        val = composite_gauss_legendre(
            prob.f, prob.p, lb, ub,
            alg.nodes, alg.weights, alg.subintervals
        )
    else
        @SciMLMessage(
            lazy"GaussLegendre: Gauss-Legendre quadrature with $(length(alg.nodes)) nodes",
            verbose, :algorithm_selection
        )
        val = gauss_legendre(
            prob.f, prob.p, lb, ub,
            alg.nodes, alg.weights
        )
    end

    @SciMLMessage(
        lazy"GaussLegendre completed: val=$val",
        verbose, :convergence_result
    )

    err = nothing
    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end
end

using Integrals, Mooncake, Zygote, FiniteDiff, ForwardDiff #, SciMLSensitivity
using Cuba, Cubature
using FastGaussQuadrature
using Test

max_dim_test = 2
max_nout_test = 2

reltol = 1.0e-3
abstol = 1.0e-3

alg_req = Dict(
    QuadratureRule(
        gausslegendre,
        n = 50
    ) => (
        nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
        allows_iip = false,
    ),
    GaussLegendre(n = 50) => (
        nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
        allows_iip = false,
    ),
    GaussLegendre(
        n = 50,
        subintervals = 3
    ) => (
        nout = Inf, min_dim = 1, max_dim = 1, allows_batch = false,
        allows_iip = false,
    ),
    QuadGKJL() => (
        nout = Inf, allows_batch = true, min_dim = 1, max_dim = 1,
        allows_iip = true,
    ),
    HCubatureJL() => (
        nout = Inf, allows_batch = false, min_dim = 1,
        max_dim = Inf, allows_iip = true,
    ),
    CubatureJLh() => (
        nout = Inf, allows_batch = true, min_dim = 1,
        max_dim = Inf, allows_iip = true,
    ),
    CubatureJLp() => (
        nout = Inf, allows_batch = true, min_dim = 1,
        max_dim = Inf, allows_iip = true,
    )
)
# VEGAS() => (nout = 1, allows_batch = true, min_dim = 2, max_dim = Inf,
# allows_iip = true),
# CubaVegas() => (nout = Inf, allows_batch = true, min_dim = 1, max_dim = Inf,
#     allows_iip = true),
# CubaSUAVE() => (nout = Inf, allows_batch = true, min_dim = 1, max_dim = Inf,
#     allows_iip = true),
# CubaDivonne() => (nout = Inf, allows_batch = true, min_dim = 2,
#     max_dim = Inf, allows_iip = true),
# CubaCuhre() => (nout = Inf, allows_batch = true, min_dim = 2, max_dim = Inf,
#     allows_iip = true),

# integrands should have same shape as parameters, independent of dimensionality
integrands = (
    (x, p) -> map(q -> prod(y -> sin(y * q), x), p),
)

# function to turn the output into a scalar / test different tangent types
scalarize_solution = (
    sol -> sin(sum(sol)),
    sol -> sin(sol[1]),
)

# we will be able to use broadcasting for this after https://github.com/FluxML/Zygote.jl/pull/1488
function buffer_copyto!(y, x)
    for (j, i) in zip(eachindex(y), eachindex(x))
        y[j] = x[i]
    end
    return y
end
function f_helper!(f, y, x, p)
    buffer_copyto!(y, f(x, p))
    return
end

# the Zygote implementation is inconsistent about 0-d so we hijack it
struct Scalar{T <: Real} <: Real
    x::T
end
Base.iterate(a::Scalar) = (a.x, nothing)
Base.iterate(::Scalar, _) = nothing
Base.IteratorSize(::Type{Scalar{T}}) where {T} = Base.HasShape{0}()
Base.eltype(::Type{Scalar{T}}) where {T} = T
Base.length(a::Scalar) = 1
Base.size(::Scalar) = ()
Base.:+(a::Scalar, b::Scalar) = Scalar(a.x + b.x)
Base.:*(a::Number, b::Scalar) = a * b.x
Base.:*(a::Scalar, b::Number) = a.x * b
Base.:*(a::Scalar, b::Scalar) = Scalar(a.x * b.x)
Base.zero(a::Scalar) = Scalar(zero(a.x))
Base.map(f, a::Scalar) = map(f, a.x)
(::Type{T})(a::Scalar) where {T <: Real} = T(a.x)
struct ScalarAxes end # the implementation doesn't preserve singleton axes
Base.axes(::Scalar) = ScalarAxes()
Base.iterate(::ScalarAxes) = nothing
Base.reshape(A::AbstractArray, ::ScalarAxes) = Scalar(only(A))

# Scalar struct defined around Real Numbers (test/derivative_tests.jl)
# Mooncake, like Zygote also treats 0-D data wrt to the type of datastructure.
Mooncake.rdata_type(::Type{Scalar{T}}) where {T <: Real} = Mooncake.rdata_type(T)

# here we assume f evaluated at scalar inputs gives a scalar output
# p will be able to be a number  after https://github.com/FluxML/Zygote.jl/pull/1489
# p will be able to be a 0-array after https://github.com/FluxML/Zygote.jl/pull/1491
# p can't be either without both prs
function batch_helper(f, x, p)
    t = f(zero(eltype(x)), zero(eltype(eltype(p))))
    return typeof(t).([f(y, q) for q in p, y in eachslice(x; dims = ndims(x))])
end

function batch_helper!(f, y, x, p)
    buffer_copyto!(y, batch_helper(f, x, p))
    return
end

# helper function / test runner
do_tests = function (; f, scalarize, lb, ub, p, alg, abstol, reltol)
    testf = function (lb, ub, p)
        prob = IntegralProblem(f, (lb, ub), p)
        return scalarize(solve(prob, alg; reltol, abstol))
    end
    testf(lb, ub, p)

    dlb1, dub1,
        dp1 = Zygote.gradient(
        testf, lb, ub, p isa Number && f isa BatchIntegralFunction ? Scalar(p) : p
    )

    f_lb = lb -> testf(lb, ub, p)
    f_ub = ub -> testf(lb, ub, p)

    dlb = lb isa AbstractArray ? :gradient : :derivative
    dub = ub isa AbstractArray ? :gradient : :derivative

    dlb2 = getproperty(FiniteDiff, Symbol(:finite_difference_, dlb))(f_lb, lb)
    dub2 = getproperty(FiniteDiff, Symbol(:finite_difference_, dub))(f_ub, ub)

    if lb isa Number
        @test dlb1 ≈ dlb2 atol = abstol rtol = reltol
        @test dub1 ≈ dub2 atol = abstol rtol = reltol
    else # TODO: implement multivariate limit derivatives in ZygoteExt
        @test_broken dlb1 ≈ dlb2 atol = abstol rtol = reltol
        @test_broken dub1 ≈ dub2 atol = abstol rtol = reltol
    end

    # TODO: implement limit derivatives in ForwardDiffExt
    @test_broken dlb2 ≈ getproperty(ForwardDiff, dlb)(dfdlb, lb) atol = abstol rtol = reltol
    @test_broken dub2 ≈ getproperty(ForwardDiff, dub)(dfdub, ub) atol = abstol rtol = reltol

    f_p = p -> testf(lb, ub, p)

    dp = p isa AbstractArray ? :gradient : :derivative

    dp2 = getproperty(FiniteDiff, Symbol(:finite_difference_, dp))(f_p, p)
    dp3 = getproperty(ForwardDiff, dp)(f_p, p)

    @test dp1 ≈ dp2 atol = abstol rtol = reltol
    @test dp2 ≈ dp3 atol = abstol rtol = reltol

    return
end

# Mooncake Sensealg testing helper function
do_tests_mooncake = function (; f, scalarize, lb, ub, p, alg, abstol, reltol)
    testf = function (lb, ub, p)
        prob = IntegralProblem(f, (lb, ub), p)
        return scalarize(
            solve(
                prob,
                alg;
                reltol,
                abstol,
                sensealg = Integrals.ReCallVJP{Integrals.MooncakeVJP}(Integrals.MooncakeVJP())
            )
        )
    end
    sol_fp = testf(lb, ub, p)

    cache = Mooncake.prepare_gradient_cache(testf, lb, ub, p)
    forwpassval, gradients = Mooncake.value_and_gradient!!(cache, testf, lb, ub, p)

    @test forwpassval == sol_fp

    f_lb = lb -> testf(lb, ub, p)
    f_ub = ub -> testf(lb, ub, p)

    dlb = lb isa AbstractArray ? :gradient : :derivative
    dub = ub isa AbstractArray ? :gradient : :derivative

    dlb2 = getproperty(FiniteDiff, Symbol(:finite_difference_, dlb))(f_lb, lb)
    dub2 = getproperty(FiniteDiff, Symbol(:finite_difference_, dub))(f_ub, ub)

    if lb isa Number
        @test gradients[2] ≈ dlb2 atol = abstol rtol = reltol
        @test gradients[3] ≈ dub2 atol = abstol rtol = reltol
    else # TODO: implement multivariate limit derivatives in MooncakeExt
        @test_broken gradients[2] ≈ dlb2 atol = abstol rtol = reltol
        @test_broken gradients[3] ≈ dub2 atol = abstol rtol = reltol
    end

    f_p = p -> testf(lb, ub, p)
    dp = p isa AbstractArray ? :gradient : :derivative

    dp2 = getproperty(FiniteDiff, Symbol(:finite_difference_, dp))(f_p, p)
    dp3 = getproperty(ForwardDiff, dp)(f_p, p)

    @test dp2 ≈ dp3 atol = abstol rtol = reltol

    # test Mooncake for parameter p
    @test gradients[4] ≈ dp2 atol = abstol rtol = reltol
    @test dp2 ≈ dp3 atol = abstol rtol = reltol

    return
end

### One Dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution)
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "One-dimensional, scalar, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i
    do_tests(; f, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
    do_tests_mooncake(; f, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
end

## One-dimensional nout
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), nout in 1:max_nout_test
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "One-dimensional, multivariate, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i nout
    do_tests(;
        f, scalarize, lb = 1.0, ub = 3.0, p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f, scalarize, lb = 1.0, ub = 3.0, p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

### N-dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Multi-dimensional, scalar, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim
    do_tests(; f, scalarize, lb = ones(dim), ub = 3ones(dim), p = 2.0, alg, abstol, reltol)
    do_tests_mooncake(;
        f, scalarize, lb = ones(dim), ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
end

### N-dimensional nout
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test,
        nout in 1:max_nout_test
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Multi-dimensional, multivariate, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim nout
    do_tests(;
        f, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

#### in place IntegralCache, IntegralFunction Tests
### One Dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution)
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "One-dimensional, scalar, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i
    fiip = IntegralFunction((y, x, p) -> f_helper!(f, y, x, p), zeros(1))
    do_tests(; f = fiip, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
    do_tests_mooncake(;
        f = fiip, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol
    )
end

## One-dimensional nout
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), nout in 1:max_nout_test
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "One-dimensional, multivariate, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i nout
    fiip = IntegralFunction((y, x, p) -> f_helper!(f, y, x, p), zeros(nout))
    do_tests(;
        f = fiip, scalarize, lb = 1.0, ub = 3.0,
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = fiip, scalarize, lb = 1.0, ub = 3.0,
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

### N-dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Multi-dimensional, scalar, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim
    fiip = IntegralFunction((y, x, p) -> f_helper!(f, y, x, p), zeros(1))
    do_tests(;
        f = fiip, scalarize, lb = ones(dim), ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = fiip, scalarize, lb = ones(dim), ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
end

### N-dimensional nout iip
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test,
        nout in 1:max_nout_test
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Multi-dimensional, multivariate, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim nout
    fiip = IntegralFunction((y, x, p) -> f_helper!(f, y, x, p), zeros(nout))
    do_tests(;
        f = fiip, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = fiip, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

### Batch, One Dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution)
    req.allows_batch || continue
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "Batched, one-dimensional, scalar, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i
    bf = BatchIntegralFunction((x, p) -> batch_helper(f, x, p))
    do_tests(; f = bf, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
    do_tests_mooncake(; f = bf, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
end

## Batch, One-dimensional nout
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), nout in 1:max_nout_test
    req.allows_batch || continue
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "Batched, one-dimensional, multivariate, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i nout
    bf = BatchIntegralFunction((x, p) -> batch_helper(f, x, p))
    do_tests(;
        f = bf, scalarize, lb = 1.0, ub = 3.0,
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = bf, scalarize, lb = 1.0, ub = 3.0,
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

### Batch, N-dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test
    req.allows_batch || continue
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Batched, multi-dimensional, scalar, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim
    bf = BatchIntegralFunction((x, p) -> batch_helper(f, x, p))
    do_tests(;
        f = bf, scalarize, lb = ones(dim), ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = bf, scalarize, lb = ones(dim), ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
end

### Batch, N-dimensional nout
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test,
        nout in 1:max_nout_test
    req.allows_batch || continue
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Batch, multi-dimensional, multivariate, oop derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim nout
    bf = BatchIntegralFunction((x, p) -> batch_helper(f, x, p))
    do_tests(;
        f = bf, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = bf, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

### Batch, one-dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution)
    req.allows_batch || continue
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "Batched, one-dimensional, scalar, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i
    bfiip = BatchIntegralFunction((y, x, p) -> batch_helper!(f, y, x, p), zeros(0))
    do_tests(; f = bfiip, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
    do_tests_mooncake(; f = bfiip, scalarize, lb = 1.0, ub = 3.0, p = 2.0, alg, abstol, reltol)
end

## Batch, one-dimensional nout
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), nout in 1:max_nout_test
    req.allows_batch || continue
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= 1 || continue

    @info "Batched, one-dimensional, multivariate, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i nout
    bfiip = BatchIntegralFunction((y, x, p) -> batch_helper!(f, y, x, p), zeros(nout, 0))
    do_tests(;
        f = bfiip, scalarize, lb = 1.0, ub = 3.0,
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = bfiip, scalarize, lb = 1.0, ub = 3.0,
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

### Batch, N-dimensional
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test
    req.allows_batch || continue
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Batched, multi-dimensional, scalar, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim
    bfiip = BatchIntegralFunction((y, x, p) -> batch_helper!(f, y, x, p), zeros(0))
    do_tests(;
        f = bfiip, scalarize, lb = ones(dim),
        ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = bfiip, scalarize, lb = ones(dim),
        ub = 3ones(dim), p = 2.0, alg, abstol, reltol
    )
end

### Batch, N-dimensional nout iip
for (alg, req) in pairs(alg_req), (j, f) in enumerate(integrands),
        (i, scalarize) in enumerate(scalarize_solution), dim in 1:max_dim_test,
        nout in 1:max_nout_test
    req.allows_batch || continue
    req.allows_iip || continue
    req.nout > 1 || continue
    req.min_dim <= dim <= req.max_dim || continue

    @info "Batched, multi-dimensional, multivariate, iip derivative test" alg = nameof(typeof(alg)) integrand = j scalarize = i dim nout
    bfiip = BatchIntegralFunction((y, x, p) -> batch_helper!(f, y, x, p), zeros(nout, 0))
    do_tests(;
        f = bfiip, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
    do_tests_mooncake(;
        f = bfiip, scalarize, lb = ones(dim), ub = 3ones(dim),
        p = [2.0i for i in 1:nout], alg, abstol, reltol
    )
end

@testset "ChangeOfVariables rrules" begin
    alg = QuadGKJL()
    # test a simple u-substitution of x = 2.7u + 1.3
    talg = Integrals.ChangeOfVariables(alg) do f, domain
        if f isa IntegralFunction{false}
            IntegralFunction((x, p) -> f((x - 1.3) / 2.7, p) / 2.7),
                map(x -> 1.3 + 2.7x, domain)
        else
            error("not implemented")
        end
    end

    testf = (
        f, lb, ub, p, alg,
        sensealg,
    ) -> begin
        prob = IntegralProblem(f, (lb, ub), p)
        solve(prob, alg; abstol, reltol, sensealg = sensealg).u
    end
    _testf = (x, p) -> x^2 * p
    lb, ub, p = 1.0, 5.0, 2.0

    @testset "Sensitivity using Zygote" begin
        sensealg = Integrals.ReCallVJP(Integrals.ZygoteVJP())
        sol = Zygote.withgradient(
            (args...) -> testf(_testf, args...), lb, ub, p, alg, sensealg
        )
        tsol = Zygote.withgradient(
            (args...) -> testf(_testf, args...), lb, ub, p, talg, sensealg
        )
        @test sol.val ≈ tsol.val
        # Fundamental theorem of Calculus part 1
        @test sol.grad[1] ≈ tsol.grad[1] ≈ -_testf(lb, p)
        @test sol.grad[2] ≈ tsol.grad[2] ≈ _testf(ub, p)
        # This is to check ∂p
        @test sol.grad[3] ≈ tsol.grad[3]
    end

    @testset "Sensitivity using Mooncake" begin
        sensealg = Integrals.ReCallVJP(Integrals.MooncakeVJP())
        # anonymous function for cache creation and gradient evaluation call must be the same.
        func = (args...) -> testf(_testf, args...)
        cache = Mooncake.prepare_gradient_cache(func, lb, ub, p, alg, sensealg)
        sol = Mooncake.value_and_gradient!!(
            cache, func,
            lb, ub, p, alg, sensealg
        )

        cache = Mooncake.prepare_gradient_cache(func, lb, ub, p, talg, sensealg)
        tsol = Mooncake.value_and_gradient!!(
            cache, func, lb, ub, p, talg, sensealg
        )

        @test sol[1] ≈ tsol[1]
        # Fundamental theorem of Calculus part 1
        @test sol[2][2] ≈ tsol[2][2] ≈ -_testf(lb, p)
        @test sol[2][3] ≈ tsol[2][3] ≈ _testf(ub, p)
        # To check ∂p
        @test sol[2][4] ≈ tsol[2][4]
    end
end

# Test for issue #291: NullParameters should not cause *(Nothing, Float) error
@testset "NullParameters gradient - Issue #291" begin
    # Test that using NullParameters (no explicit p argument) doesn't crash
    # when computing gradients with Zygote
    ps = [1.0f0, 2.0f0]

    # Function that captures parameters in closure (doesn't use p)
    function loss_closure(ps)
        g(x, _) = ps[1] * x + ps[2] * x^2
        y = solve(IntegralProblem(g, (0.0f0, 1.0f0)), HCubatureJL()).u
        abs2(y)
    end

    # This should not throw MethodError: no method matching *(::Nothing, ::Float32)
    @test_nowarn Zygote.gradient(loss_closure, ps)

    # Verify the loss value is computed correctly
    @test loss_closure(ps) ≈ (ps[1] * 0.5f0 + ps[2] / 3.0f0)^2

    # When using explicit p parameter, gradients should work correctly
    function loss_explicit_p(ps)
        g(x, p) = p[1] * x + p[2] * x^2
        y = solve(IntegralProblem(g, (0.0f0, 1.0f0), ps), HCubatureJL()).u
        abs2(y)
    end

    grad_explicit = Zygote.gradient(loss_explicit_p, ps)[1]
    @test grad_explicit !== nothing
    @test length(grad_explicit) == 2

    # Compare with ForwardDiff for correctness
    grad_fd = ForwardDiff.gradient(loss_explicit_p, ps)
    @test grad_explicit ≈ grad_fd rtol = 1.0e-5
end

# DifferentiationInterface extension tests are TODO
# The extension provides the foundation for using ADTypes backends as sensealg
# Full testing requires further integration work with the existing Zygote/Mooncake extensions

## Extension Algorithms

"""
    AbstractIntegralExtensionAlgorithm <: SciMLBase.AbstractIntegralAlgorithm

Abstract type for integration algorithms provided through package extensions.

## Interface

Concrete subtypes are lightweight algorithm configuration objects. The package extension
that owns the backend must implement `Integrals.__solvebp_call(cache, alg, sensealg,
domain, p; kwargs...)` or another solver layer used by `solve!`. Constructors may check
that the required extension is loaded and should store all backend options in fields.
"""
abstract type AbstractIntegralExtensionAlgorithm <: SciMLBase.AbstractIntegralAlgorithm end
"""
    AbstractIntegralCExtensionAlgorithm <: AbstractIntegralExtensionAlgorithm

Abstract type for integration algorithms that use C or C++ libraries through package extensions.

## Interface

Subtypes follow [`AbstractIntegralExtensionAlgorithm`](@ref). Backend wrappers are
responsible for converting Julia integrands, domains, tolerances, and iteration limits to
the C-compatible callback and option formats required by the wrapped library.
"""
abstract type AbstractIntegralCExtensionAlgorithm <: AbstractIntegralExtensionAlgorithm end

"""
    AbstractCubaAlgorithm <: AbstractIntegralCExtensionAlgorithm

Abstract type for integration algorithms from the Cuba.jl package.

## Interface

Concrete Cuba algorithms store Cuba option fields and require `using Cuba` before
construction. Their extension methods must accept multidimensional `IntegralProblem`s,
forward common `solve` tolerances and iteration limits, and return a SciMLBase integral
solution with the backend's estimate and residual/error estimate.
"""
abstract type AbstractCubaAlgorithm <: AbstractIntegralCExtensionAlgorithm end

"""
    CubaVegas(; flags = 0, seed = 0, minevals = 0, nstart = 1000,
        nincrease = 500, gridno = 0)

Multidimensional adaptive Monte Carlo integration from Cuba.jl.
Importance sampling is used to reduce variance.

## Keyword Arguments

  - `flags`: Cuba flags bitmask.
  - `seed`: Random seed passed to Cuba.
  - `minevals`: Minimum number of integrand evaluations.
  - `nstart`: Number of evaluations in the first iteration.
  - `nincrease`: Increase in evaluations for later iterations.
  - `gridno`: Cuba grid slot used for state reuse.

## Fields

The fields match the keyword arguments: `flags`, `seed`, `minevals`, `nstart`,
`nincrease`, and `gridno`.

## Returns

Returns a `CubaVegas` algorithm object. `Cuba.jl` must be loaded before construction.

## Example

```julia
using Integrals, Cuba

prob = IntegralProblem((x, p) -> x[1] * x[2], (zeros(2), ones(2)))
sol = solve(prob, CubaVegas(nstart = 2_000))
```

## References

```tex
@article{lepage1978new,
title={A new algorithm for adaptive multidimensional integration},
author={Lepage, G Peter},
journal={Journal of Computational Physics},
volume={27},
number={2},
pages={192--203},
year={1978},
publisher={Elsevier}
}
```
"""
struct CubaVegas <: AbstractCubaAlgorithm
    flags::Int
    seed::Int
    minevals::Int
    nstart::Int
    nincrease::Int
    gridno::Int
end

"""
    CubaSUAVE(; flags = 0, seed = 0, minevals = 0, nnew = 1000,
        nmin = 2, flatness = 25.0)

Multidimensional adaptive Monte Carlo integration from Cuba.jl.
Suave stands for subregion-adaptive VEGAS.
Importance sampling and subdivision are thus used to reduce variance.

## Keyword Arguments

  - `flags`: Cuba flags bitmask.
  - `seed`: Random seed passed to Cuba.
  - `minevals`: Minimum number of integrand evaluations.
  - `nnew`: Number of new samples per subdivision.
  - `nmin`: Minimum samples required before subdivision.
  - `flatness`: Flatness parameter used by SUAVE subdivision.

## Fields

The fields match the keyword arguments: `flags`, `seed`, `minevals`, `nnew`, `nmin`,
and `flatness`.

## Returns

Returns a `CubaSUAVE` algorithm object. `Cuba.jl` must be loaded before construction.

## References

```tex
@article{hahn2005cuba,
title={Cuba—a library for multidimensional numerical integration},
author={Hahn, Thomas},
journal={Computer Physics Communications},
volume={168},
number={2},
pages={78--95},
year={2005},
publisher={Elsevier}
}
```
"""
struct CubaSUAVE{R} <: AbstractCubaAlgorithm where {R <: Real}
    flags::Int
    seed::Int
    minevals::Int
    nnew::Int
    nmin::Int
    flatness::R
end

"""
    CubaDivonne(; flags = 0, seed = 0, minevals = 0, key1 = 47, key2 = 1,
        key3 = 1, maxpass = 5, border = 0.0, maxchisq = 10.0,
        mindeviation = 0.25, xgiven = zeros(Cdouble, 0, 0), nextra = 0,
        peakfinder = C_NULL)

Multidimensional adaptive Monte Carlo integration from Cuba.jl.
Stratified sampling is used to reduce variance.

## Keyword Arguments

  - `flags`: Cuba flags bitmask.
  - `seed`: Random seed passed to Cuba.
  - `minevals`: Minimum number of integrand evaluations.
  - `key1`, `key2`, `key3`: Divonne rule-selection keys.
  - `maxpass`: Maximum number of partitioning passes.
  - `border`: Border width excluded from partitioning.
  - `maxchisq`: Maximum chi-square value used for consistency checks.
  - `mindeviation`: Minimum relative deviation used for subdivision.
  - `xgiven`: Matrix of user-supplied points.
  - `nextra`: Number of extra points supplied through `peakfinder`.
  - `peakfinder`: Cuba peak-finder callback pointer.

## Fields

The fields match the keyword arguments.

## Returns

Returns a `CubaDivonne` algorithm object. `Cuba.jl` must be loaded before construction.

## References

```tex
@article{friedman1981nested,
title={A nested partitioning procedure for numerical multiple integration},
author={Friedman, Jerome H and Wright, Margaret H},
journal={ACM Transactions on Mathematical Software (TOMS)},
volume={7},
number={1},
pages={76--92},
year={1981},
publisher={ACM New York, NY, USA}
}
```
"""
struct CubaDivonne{R1, R2, R3, R4} <:
    AbstractCubaAlgorithm where {R1 <: Real, R2 <: Real, R3 <: Real, R4 <: Real}
    flags::Int
    seed::Int
    minevals::Int
    key1::Int
    key2::Int
    key3::Int
    maxpass::Int
    border::R1
    maxchisq::R2
    mindeviation::R3
    xgiven::Matrix{R4}
    nextra::Int
    peakfinder::Ptr{Cvoid}
end

"""
    CubaCuhre(; flags = 0, minevals = 0, key = 0)

Multidimensional h-adaptive integration from Cuba.jl.

## Keyword Arguments

  - `flags`: Cuba flags bitmask.
  - `minevals`: Minimum number of integrand evaluations.
  - `key`: Cuba Cuhre rule-selection key.

## Fields

  - `flags::Int`: Stored flags bitmask.
  - `minevals::Int`: Stored minimum evaluation count.
  - `key::Int`: Stored rule-selection key.

## Returns

Returns a `CubaCuhre` algorithm object. `Cuba.jl` must be loaded before construction.

## References

```tex
@article{berntsen1991adaptive,
title={An adaptive algorithm for the approximate calculation of multiple integrals},
author={Berntsen, Jarle and Espelid, Terje O and Genz, Alan},
journal={ACM Transactions on Mathematical Software (TOMS)},
volume={17},
number={4},
pages={437--451},
year={1991},
publisher={ACM New York, NY, USA}
}
```
"""
struct CubaCuhre <: AbstractCubaAlgorithm
    flags::Int
    minevals::Int
    key::Int
end

function CubaVegas(;
        flags = 0, seed = 0, minevals = 0, nstart = 1000, nincrease = 500,
        gridno = 0
    )
    isnothing(Base.get_extension(@__MODULE__, :IntegralsCubaExt)) &&
        error("CubaVegas requires `using Cuba`")
    return CubaVegas(flags, seed, minevals, nstart, nincrease, gridno)
end

function CubaSUAVE(;
        flags = 0, seed = 0, minevals = 0, nnew = 1000, nmin = 2,
        flatness = 25.0
    )
    isnothing(Base.get_extension(@__MODULE__, :IntegralsCubaExt)) &&
        error("CubaSUAVE requires `using Cuba`")
    return CubaSUAVE(flags, seed, minevals, nnew, nmin, flatness)
end

function CubaDivonne(;
        flags = 0, seed = 0, minevals = 0,
        key1 = 47, key2 = 1, key3 = 1, maxpass = 5, border = 0.0,
        maxchisq = 10.0, mindeviation = 0.25,
        xgiven = zeros(Cdouble, 0, 0),
        nextra = 0, peakfinder = C_NULL
    )
    isnothing(Base.get_extension(@__MODULE__, :IntegralsCubaExt)) &&
        error("CubaDivonne requires `using Cuba`")
    return CubaDivonne(
        flags, seed, minevals, key1, key2, key3, maxpass, border, maxchisq,
        mindeviation, xgiven, nextra, peakfinder
    )
end

function CubaCuhre(; flags = 0, minevals = 0, key = 0)
    isnothing(Base.get_extension(@__MODULE__, :IntegralsCubaExt)) &&
        error("CubaCuhre requires `using Cuba`")
    return CubaCuhre(flags, minevals, key)
end

"""
    AbstractCubatureJLAlgorithm <: AbstractIntegralCExtensionAlgorithm

Abstract type for integration algorithms from the Cubature.jl package.

## Interface

Subtypes require `using Cubature` before construction and store Cubature.jl option
values. Extension methods must pass common `solve` tolerances and iteration limits to
Cubature.jl and return a SciMLBase integral solution.
"""
abstract type AbstractCubatureJLAlgorithm <: AbstractIntegralCExtensionAlgorithm end

"""
    CubatureJLh(; error_norm = Cubature.INDIVIDUAL)

Multidimensional h-adaptive integration from Cubature.jl.
`error_norm` specifies the convergence criterion  for vector valued integrands.
Defaults to `Cubature.INDIVIDUAL`, other options are
`Cubature.PAIRED`, `Cubature.L1`, `Cubature.L2`, or `Cubature.LINF`.

## Keyword Arguments

  - `error_norm`: Cubature.jl error norm used for vector-valued integrands. The
    constructor default `0` corresponds to `Cubature.INDIVIDUAL`.

## Fields

  - `error_norm::Int32`: Stored Cubature.jl error-norm code.

## Returns

Returns a `CubatureJLh` algorithm object. `Cubature.jl` must be loaded before
construction.

## References

```tex
@article{genz1980remarks,
title={Remarks on algorithm 006: An adaptive algorithm for numerical integration over an N-dimensional rectangular region},
author={Genz, Alan C and Malik, Aftab Ahmad},
journal={Journal of Computational and Applied mathematics},
volume={6},
number={4},
pages={295--302},
year={1980},
publisher={Elsevier}
}
```
"""
struct CubatureJLh <: AbstractCubatureJLAlgorithm
    error_norm::Int32
end
function CubatureJLh(; error_norm = 0)
    isnothing(Base.get_extension(@__MODULE__, :IntegralsCubatureExt)) &&
        error("CubatureJLh requires `using Cubature`")
    return CubatureJLh(error_norm)
end

"""
    CubatureJLp(; error_norm = Cubature.INDIVIDUAL)

Multidimensional p-adaptive integration from Cubature.jl.
This method is based on repeatedly doubling the degree of the cubature rules,
until convergence is achieved.
The used cubature rule is a tensor product of Clenshaw–Curtis quadrature rules.
`error_norm` specifies the convergence criterion  for vector valued integrands.
Defaults to `Cubature.INDIVIDUAL`, other options are
`Cubature.PAIRED`, `Cubature.L1`, `Cubature.L2`, or `Cubature.LINF`.

## Keyword Arguments

  - `error_norm`: Cubature.jl error norm used for vector-valued integrands. The
    constructor default `0` corresponds to `Cubature.INDIVIDUAL`.

## Fields

  - `error_norm::Int32`: Stored Cubature.jl error-norm code.

## Returns

Returns a `CubatureJLp` algorithm object. `Cubature.jl` must be loaded before
construction.
"""
struct CubatureJLp <: AbstractCubatureJLAlgorithm
    error_norm::Int32
end
function CubatureJLp(; error_norm = 0)
    isnothing(Base.get_extension(@__MODULE__, :IntegralsCubatureExt)) &&
        error("CubatureJLp requires `using Cubature`")
    return CubatureJLp(error_norm)
end

"""
    ArblibJL(; check_analytic=false, take_prec=false, warn_on_no_convergence=false, opts=C_NULL)

One-dimensional adaptive Gauss-Legendre integration using rigorous error bounds and
precision ball arithmetic. Generally this assumes the integrand is holomorphic or
meromorphic, which is the user's responsibility to verify. The result of the integral is not
guaranteed to satisfy the requested tolerances, however the result is guaranteed to be
within the error estimate.

[Arblib.jl](https://github.com/kalmarek/Arblib.jl) only supports integration of univariate
real- and complex-valued functions with both inplace and out-of-place forms. See their
documentation for additional details the algorithm arguments and on implementing
high-precision integrands. Additionally, the error estimate is included in the return value
of the integral, representing a ball.

## Keyword Arguments

  - `check_analytic`: Whether Arblib should check analyticity assumptions.
  - `take_prec`: Whether to pass precision information through to the integrand.
  - `warn_on_no_convergence`: Whether to warn when Arblib reports non-convergence.
  - `opts`: Arblib option pointer or object passed to the backend.

## Fields

The fields match the keyword arguments: `check_analytic`, `take_prec`,
`warn_on_no_convergence`, and `opts`.

## Returns

Returns an `ArblibJL` algorithm object. `Arblib.jl` must be loaded before construction.
"""
struct ArblibJL{O} <: AbstractIntegralCExtensionAlgorithm
    check_analytic::Bool
    take_prec::Bool
    warn_on_no_convergence::Bool
    opts::O
end
function ArblibJL(;
        check_analytic = false, take_prec = false,
        warn_on_no_convergence = false, opts = C_NULL
    )
    isnothing(Base.get_extension(@__MODULE__, :IntegralsArblibExt)) &&
        error("ArblibJL requires `using Arblib`")
    return ArblibJL(check_analytic, take_prec, warn_on_no_convergence, opts)
end

"""
    VEGASMC(; kws...)

Markov-chain based Vegas algorithm from MCIntegration.jl.

Refer to
[`MCIntegration.integrate`](https://numericaleft.github.io/MCIntegration.jl/dev/lib/montecarlo/#MCIntegration.integrate-Tuple%7BFunction%7D)
for documentation on the keywords, which are passed directly to the solver with a set of
defaults that works for conforming integrands.

## Keyword Arguments

  - `kws...`: Backend keyword arguments forwarded to `MCIntegration.integrate`.

## Fields

  - `kws::NamedTuple`: Stored backend keyword arguments.

## Returns

Returns a `VEGASMC` algorithm object. `MCIntegration.jl` must be loaded before
construction.
"""
struct VEGASMC{K <: NamedTuple} <: AbstractIntegralExtensionAlgorithm
    kws::K
end
function VEGASMC(; kws...)
    isnothing(Base.get_extension(@__MODULE__, :IntegralsMCIntegrationExt)) &&
        error("VEGASMC requires `using MCIntegration`")
    return VEGASMC(NamedTuple(kws))
end

"""
    HAdaptiveIntegrationJL(; kws...)

Adaptive integration over simplices and orthotopes from HAdaptiveIntegration.jl.

This algorithm supports integration over:
- Orthotope domains specified as `(lb, ub)` tuples (converted to `Rectangle`, `Cuboid`, etc.)
- Simplex domains specified directly as `HAdaptiveIntegration.Triangle`,
  `HAdaptiveIntegration.Tetrahedron`, etc.

Any keyword arguments are passed directly to `HAdaptiveIntegration.integrate`.

## Keyword Arguments

  - `kws...`: Backend keyword arguments forwarded to `HAdaptiveIntegration.integrate`.

## Fields

  - `kws::NamedTuple`: Stored backend keyword arguments.

## Returns

Returns an `HAdaptiveIntegrationJL` algorithm object. `HAdaptiveIntegration.jl` must be
loaded before construction.

## Example

```julia
using Integrals, HAdaptiveIntegration

# Orthotope domain (standard lb, ub)
prob = IntegralProblem((x, p) -> x[1] + x[2], (zeros(2), ones(2)))
sol = solve(prob, HAdaptiveIntegrationJL())

# Simplex domain (triangle)
prob = IntegralProblem((x, p) -> x[1] + x[2], Triangle((0.0, 0.0), (1.0, 0.0), (0.0, 1.0)))
sol = solve(prob, HAdaptiveIntegrationJL())
```
"""
struct HAdaptiveIntegrationJL{K <: NamedTuple} <: AbstractIntegralExtensionAlgorithm
    kws::K
end
function HAdaptiveIntegrationJL(; kws...)
    isnothing(Base.get_extension(@__MODULE__, :IntegralsHAdaptiveIntegrationExt)) &&
        error("HAdaptiveIntegrationJL requires `using HAdaptiveIntegration`")
    return HAdaptiveIntegrationJL(NamedTuple(kws))
end

"""
    FastTanhSinhQuadratureJL(; rtol = 1e-12, atol = 0.0, max_levels = 10)

One-dimensional adaptive Tanh-Sinh (double exponential) quadrature from FastTanhSinhQuadrature.jl.
This method uses a double exponential transformation that provides excellent convergence properties,
especially for integrands with endpoint singularities or infinite derivatives at endpoints.

## Keyword Arguments

  - `rtol`: Relative tolerance for convergence (default: `1e-12`)
  - `atol`: Absolute tolerance for convergence (default: `0.0`)
  - `max_levels`: Maximum number of refinement levels in adaptive integration (default: `10`)

## Fields

  - `rtol`: Stored relative tolerance.
  - `atol`: Stored absolute tolerance.
  - `max_levels::Int`: Stored maximum number of refinement levels.

## Returns

Returns a `FastTanhSinhQuadratureJL` algorithm object. FastTanhSinhQuadrature.jl must be
loaded before construction.

## Example

```julia
using Integrals, FastTanhSinhQuadrature

prob = IntegralProblem((x, p) -> sqrt(x), (0.0, 1.0))
sol = solve(prob, FastTanhSinhQuadratureJL(rtol = 1e-10))
```

## Limitations

  - Only supports 1D, 2D, and 3D integration
  - Does not support batched evaluation
  - Does not support in-place integrands

## References

```tex
@article{takahasi1974double,
title={Double exponential formulas for numerical integration},
author={Takahasi, Hidetosi and Mori, Masatake},
journal={Publications of the Research Institute for Mathematical Sciences},
volume={9},
number={3},
pages={721--741},
year={1974},
publisher={Research Institute for Mathematical Sciences}
}
```
"""
struct FastTanhSinhQuadratureJL{T, S} <: AbstractIntegralExtensionAlgorithm
    rtol::T
    atol::S
    max_levels::Int
end
function FastTanhSinhQuadratureJL(; rtol = 1.0e-12, atol = 0.0, max_levels = 10)
    isnothing(Base.get_extension(@__MODULE__, :IntegralsFastTanhSinhQuadratureExt)) &&
        error("FastTanhSinhQuadratureJL requires `using FastTanhSinhQuadrature`")
    return FastTanhSinhQuadratureJL(rtol, atol, max_levels)
end

"""
    TrapezoidalUniformWeights{T} <: UniformWeights

Quadrature weights for the trapezoidal rule with uniformly spaced points.

# Fields

  - `n::Int`: Number of points
  - `h::T`: Step size between points
"""
struct TrapezoidalUniformWeights{T} <: UniformWeights
    n::Int
    h::T
end

@inline Base.getindex(w::TrapezoidalUniformWeights, i) = ifelse(
    (i == 1) || (i == w.n),
    w.h / 2,
    w.h
)

"""
    TrapezoidalNonuniformWeights{X <: AbstractArray} <: NonuniformWeights

Quadrature weights for the trapezoidal rule with non-uniformly spaced points.

# Fields

  - `x::X`: Array of sampling points
"""
struct TrapezoidalNonuniformWeights{X <: AbstractArray} <: NonuniformWeights
    x::X
end

@inline function Base.getindex(w::TrapezoidalNonuniformWeights, i)
    x = w.x
    (i == firstindex(x)) && return (x[i + 1] - x[i]) / 2
    (i == lastindex(x)) && return (x[i] - x[i - 1]) / 2
    return (x[i + 1] - x[i - 1]) / 2
end

function find_weights(x::AbstractVector, ::TrapezoidalRule)
    x isa AbstractRange && return TrapezoidalUniformWeights(length(x), step(x))
    return TrapezoidalNonuniformWeights(x)
end

@verbosity_specifier IntegralVerbosity begin
    toggles = (
        :cache_init,
        :domain_transformation,
        :algorithm_selection,
        :iteration_progress,
        :convergence_result,
        :batch_mode,
        :buffer_allocation,
        :weight_computation,
        :deprecations,
    )

    presets = (
        None = (
            cache_init = Silent(),
            domain_transformation = Silent(),
            algorithm_selection = Silent(),
            iteration_progress = Silent(),
            convergence_result = Silent(),
            batch_mode = Silent(),
            buffer_allocation = Silent(),
            weight_computation = Silent(),
            deprecations = Silent(),
        ),
        Minimal = (
            cache_init = Silent(),
            domain_transformation = Silent(),
            algorithm_selection = Silent(),
            iteration_progress = Silent(),
            convergence_result = Silent(),
            batch_mode = Silent(),
            buffer_allocation = Silent(),
            weight_computation = Silent(),
            deprecations = WarnLevel(),
        ),
        Standard = (
            cache_init = Silent(),
            domain_transformation = Silent(),
            algorithm_selection = Silent(),
            iteration_progress = Silent(),
            convergence_result = Silent(),
            batch_mode = Silent(),
            buffer_allocation = Silent(),
            weight_computation = Silent(),
            deprecations = WarnLevel(),
        ),
        Detailed = (
            cache_init = InfoLevel(),
            domain_transformation = InfoLevel(),
            algorithm_selection = InfoLevel(),
            iteration_progress = Silent(),
            convergence_result = InfoLevel(),
            batch_mode = InfoLevel(),
            buffer_allocation = InfoLevel(),
            weight_computation = InfoLevel(),
            deprecations = WarnLevel(),
        ),
        All = (
            cache_init = InfoLevel(),
            domain_transformation = InfoLevel(),
            algorithm_selection = InfoLevel(),
            iteration_progress = InfoLevel(),
            convergence_result = InfoLevel(),
            batch_mode = InfoLevel(),
            buffer_allocation = InfoLevel(),
            weight_computation = InfoLevel(),
            deprecations = WarnLevel(),
        ),
    )

    groups = (
        solver = (:iteration_progress, :convergence_result),
        setup = (:cache_init, :domain_transformation, :algorithm_selection, :weight_computation),
        debug = (:batch_mode, :buffer_allocation),
    )
end

"""
    IntegralVerbosity

Verbosity specifier for controlling logging output in Integrals.jl.

# Toggles

- `:cache_init` - IntegralCache initialization and setup
- `:domain_transformation` - Change of variables for infinite bounds and domain remapping
- `:algorithm_selection` - Which algorithm is being used and its parameters
- `:iteration_progress` - Per-iteration updates during adaptive integration (can be verbose)
- `:convergence_result` - Final integration result with value, error estimate, and tolerances
- `:batch_mode` - Batch evaluation mode selection
- `:buffer_allocation` - Pre-allocated buffer creation for reusable caches
- `:weight_computation` - Quadrature weight calculation for sampled integration methods
- `:deprecations` - Deprecation warnings for outdated API usage

# Presets

IntegralVerbosity supports five predefined SciMLLogging presets:

- **None()** - No output (best for production)
- **Minimal()** - Only deprecation warnings
- **Standard()** - Only deprecation warnings (default, recommended)
- **Detailed()** - Comprehensive output for debugging (all setup, solver, and debug info)
- **All()** - Maximum verbosity (includes iteration-by-iteration progress)

# Usage

## Using Presets

```julia
# Standard preset (default) - shows only deprecations
solve(prob, QuadGKJL(); verbose = IntegralVerbosity())
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(Standard()))

# Completely silent
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(None()))

# Only deprecation warnings
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(Minimal()))

# Detailed debugging information
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(Detailed()))

# Maximum verbosity including iteration progress
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(All()))
```

## Setting Individual Toggles

```julia
# Show only convergence results
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(
    cache_init = Silent(),
    domain_transformation = Silent(),
    algorithm_selection = Silent(),
    iteration_progress = Silent(),
    convergence_result = InfoLevel(),
    batch_mode = Silent(),
    buffer_allocation = Silent(),
    deprecations = WarnLevel()
))

# Enable iteration-by-iteration progress (useful for slow integrals)
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(iteration_progress = InfoLevel()))
```

## Using Groups

```julia
# Enable all solver messages (iteration progress + convergence)
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(solver = InfoLevel()))

# Enable all setup messages (cache, domain transforms, algorithm selection)
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(setup = InfoLevel()))

# Enable debug information (batch mode + buffer allocation)
solve(prob, QuadGKJL(); verbose = IntegralVerbosity(debug = DebugLevel()))
```

# Preset Details

## None
- All toggles: `Silent()`

## Minimal
- `deprecations` → `WarnLevel()` (shows deprecation warnings)
- All others → `Silent()`

## Standard (Default)
- `deprecations` → `WarnLevel()` (shows deprecation warnings)
- All others → `Silent()`

## Detailed
- `cache_init` → `InfoLevel()`
- `domain_transformation` → `InfoLevel()`
- `algorithm_selection` → `InfoLevel()`
- `convergence_result` → `InfoLevel()`
- `batch_mode` → `InfoLevel()`
- `buffer_allocation` → `InfoLevel()`
- `iteration_progress` → `Silent()` (still off, can be very verbose)
- `deprecations` → `WarnLevel()`

## All
- All toggles → `InfoLevel()` (including `iteration_progress`)
- `deprecations` → `WarnLevel()`
"""
function IntegralVerbosity end

const DEFAULT_VERBOSE = IntegralVerbosity()

@inline function _process_verbose_param(verbose::SciMLLogging.AbstractVerbosityPreset)
    return IntegralVerbosity(verbose)
end

@inline function _process_verbose_param(verbose::Bool)
    return verbose ? DEFAULT_VERBOSE : IntegralVerbosity(SciMLLogging.None())
end

@inline _process_verbose_param(verbose::IntegralVerbosity) = verbose

using Integrals
using FastGaussQuadrature
using StaticArrays
using Test

f = (x, p) -> prod(y -> cos(p * y), x)
exact_f = (lb, ub, p) -> prod(lu -> (sin(p * lu[2]) - sin(p * lu[1])) / p, zip(lb, ub))

# single dim

"""
    trapz(n::Integer)

Return the weights and nodes on the standard interval [-1,1] of the [trapezoidal
rule](https://en.wikipedia.org/wiki/Trapezoidal_rule).
"""
function trapz(n::Integer)
    @assert n > 1
    r = range(-1, 1, length = n)
    x = collect(r)
    halfh = step(r) / 2
    h = step(r)
    w = [(i == 1) || (i == n) ? halfh : h for i in 1:n]
    return (x, w)
end

alg = QuadratureRule(trapz, n = 1000)

lb = -1.2
ub = 3.5
p = 2.0

prob = IntegralProblem(f, (lb, ub), p)
u = solve(prob, alg).u

@test u ≈ exact_f(lb, ub, p) rtol = 1.0e-3

# multi-dim

# here we just form a tensor product of 1d rules to make a 2d rule
function trapz2(n)
    x, w = trapz(n)
    return [SVector(y, z) for (y, z) in Iterators.product(x, x)], w .* w'
end

alg = QuadratureRule(trapz2, n = 100)

lb = SVector(-1.2, -1.0)
ub = SVector(3.5, 3.7)
p = 1.2

prob = IntegralProblem(f, (lb, ub), p)
u = solve(prob, alg).u

@test u ≈ exact_f(lb, ub, p) rtol = 1.0e-3

# 1d with inf limits

g = (x, p) -> p / (x^2 + p^2)

alg = QuadratureRule(gausslegendre, n = 1000)

lb = -Inf
ub = Inf
p = 1.0

prob = IntegralProblem(g, (lb, ub), p)

@test solve(prob, alg).u ≈ pi rtol = 1.0e-4

# 1d with nout

g2 = (x, p) -> [p[1] / (x^2 + p[1]^2), p[2] / (x^2 + p[2]^2)]

alg = QuadratureRule(gausslegendre, n = 1000)

lb = -Inf
ub = Inf
p = (1.0, 1.3)

prob = IntegralProblem(g2, (lb, ub), p)

@test solve(prob, alg).u ≈ [pi, pi] rtol = 1.0e-4

#= derivative tests

using Zygote

function testf(lb, ub, p, f = f)
    prob = IntegralProblem(f, (lb, ub), p)
    solve(prob, QuadratureRule(trapz, n=200))[1]
end

lb = -1.2
ub = 2.0
p = 3.1

dp = Zygote.gradient(p -> testf(lb, ub, p), p)

@test dp ≈ f(ub, p)-f(lb, p) rtol=1e-4
=#

module IntegralsArblibExt

using Arblib: Arblib, Acb, abs_lbound, abs_ubound, midpoint
using Integrals
using SciMLLogging: @SciMLMessage

function Integrals.__solvebp_call(
        prob::IntegralProblem, alg::ArblibJL, sensealg, domain, p;
        reltol = 1.0e-8, abstol = 1.0e-8, maxiters = nothing,
        verbose = Integrals.DEFAULT_VERBOSE
    )
    lb_, ub_ = domain
    lb, ub = map(first, domain)
    if !isone(length(lb_)) || !isone(length(ub_))
        error("ArblibJL only accepts one-dimensional quadrature problems.")
    end
    @assert prob.f isa IntegralFunction

    @SciMLMessage(
        lazy"ArblibJL: starting high-precision integration with reltol=$reltol, abstol=$abstol, check_analytic=$(alg.check_analytic)",
        verbose, :algorithm_selection
    )

    if isinplace(prob)
        res = Acb(0)
        @assert res isa eltype(prob.f.integrand_prototype) "Arblib require inplace prototypes to store Acb elements"
        y_ = similar(prob.f.integrand_prototype)
        f_ = (y, x; kws...) -> (prob.f(y_, x, p; kws...); Arblib.set!(y, only(y_)))
        val = Arblib.integrate!(
            f_, res, lb, ub, atol = abstol, rtol = reltol,
            check_analytic = alg.check_analytic, take_prec = alg.take_prec,
            warn_on_no_convergence = alg.warn_on_no_convergence, opts = alg.opts
        )
    else
        f_ = (x; kws...) -> only(prob.f(x, p; kws...))
        val = Arblib.integrate(
            f_, lb, ub, atol = abstol, rtol = reltol,
            check_analytic = alg.check_analytic, take_prec = alg.take_prec,
            warn_on_no_convergence = alg.warn_on_no_convergence, opts = alg.opts
        )
    end

    @SciMLMessage(
        lazy"ArblibJL converged: val=$val, radius=$(get_radius(val))",
        verbose, :convergence_result
    )

    return SciMLBase.build_solution(prob, alg, val, get_radius(val), retcode = ReturnCode.Success)
end

function get_radius(ball)
    x = abs(midpoint(ball))
    return max(abs(x - abs_ubound(ball)), abs(x - abs_lbound(ball)))
end

end

"""
    AbstractIntegralMetaAlgorithm <: SciMLBase.AbstractIntegralAlgorithm

Abstract type for meta-algorithms that wrap other integration algorithms,
typically to apply transformations or preprocessing steps.

## Interface

Concrete subtypes must wrap an underlying `SciMLBase.AbstractIntegralAlgorithm` and
must implement the same solver lifecycle as ordinary integral algorithms:

  - `init_cacheval(alg, prob)` may allocate reusable cache state.
  - `__solve(cache, alg, sensealg, domain, p; kwargs...)` or the lower
    `__solvebp_call` layer must transform the problem and delegate to the wrapped
    algorithm.
  - returned solutions must be built for the user's original problem when the
    transformation is transparent to callers.
"""
abstract type AbstractIntegralMetaAlgorithm <: SciMLBase.AbstractIntegralAlgorithm end

"""
    ChangeOfVariables(fu2gv, alg)

Apply a change of variables from `∫ f(u,p) du` to an equivalent integral `∫ g(v,p) dv` using
a helper function `fu2gv(f, u_domain) -> (g, v_domain)`. The transformed integrand `g`
must obey the same `IntegralFunction` or `BatchIntegralFunction` calling convention as
`f`.

This meta-algorithm allows users to apply custom or alternative transformations when
integrating, particularly useful for handling infinite domains where different
transformations may provide better accuracy for specific integrand types.

## Arguments

- `fu2gv`: A transformation function with signature `(f, domain) -> (g, new_domain)` that transforms
  the integrand and domain. Built-in options include:
  - [`transformation_if_inf`](@ref): Default rational transformation (used automatically)
  - [`transformation_tan_inf`](@ref): Arctan/tan transformation
  - [`transformation_cot_inf`](@ref): Cotangent transformation for semi-infinite domains
- `alg`: The underlying integration algorithm to use (e.g., `QuadGKJL()`, `HCubatureJL()`)

## Fields

  - `fu2gv`: Stored transformation function.
  - `alg`: Stored wrapped algorithm.

## Returns

Returns a `ChangeOfVariables` meta-algorithm. When solved, the result is reported as a
solution of the original integral problem.

## Example

```julia
using Integrals

f(x, p) = exp(-x^2)
prob = IntegralProblem(f, (-Inf, Inf))

# Use alternative tan transformation instead of default
alg = ChangeOfVariables(transformation_tan_inf, QuadGKJL())
sol = solve(prob, alg)
```

See also: [`transformation_if_inf`](@ref), [`transformation_tan_inf`](@ref), [`transformation_cot_inf`](@ref)
"""
struct ChangeOfVariables{T, A <: SciMLBase.AbstractIntegralAlgorithm} <:
    AbstractIntegralMetaAlgorithm
    fu2gv::T
    alg::A
end

using Integrals, HAdaptiveIntegration
using Test

@testset "HAdaptiveIntegrationJL" begin
    reltol = 1.0e-6
    abstol = 1.0e-6

    @testset "1D orthotope" begin
        prob = IntegralProblem((x, p) -> sin(x), (0.0, 1.0))
        sol = solve(prob, HAdaptiveIntegrationJL(), reltol = reltol, abstol = abstol)
        @test sol.u ≈ 1 - cos(1.0) rtol = 1.0e-6
        @test sol.retcode == ReturnCode.Success
    end

    @testset "2D orthotope" begin
        prob = IntegralProblem((x, p) -> x[1] + x[2], (zeros(2), ones(2)))
        sol = solve(prob, HAdaptiveIntegrationJL(), reltol = reltol, abstol = abstol)
        @test sol.u ≈ 1.0 rtol = 1.0e-6
    end

    @testset "3D orthotope" begin
        prob = IntegralProblem((x, p) -> 1.0, (zeros(3), ones(3)))
        sol = solve(prob, HAdaptiveIntegrationJL(), reltol = reltol, abstol = abstol)
        @test sol.u ≈ 1.0 rtol = 1.0e-6
    end

    @testset "Triangle" begin
        prob = IntegralProblem(
            (x, p) -> 1.0, Triangle((0.0, 0.0), (1.0, 0.0), (0.0, 1.0))
        )
        sol = solve(prob, HAdaptiveIntegrationJL(), reltol = reltol, abstol = abstol)
        @test sol.u ≈ 0.5 rtol = 1.0e-6
    end

    @testset "Tetrahedron" begin
        prob = IntegralProblem(
            (x, p) -> 1.0,
            Tetrahedron(
                (0.0, 0.0, 0.0), (1.0, 0.0, 0.0),
                (0.0, 1.0, 0.0), (0.0, 0.0, 1.0)
            )
        )
        sol = solve(prob, HAdaptiveIntegrationJL(), reltol = reltol, abstol = abstol)
        @test sol.u ≈ 1 / 6 rtol = 1.0e-6
    end

    @testset "With parameters" begin
        prob = IntegralProblem((x, p) -> p * x[1], (zeros(2), ones(2)), 3.0)
        sol = solve(prob, HAdaptiveIntegrationJL(), reltol = reltol, abstol = abstol)
        @test sol.u ≈ 1.5 rtol = 1.0e-6
    end

    @testset "Error estimate" begin
        prob = IntegralProblem((x, p) -> sin(x), (0.0, 1.0))
        sol = solve(prob, HAdaptiveIntegrationJL())
        @test sol.resid isa Number
        @test sol.resid >= 0
    end
end

using Integrals
using Integrals: IntegralVerbosity
using FastGaussQuadrature
using StaticArrays
using SciMLLogging
using Test

@testset "Verbosity Tests" begin
    # Test function
    test_f = (x, p) -> sin(p * x)
    test_prob = IntegralProblem(test_f, (-1.0, 1.0), 2.0)
    test_alg = QuadratureRule(gausslegendre, n = 100)

    # Test 1: Default verbosity (Standard preset)
    @testset "Default Verbosity" begin
        cache = init(test_prob, test_alg)
        @test cache.verbosity isa IntegralVerbosity
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 2: Explicit Standard preset
    @testset "Standard Preset" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity())
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 3: None preset (silent mode)
    @testset "None Preset" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.None()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 3b: Minimal preset
    @testset "Minimal Preset" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.Minimal()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 3c: Detailed preset
    @testset "Detailed Preset" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.Detailed()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 3d: All preset
    @testset "All Preset" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.All()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 4: Boolean verbose parameter (true)
    @testset "Boolean Verbose - True" begin
        cache = init(test_prob, test_alg; verbose = true)
        @test cache.verbosity isa IntegralVerbosity
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 5: Boolean verbose parameter (false)
    @testset "Boolean Verbose - False" begin
        cache = init(test_prob, test_alg; verbose = false)
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 6: Individual toggles
    @testset "Individual Toggles" begin
        cache = init(
            test_prob, test_alg; verbose = IntegralVerbosity(
                cache_init = Silent(),
                domain_transformation = InfoLevel(),
                algorithm_selection = DebugLevel(),
                iteration_progress = Silent(),
                convergence_result = InfoLevel(),
                batch_mode = Silent(),
                buffer_allocation = Silent(),
                deprecations = WarnLevel()
            )
        )
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 7: Group settings - solver group
    @testset "Solver Group" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(solver = InfoLevel()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 8: Group settings - setup group
    @testset "Setup Group" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(setup = InfoLevel()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 9: Group settings - debug group
    @testset "Debug Group" begin
        cache = init(test_prob, test_alg; verbose = IntegralVerbosity(debug = DebugLevel()))
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 10: Verbosity with solve() directly (not using cache)
    @testset "Direct Solve with Verbosity" begin
        sol = solve(test_prob, test_alg; verbose = IntegralVerbosity())
        @test sol.retcode == ReturnCode.Success

        sol = solve(test_prob, test_alg; verbose = false)
        @test sol.retcode == ReturnCode.Success

        sol = solve(test_prob, test_alg; verbose = true)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 11: Multiple verbosity levels
    @testset "Multiple Verbosity Levels" begin
        # Test Silent
        cache = init(
            test_prob, test_alg; verbose = IntegralVerbosity(
                cache_init = Silent()
            )
        )
        @test cache.verbosity isa IntegralVerbosity

        # Test InfoLevel
        cache = init(
            test_prob, test_alg; verbose = IntegralVerbosity(
                cache_init = InfoLevel()
            )
        )

        # Test DebugLevel
        cache = init(
            test_prob, test_alg; verbose = IntegralVerbosity(
                cache_init = DebugLevel()
            )
        )

        # Test WarnLevel
        cache = init(
            test_prob, test_alg; verbose = IntegralVerbosity(
                deprecations = WarnLevel()
            )
        )
    end

    # Test 12: Verbosity with multi-dimensional integrals
    @testset "Verbosity with Multi-dimensional" begin
        f_2d = (x, p) -> prod(y -> cos(p * y), x)
        lb_2d = SVector(-1.0, -1.0)
        ub_2d = SVector(1.0, 1.0)
        prob_2d = IntegralProblem(f_2d, (lb_2d, ub_2d), 1.0)

        # Use trapz2 from the earlier test
        function trapz2_test(n)
            r = range(-1, 1, length = n)
            x = collect(r)
            halfh = step(r) / 2
            h = step(r)
            w = [(i == 1) || (i == n) ? halfh : h for i in 1:n]
            return [SVector(y, z) for (y, z) in Iterators.product(x, x)], w .* w'
        end

        alg_2d = QuadratureRule(trapz2_test, n = 50)

        cache = init(prob_2d, alg_2d; verbose = IntegralVerbosity())
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 13: Verbosity persists in cache
    @testset "Verbosity Persistence in Cache" begin
        cache = init(
            test_prob, test_alg; verbose = IntegralVerbosity(
                convergence_result = InfoLevel()
            )
        )

        # Solve and verify it works
        sol = solve!(cache)
        @test sol.retcode == ReturnCode.Success
    end

    # Test 14: All SciMLLogging presets
    @testset "All SciMLLogging Presets" begin
        # Test None
        sol = solve(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.None()))
        @test sol.retcode == ReturnCode.Success

        # Test Minimal
        sol = solve(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.Minimal()))
        @test sol.retcode == ReturnCode.Success

        # Test Standard
        sol = solve(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.Standard()))
        @test sol.retcode == ReturnCode.Success

        # Test Detailed
        sol = solve(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.Detailed()))
        @test sol.retcode == ReturnCode.Success

        # Test All
        sol = solve(test_prob, test_alg; verbose = IntegralVerbosity(SciMLLogging.All()))
        @test sol.retcode == ReturnCode.Success
    end
end

module IntegralsHAdaptiveIntegrationExt

using Integrals
using HAdaptiveIntegration: HAdaptiveIntegration
using HAdaptiveIntegration.Domain: AbstractDomain, Cuboid, Orthotope, Rectangle, Segment

using Integrals: HAdaptiveIntegrationJL

using SciMLLogging: @SciMLMessage

function _domain_from_bounds(lb::Number, ub::Number)
    return Segment(lb, ub)
end

function _domain_from_bounds(lb::AbstractVector, ub::AbstractVector)
    d = length(lb)
    if d == 1
        return Segment(lb[1], ub[1])
    elseif d == 2
        return Rectangle(Tuple(lb), Tuple(ub))
    elseif d == 3
        return Cuboid(Tuple(lb), Tuple(ub))
    else
        return Orthotope(Tuple(lb), Tuple(ub))
    end
end

function _domain_from_bounds(lb::Tuple, ub::Tuple)
    d = length(lb)
    if d == 1
        return Segment(lb[1], ub[1])
    elseif d == 2
        return Rectangle(lb, ub)
    elseif d == 3
        return Cuboid(lb, ub)
    else
        return Orthotope(lb, ub)
    end
end

function Integrals.__solvebp_call(
        cache::Integrals.IntegralCache, alg::HAdaptiveIntegrationJL, sensealg, domain, p;
        reltol = 1.0e-8, abstol = 1.0e-8,
        maxiters = typemax(Int)
    )
    prob = Integrals.build_problem(cache)
    f = cache.f

    @SciMLMessage(
        lazy"HAdaptiveIntegrationJL: starting h-adaptive integration with reltol=$reltol, abstol=$abstol, maxsubdiv=$maxiters",
        cache.verbosity, :algorithm_selection
    )

    @assert f isa IntegralFunction "HAdaptiveIntegrationJL does not support BatchIntegralFunction"
    @assert !isinplace(f) "HAdaptiveIntegrationJL does not support in-place integrands"

    # Determine the HAdaptiveIntegration domain
    hadaptive_domain = if domain isa AbstractDomain
        domain
    else
        lb, ub = domain
        _domain_from_bounds(lb, ub)
    end

    @SciMLMessage(
        lazy"Constructed $(typeof(hadaptive_domain).name.name) domain from bounds",
        cache.verbosity, :domain_transformation
    )

    _f = if hadaptive_domain isa Segment
        x -> f(x[1], p)
    else
        x -> f(x, p)
    end

    val, err = HAdaptiveIntegration.integrate(
        _f, hadaptive_domain;
        atol = abstol, rtol = reltol, maxsubdiv = maxiters,
        alg.kws...
    )

    @SciMLMessage(
        lazy"HAdaptiveIntegrationJL converged: val=$val, err=$err",
        cache.verbosity, :convergence_result
    )

    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end

end

module IntegralsCubaExt

using Integrals
using Cuba: Cuba
import Integrals: scale_x, scale_x!, CubaVegas, AbstractCubaAlgorithm,
    CubaSUAVE, CubaDivonne, CubaCuhre
using SciMLLogging: @SciMLMessage

function Integrals.__solvebp_call(
        prob::IntegralProblem, alg::AbstractCubaAlgorithm,
        sensealg,
        domain, p;
        reltol = 1.0e-4, abstol = 1.0e-12,
        maxiters = 1000000,
        verbose = Integrals.DEFAULT_VERBOSE
    )
    @assert maxiters >= 1000 "maxiters for $alg should be larger than 1000"
    lb, ub = domain
    mid = (lb + ub) / 2
    ndim = length(mid)
    (vol = prod(map(-, ub, lb))) isa Real ||
        throw(ArgumentError("Cuba.jl only supports real-valued integrands"))
    # we could support other types by multiplying by the jacobian determinant at the end

    f = prob.f
    prototype = Integrals.get_prototype(prob)
    if f isa BatchIntegralFunction
        fsize = size(prototype)[begin:(end - 1)]
        ncomp = prod(fsize)
        nvec = min(maxiters, f.max_batch)
        # nvec == 1 in Cuba will change vectors to matrices, so we won't support it when
        # batching
        nvec > 1 ||
            throw(ArgumentError("BatchIntegralFunction must take multiple batch points"))

        @SciMLMessage(
            lazy"Using batch evaluation with nvec=$nvec points per call",
            verbose, :batch_mode
        )

        if mid isa Real
            _x = zeros(typeof(mid), nvec)
            scale = x -> scale_x!(resize!(_x, length(x)), ub, lb, vec(x))
        else
            _x = zeros(eltype(mid), length(mid), nvec)
            scale = x -> scale_x!(view(_x, :, 1:size(x, 2)), ub, lb, x)
        end

        if isinplace(f)
            ax = ntuple(_ -> (:), length(fsize))
            _f = let y_ = similar(prototype, fsize..., nvec)
                function (u, _y)
                    y = @view(y_[ax..., begin:(begin + size(_y, 2) - 1)])
                    f(y, scale(u), p)
                    return _y .= reshape(y, size(_y)) .* vol
                end
            end
        else
            _f = (u, y) -> y .= reshape(f(scale(u), p), size(y)) .* vol
        end
    else
        nvec = 1
        ncomp = length(prototype)

        if mid isa Real
            scale = x -> scale_x(ub, lb, only(x))
        else
            _x = zeros(eltype(mid), length(mid))
            scale = x -> scale_x!(_x, ub, lb, x)
        end

        if isinplace(f)
            _f = let y = similar(prototype)
                (u, _y) -> begin
                    f(y, scale(u), p)
                    _y .= vec(y) .* vol
                end
            end
        else
            _f = (u, y) -> y .= Iterators.flatten(f(scale(u), p)) .* vol
        end
    end

    if alg isa CubaVegas
        @SciMLMessage(
            lazy"CubaVegas: starting Monte Carlo integration with ndim=$ndim, ncomp=$ncomp, rtol=$reltol, atol=$abstol, nstart=$(alg.nstart), nincrease=$(alg.nincrease)",
            verbose, :algorithm_selection
        )
    elseif alg isa CubaSUAVE
        @SciMLMessage(
            lazy"CubaSUAVE: starting SUAVE integration with ndim=$ndim, ncomp=$ncomp, rtol=$reltol, atol=$abstol, nnew=$(alg.nnew)",
            verbose, :algorithm_selection
        )
    elseif alg isa CubaDivonne
        @SciMLMessage(
            lazy"CubaDivonne: starting Divonne integration with ndim=$ndim, ncomp=$ncomp, rtol=$reltol, atol=$abstol, maxpass=$(alg.maxpass)",
            verbose, :algorithm_selection
        )
    elseif alg isa CubaCuhre
        @SciMLMessage(
            lazy"CubaCuhre: starting Cuhre integration with ndim=$ndim, ncomp=$ncomp, rtol=$reltol, atol=$abstol, key=$(alg.key)",
            verbose, :algorithm_selection
        )
    end

    out = if alg isa CubaVegas
        Cuba.vegas(
            _f, ndim, ncomp; rtol = reltol,
            atol = abstol, nvec = nvec,
            maxevals = maxiters,
            flags = alg.flags, seed = alg.seed, minevals = alg.minevals,
            nstart = alg.nstart, nincrease = alg.nincrease,
            gridno = alg.gridno
        )
    elseif alg isa CubaSUAVE
        Cuba.suave(
            _f, ndim, ncomp; rtol = reltol,
            atol = abstol, nvec = nvec,
            maxevals = maxiters,
            flags = alg.flags, seed = alg.seed, minevals = alg.minevals,
            nnew = alg.nnew, nmin = alg.nmin, flatness = alg.flatness
        )
    elseif alg isa CubaDivonne
        Cuba.divonne(
            _f, ndim, ncomp; rtol = reltol,
            atol = abstol, nvec = nvec,
            maxevals = maxiters,
            flags = alg.flags, seed = alg.seed, minevals = alg.minevals,
            key1 = alg.key1, key2 = alg.key2, key3 = alg.key3,
            maxpass = alg.maxpass, border = alg.border,
            maxchisq = alg.maxchisq, mindeviation = alg.mindeviation
        )
    elseif alg isa CubaCuhre
        Cuba.cuhre(
            _f, ndim, ncomp; rtol = reltol,
            atol = abstol, nvec = nvec,
            maxevals = maxiters,
            flags = alg.flags, minevals = alg.minevals, key = alg.key
        )
    end

    # out.integral is a Vector{Float64}, but we want to return it to the shape of the integrand
    val = if f isa BatchIntegralFunction
        if prototype isa AbstractVector
            out.integral[1]
        else
            reshape(out.integral, fsize)
        end
    else
        if prototype isa Real
            out.integral[1]
        elseif prototype isa AbstractVector
            out.integral
        else
            reshape(out.integral, size(prototype))
        end
    end

    @SciMLMessage(
        lazy"$(typeof(alg).name.name) converged: val=$val, err=$(out.error), prob=$(out.probability), neval=$(out.neval)",
        verbose, :convergence_result
    )

    return SciMLBase.build_solution(
        prob, alg, val, out.error,
        chi = out.probability, retcode = ReturnCode.Success
    )
end

end

module IntegralsMCIntegrationExt

using Integrals
using MCIntegration: MCIntegration, integrate
using MCIntegration.Dist: Continuous
using SciMLLogging: @SciMLMessage

_oftype(::Number, x) = only(x)
_oftype(y, x) = oftype(y, x)

function Integrals.__solvebp_call(
        prob::IntegralProblem, alg::VEGASMC, sensealg, domain, p;
        reltol = nothing, abstol = nothing, maxiters = 1000,
        verbose = Integrals.DEFAULT_VERBOSE
    )
    lb, ub = domain
    mid = (lb + ub) / 2
    tmp = vec(collect(mid))
    var = Continuous(vec([tuple(a, b) for (a, b) in zip(lb, ub)]))

    @SciMLMessage(
        lazy"VEGASMC: starting Markov-chain Monte Carlo integration with maxiters=$maxiters",
        verbose, :algorithm_selection
    )

    f = prob.f
    return if f isa BatchIntegralFunction
        error("VEGASMC doesn't support batching. See https://github.com/numericalEFT/MCIntegration.jl/issues/29")
    else
        prototype = Integrals.get_prototype(prob)
        if isinplace(prob)
            @SciMLMessage("Using in-place evaluation", verbose, :batch_mode)
            _f = let y = similar(prototype)
                (u, _y, c) -> begin
                    n = 0
                    for v in u
                        tmp[n += 1] = first(v)
                    end
                    f(y, _oftype(mid, tmp), p)
                    _y .= vec(y)
                end
            end
        else
            _f = (u, c) -> begin
                n = 0
                for v in u
                    tmp[n += 1] = first(v)
                end
                y = f(_oftype(mid, tmp), p)
                y isa AbstractArray ? vec(y) : y
            end
        end
        dof = ones(Int, length(prototype)) # each composite Continuous var gets 1 dof
        res = integrate(
            _f; var, dof, inplace = isinplace(prob), type = eltype(prototype),
            solver = :vegasmc, niter = maxiters, verbose = -2, print = -2, alg.kws...
        )
        # the package itself is not type-stable
        out::typeof(prototype), err::typeof(prototype),
            chi2 = if prototype isa Number
            map(only, (res.mean, res.stdev, res.chi2))
        else
            map(a -> reshape(a, size(prototype)), (res.mean, res.stdev, res.chi2))
        end
        chi::typeof(prototype) = map(sqrt, chi2)

        @SciMLMessage(
            lazy"VEGASMC converged: val=$out, err=$err, χ²=$chi",
            verbose, :convergence_result
        )

        SciMLBase.build_solution(
            prob, alg, out, err, chi = chi,
            retcode = ReturnCode.Success
        )
    end
end

end

using SciMLTesting, Integrals, Test
using JET

# ExplicitImports only checks an extension module once it actually exists, and an
# extension is only loaded once every one of its triggers is. Loading all of the
# weakdeps here is what makes `run_qa` scan ext/ at all.
using ADTypes, Arblib, ChainRulesCore, Cuba, Cubature, DifferentiationInterface
using FastGaussQuadrature, FastTanhSinhQuadrature, ForwardDiff, HAdaptiveIntegration
using MCIntegration, Mooncake, Zygote, ZygoteRules

run_qa(
    Integrals;
    reexports_allow = (
        :BatchIntegralFunction, :IntegralFunction, :IntegralProblem, :ReturnCode,
        :SampledIntegralProblem, :SciMLBase, :init, :isinplace, :remake, :solve, :solve!,
    ),
    aqua_kwargs = (;
        # IntegralProblem / SampledIntegralProblem are SciMLBase types this package
        # owns the integral-solver methods for, so dispatching on them is not piracy.
        piracies = (; treat_as_own = [IntegralProblem, SampledIntegralProblem]),
    ),
    ei_kwargs = (;
        no_stale_explicit_imports = (;
            # Referenced only inside `@verbosity_specifier IntegralVerbosity` (src/verbosity.jl):
            # the macro generates `IntegralVerbosity(::None)` / `(::Minimal)` / ... preset
            # constructors and `MessageLevel` / `AbstractVerbositySpecifier` /
            # `AbstractVerbosityPreset` type guards that need these bare names in `Integrals`'s
            # scope. ExplicitImports cannot see through the macro, so it reports them stale;
            # dropping the imports breaks the constructor at runtime
            # (`IntegralVerbosity(; preset=Standard())` -> UndefVarError: `AbstractVerbosityPreset`).
            ignore = (
                :AbstractVerbositySpecifier, :AbstractVerbosityPreset, :MessageLevel,
                :None, :Minimal, :Standard, :Detailed, :All,
            ),
        ),
        all_qualified_accesses_are_public = (;
            ignore = (
                # Integrals' own internals. The `ext/` modules are part of this package,
                # so they implement and call its unexported solver interface directly;
                # there is no public spelling of any of these and exporting them would
                # commit the package to a SemVer-stable internal solver API.
                :DEFAULT_VERBOSE, :IntegralCache, :AbstractIntegralCExtensionAlgorithm,
                :MooncakeVJP, :ZygoteVJP, :ReverseDiffVJP,
                :__solvebp, :__solvebp_call, :_compute_dfdp_and_f, :_evaluate!,
                :build_problem, :checkkwargs, :gausslegendre, :get_prototype,
                :init_cacheval, :substitute_bv, :substitute_f, :substitute_v,
                :t2ujac, :u2t,
                # Arblib: the ball-integration entry points and the `Acb` setter are
                # unexported and Arblib declares nothing `public`.
                :integrate, :integrate!, :set!,
                # ForwardDiff: the dual-number type and its element-type guards are the
                # documented AD interface but are not exported or declared public.
                :Dual, :can_dual, :throw_cannot_dual,
                # QuadGK: `cachedrule` is the rule cache the Mooncake rules must mark
                # non-differentiable; not public.
                :cachedrule,
                # Zygote: `Buffer` is the documented way to write mutating code under
                # Zygote, but it is not exported or declared public.
                :Buffer,
            ),
        ),
        all_explicit_imports_are_public = (;
            ignore = (
                # Integrals' own internals, imported by its own `ext/` modules (see above).
                :AbstractCubaAlgorithm, :AbstractCubatureJLAlgorithm,
                :AbstractIntegralMetaAlgorithm, :scale_x, :scale_x!,
                # Mooncake's rule-definition interface: the only way to register rules
                # with Mooncake, and none of it is exported or declared public.
                Symbol("@from_chainrules"), Symbol("@zero_derivative"), :MinimalCtx,
                # ZygoteRules owns `literal_getproperty` (Zygote only re-exports it) and
                # does not declare it public; overloading it is the only way to give
                # `sol.u` an adjoint.
                :literal_getproperty,
            ),
        ),
    ),
)

# Type-stability (JET opt-mode) regression guards for the hot solver paths. These are
# repo-specific @report_opt checks, orthogonal to run_qa's package-level JET typo check.
@testset "JET opt-mode solver paths" begin
    @testset "QuadGKJL" begin
        f = (x, p) -> x^2
        prob = IntegralProblem(f, (0.0, 1.0))
        rep = @report_opt target_modules = (Integrals,) solve(prob, QuadGKJL())
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "HCubatureJL" begin
        f = (x, p) -> x[1]^2 + x[2]^2
        prob = IntegralProblem(f, ([0.0, 0.0], [1.0, 1.0]))
        rep = @report_opt target_modules = (Integrals,) solve(prob, HCubatureJL())
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "SampledIntegralProblem with TrapezoidalRule" begin
        x = range(0, 1, length = 100)
        y = x .^ 2
        prob = SampledIntegralProblem(y, x)
        rep = @report_opt target_modules = (Integrals,) solve(prob, TrapezoidalRule())
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "SampledIntegralProblem with SimpsonsRule" begin
        x = range(0, 1, length = 101)
        y = x .^ 2
        prob = SampledIntegralProblem(y, x)
        rep = @report_opt target_modules = (Integrals,) solve(prob, SimpsonsRule())
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "Infinite bounds transformation" begin
        f = (x, p) -> exp(-x^2)
        prob = IntegralProblem(f, (0.0, Inf))
        rep = @report_opt target_modules = (Integrals,) solve(prob, QuadGKJL())
        @test length(JET.get_reports(rep)) == 0
    end

    @testset "VEGAS" begin
        # VEGAS has some inherent type instability issues due to:
        # 1. Captured variables in closures (necessary for in-place operations)
        # 2. Runtime dispatch for integrand type checking
        # We verify the number of issues is bounded and doesn't regress.
        f = (x, p) -> x^2
        prob = IntegralProblem(f, (0.0, 1.0))
        rep = @report_opt target_modules = (Integrals,) solve(prob, VEGAS())
        @test length(JET.get_reports(rep)) <= 2
    end
end

using Integrals, Test, FastGaussQuadrature

#=
f = (x, p) -> x^3 * sin(5x)
n = 250
nodes, weights = gausslegendre(n)
I = gauss_legendre(f, nothing, -1, 1, nodes, weights)
@test I ≈ 2 / (625) * (69sin(5) - 95cos(5))
I = Integrals.composite_gauss_legendre(f, nothing, -1, 1, nodes, weights, 2)
@test I ≈ 2 / (625) * (69sin(5) - 95cos(5))

f = (x, p) -> (x + p) * abs(x)
n = 100
nodes, weights = gausslegendre(n)
I = Integrals.gauss_legendre(f, 0.0, -2, 2, nodes, weights)
Ic = Integrals.composite_gauss_legendre(f, 6, -2, 2, nodes, weights, 5)
@inferred Integrals.gauss_legendre(f, 0.0, -2, 2, nodes, weights)
@inferred Integrals.composite_gauss_legendre(f, 6, -2, 2, nodes, weights, 5)
@test I≈0.0 atol=1e-6
@test Ic≈24 rtol=1e-4
=#

alg = GaussLegendre()
n = 250
nd, wt = gausslegendre(n)
@test alg.nodes == nd
@test alg.weights == wt
@test alg.subintervals == 1
alg = GaussLegendre(n = 125, subintervals = 3)
n = 125
nd, wt = gausslegendre(n)
@test alg.nodes == nd
@test alg.weights == wt
@test alg.subintervals == 3
@test typeof(alg).parameters[1]
nd, wt = gausslegendre(275)
alg = GaussLegendre(nodes = nd, weights = wt)
@test !typeof(alg).parameters[1]
@test alg.nodes == nd
@test alg.weights == wt
@test alg.subintervals == 1
alg = GaussLegendre(nodes = nd, weights = wt, subintervals = 20)
@test typeof(alg).parameters[1]
@test alg.nodes == nd
@test alg.weights == wt
@test alg.subintervals == 20

f = (x, p) -> 5x + sin(x) - p * exp(x)
prob = IntegralProblem(f, (-5, 3), 3.3)
alg = GaussLegendre()
sol = solve(prob, alg)
@test isnothing(sol.chi)
@test sol.alg === alg
@test sol.prob === prob
@test isnothing(sol.resid)
@test SciMLBase.successful_retcode(sol)
@test sol.u ≈ -exp(3) * 3.3 + 3.3 / exp(5) - 40 + cos(5) - cos(3)
alg = GaussLegendre(subintervals = 7)
sol = solve(prob, alg)
@test sol.u ≈ -exp(3) * 3.3 + 3.3 / exp(5) - 40 + cos(5) - cos(3)

f = (x, p) -> exp(-x^2)
prob = IntegralProblem(f, (0.0, Inf))
alg = GaussLegendre()
sol = solve(prob, alg)
@test sol.u ≈ sqrt(π) / 2
alg = GaussLegendre(subintervals = 1)
@test sol.u ≈ sqrt(π) / 2
alg = GaussLegendre(subintervals = 17)
@test sol.u ≈ sqrt(π) / 2

prob = IntegralProblem(f, (-Inf, Inf))
alg = GaussLegendre()
sol = solve(prob, alg)
@test sol.u ≈ sqrt(π)
alg = GaussLegendre(subintervals = 1)
@test sol.u ≈ sqrt(π)
alg = GaussLegendre(subintervals = 17)
@test sol.u ≈ sqrt(π)

prob = IntegralProblem(f, (-Inf, 0.0))
alg = GaussLegendre()
sol = solve(prob, alg)
@test sol.u ≈ sqrt(π) / 2
alg = GaussLegendre(subintervals = 1)
@test sol.u ≈ sqrt(π) / 2
alg = GaussLegendre(subintervals = 17)
@test sol.u ≈ sqrt(π) / 2

# Make sure broadcasting correctly handles the argument p
f = (x, p) -> 1 + x + x^p[1] - cos(x * p[2]) + exp(x) * p[3]
p = [0.3, 1.3, -0.5]
prob = IntegralProblem(f, (2.0, 6.3), p)
alg = GaussLegendre()
sol = solve(prob, alg)
@test sol.u ≈ -240.25235266303063249920743158729
alg = GaussLegendre(n = 500, subintervals = 17)
sol = solve(prob, alg)
@test sol.u ≈ -240.25235266303063249920743158729

# Gauss-Legendre with array-valued integrands
prob = IntegralProblem((x, p) -> [1, 2], (-1, 1))
sol = solve(prob, GaussLegendre(; n = 5))
@test sol.u ≈ 2 * [1, 2]

prob = IntegralProblem((x, p) -> [1 2; 3 4], (-1, 1))
sol = solve(prob, GaussLegendre(; n = 5))
@test sol.u ≈ 2 * [1 2; 3 4]

# Composite Gauss-Legendre with array-valued integrands
prob = IntegralProblem((x, p) -> [1, 2], (-1, 1))
sol = solve(prob, GaussLegendre(; n = 5, subintervals = 5))
@test sol.u ≈ 2 * [1, 2]

prob = IntegralProblem((x, p) -> [1 2; 3 4], (-1, 1))
sol = solve(prob, GaussLegendre(; n = 5, subintervals = 5))
@test sol.u ≈ 2 * [1 2; 3 4]

using Integrals, Test, Unitful
@testset "Sampled Integration" begin
    lb = 0.4
    ub = 1.1
    npoints = 1000

    grid1 = range(lb, ub, length = npoints)
    grid2 = rand(npoints) .* (ub - lb) .+ lb
    grid2 = [lb; sort(grid2); ub]

    grid3 = rand(npoints + 1) .* (ub - lb) .+ lb # also test odd number of points
    grid3 = [lb; sort(grid3); ub]

    exact_sols = [1 / 6 * (ub^6 - lb^6), sin(ub) - sin(lb)]
    for method in [TrapezoidalRule, SimpsonsRule]
        for grid in [grid1, grid2, grid3]
            for (i, f) in enumerate([x -> x^5, x -> cos(x)])
                exact = exact_sols[i]
                # single dimensional y
                y = f.(grid)
                prob = SampledIntegralProblem(y, grid)
                error = solve(prob, method()).u .- exact
                @test all(error .< 10^-4)

                # along dim=2
                y = f.([grid grid]')
                prob = SampledIntegralProblem(y, grid; dim = 2)
                error = solve(prob, method()).u .- exact
                @test all(error .< 10^-4)
            end
        end
    end
end

@testset "Sampled integration with dimensional axes" begin
    data = ones(2, 3)
    axis = [0.0, 1.0, 2.0]u"m"

    prob = SampledIntegralProblem(data, axis; dim = 2)
    sol = solve(prob, TrapezoidalRule())

    @test sol.u == [2.0, 2.0]u"m"
end

@testset "Caching interface" begin
    x = 0.0:0.1:1.0
    y = sin.(x)

    prob = SampledIntegralProblem(y, x)
    alg = TrapezoidalRule()

    cache = init(prob, alg)
    sol1 = solve!(cache)

    @test sol1 == solve(prob, alg)

    cache.y = cos.(x)   # use .= to update in-place
    sol2 = solve!(cache)

    @test sol2 == solve(SampledIntegralProblem(cache.y, cache.x), alg)

    cache.x = 0.0:0.2:2.0
    cache.y = sin.(cache.x)
    sol3 = solve!(cache)

    @test sol3 == solve(SampledIntegralProblem(cache.y, cache.x), alg)

    x = 0.0:0.1:1.0
    y = sin.(x) .* cos.(x')

    prob = SampledIntegralProblem(y, x)
    alg = TrapezoidalRule()

    cache = init(prob, alg)
    sol1 = solve!(cache)

    @test sol1 == solve(prob, alg)

    cache.dim = 1
    sol2 = solve!(cache)

    @test sol2 == solve(SampledIntegralProblem(y, x, dim = 1), alg)
end

module IntegralsMooncakeExt
using Integrals, SciMLBase
using QuadGK: QuadGK
using Mooncake: Mooncake, @from_chainrules, MinimalCtx, @zero_derivative
using Integrals: AbstractIntegralMetaAlgorithm, IntegralProblem
import ChainRulesCore
using Zygote: Zygote # use chainrules defined in ZygoteExt

batch_unwrap(x::AbstractArray) = dropdims(x; dims = ndims(x))

@zero_derivative MinimalCtx Tuple{typeof(QuadGK.quadgk), Vararg}
@zero_derivative MinimalCtx Tuple{typeof(QuadGK.cachedrule), Any, Integer}
@zero_derivative MinimalCtx Tuple{typeof(Integrals.checkkwargs), Vararg}
@zero_derivative MinimalCtx Tuple{typeof(Integrals.isinplace), Vararg}
@zero_derivative MinimalCtx Tuple{
    typeof(Integrals.init_cacheval),
    Union{<:SciMLBase.AbstractIntegralAlgorithm, <:AbstractIntegralMetaAlgorithm},
    Union{<:IntegralProblem, <:SampledIntegralProblem},
}
@zero_derivative MinimalCtx Tuple{
    typeof(Integrals.substitute_f),
    Union{<:BatchIntegralFunction, <:IntegralFunction}, Any, Any, Any,
}
@zero_derivative MinimalCtx Tuple{
    typeof(Integrals.substitute_v), Any, Any,
    Union{<:AbstractVector, <:Number}, Union{<:AbstractVector, <:Number},
}
@zero_derivative MinimalCtx Tuple{
    typeof(Integrals.substitute_bv), Any, AbstractArray,
    Union{<:AbstractVector, <:Number}, Union{<:AbstractVector, <:Number},
}

@from_chainrules MinimalCtx Tuple{Type{IntegralProblem{iip}}, Any, Any, Any} where {iip} true
@from_chainrules MinimalCtx Tuple{Type{IntegralProblem}, Any, Any, Any} true
@from_chainrules MinimalCtx Tuple{typeof(Integrals.u2t), Any, Any} true
@from_chainrules MinimalCtx Tuple{typeof(Integrals.__solvebp), Any, Any, Any, Any, Any} true

# Add MooncakeVJP support to the dispatch function defined in ZygoteExt
function Integrals._compute_dfdp_and_f(::Integrals.MooncakeVJP, cache, p, Δ)
    # Extract the tangent value - Mooncake wraps it in a struct with .u field
    Δ_val = hasproperty(Δ, :u) ? Δ.u : Δ

    if isinplace(cache)
        if cache.f isa BatchIntegralFunction
            dx = similar(
                cache.f.integrand_prototype,
                size(cache.f.integrand_prototype)[begin:(end - 1)]..., 1
            )
            _f = x -> (cache.f(dx, x, p); dx)
            dfdp_ = function (x, p)
                x_ = x isa AbstractArray ? reshape(x, size(x)..., 1) : [x]
                integralfunc_closure_p = p -> (cache.f(dx, x_, p); dx)
                cache_z = Mooncake.prepare_pullback_cache(integralfunc_closure_p, p)
                Δ_batch = Δ_val isa AbstractArray ? reshape(Δ_val, size(Δ_val)..., 1) : [Δ_val]
                z, grads = Mooncake.value_and_pullback!!(
                    cache_z, Δ_batch, integralfunc_closure_p, p
                )
                return grads[2]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        else
            dx = similar(cache.f.integrand_prototype)
            _f = x -> (cache.f(dx, x, p); dx)
            dfdp_ = function (x, p)
                # dx is modified inplace by dfdp/integralfunc_closure_p calls AND the Reverse pass tangent comes externally (from Δ).
                # Therefore, Δ_val is Tangent passed to the pullback AND integralfunc_closure_p must always return dx as Output.
                # i.e. (tangent(output) == Δ_val). Otherwise integralfunc_closure_p only outputs "nothing" and tangent(output) != Δ_val
                integralfunc_closure_p = p -> (cache.f(dx, x, p); dx)
                cache_z = Mooncake.prepare_pullback_cache(integralfunc_closure_p, p)
                z, grads = Mooncake.value_and_pullback!!(cache_z, Δ_val, integralfunc_closure_p, p)
                return grads[2]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        end
    else
        _f = x -> cache.f(x, p)
        if cache.f isa BatchIntegralFunction
            dfdp_ = function (x, p)
                x_ = x isa AbstractArray ? reshape(x, size(x)..., 1) : [x]
                integralfunc_closure_p = p -> cache.f(x_, p)
                cache_z = Mooncake.prepare_pullback_cache(integralfunc_closure_p, p)
                Δ_batch = Δ_val isa AbstractArray ? reshape(Δ_val, size(Δ_val)..., 1) : [Δ_val]
                z, grads = Mooncake.value_and_pullback!!(
                    cache_z, Δ_batch, integralfunc_closure_p, p
                )
                return grads[2]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        else
            dfdp_ = function (x, p)
                integralfunc_closure_p = p -> cache.f(x, p)
                cache_z = Mooncake.prepare_pullback_cache(integralfunc_closure_p, p)
                # Δ_val is integrand function's output sensitivity which we pass into Mooncake's pullback
                z, grads = Mooncake.value_and_pullback!!(cache_z, Δ_val, integralfunc_closure_p, p)
                return grads[2]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        end
    end
    return dfdp, _f
end

end

mutable struct IntegralCache{iip, F, D, P, PK, A, S, K, Tc, VT}
    iip::Val{iip}
    f::F
    domain::D
    p::P
    prob_kwargs::PK
    alg::A
    sensealg::S
    kwargs::K
    cacheval::Tc    # store alg cache here
    verbosity::VT
end

"""
    isinplace(cache::IntegralCache) -> Bool

Return whether an initialized integral cache wraps an in-place integrand.

## Arguments

  - `cache`: Cache returned by [`init`](@ref) for an `IntegralProblem`.

## Returns

Returns `true` when the cached integral function mutates its output argument, and
`false` otherwise.

## Example

```julia
using Integrals

prob = IntegralProblem((x, p) -> x^2, (0.0, 1.0))
cache = init(prob, QuadGKJL())
isinplace(cache)
```
"""
SciMLBase.isinplace(::IntegralCache{iip}) where {iip} = iip

init_cacheval(::SciMLBase.AbstractIntegralAlgorithm, args...) = nothing

"""
    init(prob::IntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm; kwargs...)

Initialize a reusable integral solver cache for `prob` and `alg`.

## Arguments

  - `prob`: Integral problem containing the integrand, domain, parameters, and problem
    keyword options.
  - `alg`: Integration algorithm, such as `QuadGKJL()`, `HCubatureJL()`, or another
    subtype of `SciMLBase.AbstractIntegralAlgorithm`.

## Keyword Arguments

  - `sensealg`: Sensitivity algorithm used by automatic differentiation paths. Defaults to
    `ReCallVJP(ZygoteVJP())`.
  - `verbose`: Verbosity control via [`IntegralVerbosity`](@ref). Defaults to
    `IntegralVerbosity()`.
  - `do_inf_transformation`: Deprecated. Infinite-domain transformations are always
    applied when needed.
  - Additional keyword arguments are forwarded to the eventual solve.

## Returns

Returns an internal cache object that stores the transformed algorithm, cached backend
state, verbosity settings, and solve keyword arguments for reuse with [`solve!`](@ref).

## Example

```julia
using Integrals

prob = IntegralProblem((x, p) -> sin(x), (0.0, pi))
cache = init(prob, QuadGKJL(); reltol = 1e-10)
solve!(cache)
```
"""
function SciMLBase.init(
        prob::IntegralProblem{iip},
        alg::SciMLBase.AbstractIntegralAlgorithm;
        sensealg = ReCallVJP(ZygoteVJP()),
        do_inf_transformation = nothing,
        verbose = IntegralVerbosity(),
        kws...
    ) where {iip}
    kwargs = pairs((; prob.kwargs..., kws...))

    checkkwargs(kwargs...)
    verb_spec = _process_verbose_param(verbose)

    do_inf_transformation === nothing ||
        @SciMLMessage(
        "do_inf_transformation is deprecated. All integral problems are transformed",
        verb_spec, :deprecations
    )
    _alg = if alg isa ChangeOfVariables
        alg
    elseif prob.domain isa Tuple
        ChangeOfVariables(transformation_if_inf, alg)
    else
        alg
    end

    cacheval = init_cacheval(_alg, prob)

    @SciMLMessage("Cache initialization complete", verb_spec, :cache_init)

    return IntegralCache{
        iip,
        typeof(prob.f),
        typeof(prob.domain),
        typeof(prob.p),
        typeof(prob.kwargs),
        typeof(_alg),
        typeof(sensealg),
        typeof(kwargs),
        typeof(cacheval),
        typeof(verb_spec),
    }(
        Val(iip),
        prob.f,
        prob.domain,
        prob.p,
        prob.kwargs,
        _alg,
        sensealg,
        kwargs,
        cacheval
        ,
        verb_spec
    )
end

function Base.getproperty(cache::IntegralCache, name::Symbol)
    if name === :lb
        domain = getfield(cache, :domain)
        lb, ub = domain
        return lb
    elseif name === :ub
        domain = getfield(cache, :domain)
        lb, ub = domain
        return ub
    end
    return getfield(cache, name)
end
function Base.setproperty!(cache::IntegralCache, name::Symbol, x)
    if name === :lb
        @SciMLMessage("updating lb is deprecated by replacing domain", cache.verbosity, :deprecations)
        lb, ub = cache.domain
        setfield!(cache, :domain, (oftype(lb, x), ub))
        return x
    elseif name === :ub
        @SciMLMessage("updating ub is deprecated by replacing domain", cache.verbosity, :deprecations)
        lb, ub = cache.domain
        setfield!(cache, :domain, (lb, oftype(ub, x)))
        return x
    end
    return setfield!(cache, name, x)
end

# Throw error if alg is not provided, as defaults are not implemented.
function SciMLBase.solve(::IntegralProblem; kwargs...)
    checkkwargs(kwargs...)
    throw(
        ArgumentError(
            """
            No integration algorithm `alg` was supplied as the second positional argument.
            Recommended integration algorithms are:
            For scalar functions: QuadGKJL()
            For ≤ 8 dimensional vector functions: HCubatureJL()
            For > 8 dimensional vector functions: MonteCarloIntegration.vegas(f, st, en, kwargs...)
            See the docstrings of the different algorithms for more detail.
            """
        )
    )
end

"""
    solve(prob::IntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm; kwargs...)

Solve an integral problem with the specified integration algorithm.

## Arguments

  - `prob`: Integral problem containing the integrand, domain, parameters, and problem
    keyword options.
  - `alg`: Integration algorithm, such as `QuadGKJL()`, `HCubatureJL()`, or another
    subtype of `SciMLBase.AbstractIntegralAlgorithm`.

## Keyword Arguments

The arguments to `solve` are common across all of the quadrature methods.
These common arguments are:

  - `maxiters`: Maximum number of algorithm iterations or backend evaluations.
  - `abstol`: Absolute tolerance for the integral residual/error estimate.
  - `reltol`: Relative tolerance for the integral residual/error estimate.
  - `verbose`: Verbosity control via [`IntegralVerbosity`](@ref). Defaults to
    `IntegralVerbosity()`.

## Returns

Returns a SciMLBase integral solution whose `u` field is the integral estimate and whose
`resid` field is the backend residual or error estimate when available.

## Example

```julia
using Integrals

prob = IntegralProblem((x, p) -> sin(x), (0.0, pi))
sol = solve(prob, QuadGKJL(); reltol = 1e-10, abstol = 1e-10)
```
"""
function SciMLBase.solve(
        prob::IntegralProblem,
        alg::SciMLBase.AbstractIntegralAlgorithm;
        kwargs...
    )
    return solve!(init(prob, alg; kwargs...))
end

"""
    solve!(cache::IntegralCache)

Solve an initialized integral cache.

## Arguments

  - `cache`: Cache returned by [`init`](@ref) for an `IntegralProblem`.

## Returns

Returns a SciMLBase integral solution whose `u` field is the integral estimate and whose
`resid` field is the backend residual or error estimate when available.

## Example

```julia
using Integrals

prob = IntegralProblem((x, p) -> x^2, (0.0, 1.0))
cache = init(prob, QuadGKJL())
sol = solve!(cache)
```
"""
function SciMLBase.solve!(cache::IntegralCache)
    return __solve(
        cache, cache.alg, cache.sensealg, cache.domain, cache.p;
        cache.kwargs...
    )
end

function build_problem(cache::IntegralCache{iip}) where {iip}
    return IntegralProblem{iip}(cache.f, cache.domain, cache.p; cache.prob_kwargs...)
end

# fallback method for existing algorithms which use no cache
function __solvebp_call(cache::IntegralCache, args...; kwargs...)
    return __solvebp_call(build_problem(cache), args...; verbose = cache.verbosity, kwargs...)
end

mutable struct SampledIntegralCache{Y, X, D, PK, A, K, Tc, VT}
    y::Y
    x::X
    dim::D
    prob_kwargs::PK
    alg::A
    kwargs::K
    isfresh::Bool   # state of whether weights have been calculated
    cacheval::Tc    # store alg weights here
    verbosity::VT
end

function Base.setproperty!(cache::SampledIntegralCache, name::Symbol, x)
    if name === :x
        setfield!(cache, :isfresh, true)
    end
    return setfield!(cache, name, x)
end

"""
    init(prob::SampledIntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm; kwargs...)

Initialize a reusable sampled-data integral solver cache.

## Arguments

  - `prob`: Sampled integral problem containing sampled values, sampling points, and the
    integration dimension.
  - `alg`: Sampled-data integration algorithm, such as `TrapezoidalRule()` or
    `SimpsonsRule()`.

## Keyword Arguments

  - `verbose`: Verbosity control via [`IntegralVerbosity`](@ref). Defaults to
    `IntegralVerbosity()`.

No other keyword arguments are accepted by this cache initializer.

## Returns

Returns an internal cache object that can be reused with [`solve!`](@ref). Updating the
sample locations marks the cached weights stale so they are recomputed before the next
solve.

## Example

```julia
using Integrals

x = range(0, 1, length = 21)
prob = SampledIntegralProblem(x .^ 2, x)
cache = init(prob, SimpsonsRule())
solve!(cache)
```
"""
function SciMLBase.init(
        prob::SampledIntegralProblem,
        alg::SciMLBase.AbstractIntegralAlgorithm;
        verbose = IntegralVerbosity(),
        kwargs...
    )
    NamedTuple(kwargs) == NamedTuple() ||
        throw(ArgumentError("There are no keyword arguments allowed to `solve`"))

    verb_spec = _process_verbose_param(verbose)
    cacheval = init_cacheval(alg, prob)
    isfresh = true

    return SampledIntegralCache(
        prob.y,
        prob.x,
        prob.dim,
        prob.kwargs,
        alg,
        kwargs,
        isfresh,
        cacheval,
        verb_spec
    )
end

"""
    solve(prob::SampledIntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm; kwargs...)

Integrate sampled data with a sampled-data quadrature algorithm.

## Arguments

  - `prob`: Sampled integral problem containing sampled values `y`, sampling points
    `x`, and the integration dimension.
  - `alg`: Sampled-data integration algorithm, such as `TrapezoidalRule()` or
    `SimpsonsRule()`.

## Keyword Arguments

There are no algorithm-independent keyword arguments used to solve
`SampledIntegralProblem`s.

## Returns

Returns a SciMLBase integral solution whose `u` field is the sampled integral estimate.

## Example

```julia
using Integrals

x = range(0, 1, length = 21)
prob = SampledIntegralProblem(x .^ 2, x)
sol = solve(prob, SimpsonsRule())
```
"""
function SciMLBase.solve(
        prob::SampledIntegralProblem,
        alg::SciMLBase.AbstractIntegralAlgorithm;
        kwargs...
    )
    return solve!(init(prob, alg; kwargs...))
end

"""
    solve!(cache::SampledIntegralCache)

Solve an initialized sampled-data integral cache.

## Arguments

  - `cache`: Cache returned by [`init`](@ref) for a `SampledIntegralProblem`.

## Returns

Returns a SciMLBase integral solution whose `u` field is the sampled integral estimate.

## Example

```julia
using Integrals

x = range(0, 1, length = 21)
prob = SampledIntegralProblem(x .^ 2, x)
cache = init(prob, TrapezoidalRule())
sol = solve!(cache)
```
"""
function SciMLBase.solve!(cache::SampledIntegralCache)
    return __solvebp(cache, cache.alg; cache.kwargs...)
end

function build_problem(cache::SampledIntegralCache)
    return SampledIntegralProblem(
        cache.y,
        cache.x;
        dim = dimension(cache.dim),
        cache.prob_kwargs...
    )
end

module IntegralsZygoteExt
using LinearAlgebra: dot
using Integrals
using Zygote: Zygote
using ZygoteRules: ZygoteRules, @adjoint, literal_getproperty
import ChainRulesCore
import ChainRulesCore: Tangent, NoTangent, ProjectTo

ChainRulesCore.@non_differentiable Integrals.checkkwargs(kwargs...)
ChainRulesCore.@non_differentiable Integrals.isinplace(f, args...)    # fixes #99
ChainRulesCore.@non_differentiable Integrals.init_cacheval(alg, prob)
ChainRulesCore.@non_differentiable Integrals.substitute_f(args...) # use ∂f/∂p instead
ChainRulesCore.@non_differentiable Integrals.substitute_v(args...) # TODO for ∂f/∂u
ChainRulesCore.@non_differentiable Integrals.substitute_bv(args...) # TODO for ∂f/∂u

function ChainRulesCore.rrule(::Type{<:IntegralProblem}, f, domain, p; kwargs...)
    prob = IntegralProblem(f, domain, p; kwargs...)
    function IntegralProblem_pullback(Δ)
        ddomain = hasproperty(Δ, :domain) ? Δ.domain : NoTangent()
        dp = hasproperty(Δ, :p) ? Δ.p : NoTangent()
        return NoTangent(), NoTangent(), ddomain, dp
    end
    return prob, IntegralProblem_pullback
end

function ChainRulesCore.rrule(
        ::Type{IntegralProblem{iip}}, f, domain, p; kwargs...
    ) where {iip}
    prob = IntegralProblem{iip}(f, domain, p; kwargs...)
    function IntegralProblem_iip_pullback(Δ)
        ddomain = hasproperty(Δ, :domain) ? Δ.domain : NoTangent()
        dp = hasproperty(Δ, :p) ? Δ.p : NoTangent()
        return NoTangent(), NoTangent(), ddomain, dp
    end
    return prob, IntegralProblem_iip_pullback
end

# TODO move this adjoint to SciMLBase
function ChainRulesCore.rrule(
        ::typeof(SciMLBase.build_solution), prob::IntegralProblem, alg, u, resid; kwargs...
    )
    function build_integral_solution_pullback(Δ)
        return NoTangent(), NoTangent(), NoTangent(), Δ, NoTangent()
    end
    return SciMLBase.build_solution(prob, alg, u, resid; kwargs...),
        build_integral_solution_pullback
end

function ChainRulesCore.rrule(::typeof(Integrals._evaluate!), f, y, u, p)
    out, back = Zygote.pullback(y, u, p) do y, u, p
        b = Zygote.Buffer(y)
        f(b, u, p)
        return copy(b)
    end
    return out, Δ -> (NoTangent(), NoTangent(), back(Δ)...)
end

function ChainRulesCore.rrule(::typeof(Integrals.u2t), lb, ub)
    tlb, tub = out = Integrals.u2t(lb, ub)
    function u2t_pullback(Δ)
        _, lbjac = Integrals.t2ujac(tlb, lb, ub)
        _, ubjac = Integrals.t2ujac(tub, lb, ub)
        return NoTangent(), Δ[1] / lbjac, Δ[2] / ubjac
    end
    return out, u2t_pullback
end

batch_unwrap(x::AbstractArray) = dropdims(x; dims = ndims(x))

# Extract tangent value - Mooncake wraps tangents in a struct with .u field
_extract_tangent(Δ) = hasproperty(Δ, :u) ? Δ.u : Δ

# Dispatch function for computing dfdp and _f based on VJP type
# Extensions can add methods for other VJP types (e.g., MooncakeVJP in IntegralsMooncakeExt)
function Integrals._compute_dfdp_and_f(
        ::Integrals.ZygoteVJP, cache, p, Δ
    )
    if isinplace(cache)
        # zygote doesn't support mutation, so we build an oop pullback
        if cache.f isa BatchIntegralFunction
            dx = similar(
                cache.f.integrand_prototype,
                size(cache.f.integrand_prototype)[begin:(end - 1)]..., 1
            )
            _f = x -> (cache.f(dx, x, p); dx)
            # TODO: let the user pass a batched jacobian so we can return a BatchIntegralFunction
            dfdp_ = function (x, p)
                x_ = x isa AbstractArray ? reshape(x, size(x)..., 1) : [x]
                z, back = Zygote.pullback(p) do p
                    _dx = Zygote.Buffer(dx)
                    cache.f(_dx, x_, p)
                    copy(_dx)
                end
                return back(
                    z .= (
                        Δ isa AbstractArray ? reshape(Δ, size(Δ)..., 1) :
                            Δ
                    )
                )[1]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        else
            dx = similar(cache.f.integrand_prototype)
            _f = x -> (cache.f(dx, x, p); dx)
            dfdp_ = function (x, p)
                _, back = Zygote.pullback(p) do p
                    _dx = Zygote.Buffer(dx)
                    cache.f(_dx, x, p)
                    copy(_dx)
                end
                return back(Δ)[1]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        end
    else
        _f = x -> cache.f(x, p)
        if cache.f isa BatchIntegralFunction
            # TODO: let the user pass a batched jacobian so we can return a BatchIntegralFunction
            dfdp_ = function (x, p)
                x_ = x isa AbstractArray ? reshape(x, size(x)..., 1) : [x]
                z, back = Zygote.pullback(p -> cache.f(x_, p), p)
                return back(Δ isa AbstractArray ? reshape(Δ, size(Δ)..., 1) : [Δ])[1]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        else
            dfdp_ = function (x, p)
                z, back = Zygote.pullback(p -> cache.f(x, p), p)
                return back(z isa Number ? only(Δ) : Δ)[1]
            end
            dfdp = IntegralFunction{false}(dfdp_, nothing)
        end
    end
    return dfdp, _f
end

function Integrals._compute_dfdp_and_f(::Integrals.ReverseDiffVJP, cache, p, Δ)
    error("ReverseDiffVJP is not yet implemented")
end

# Fallback for unknown VJP types
function Integrals._compute_dfdp_and_f(vjp, cache, p, Δ)
    error("Unsupported VJP type: $(typeof(vjp)). If using MooncakeVJP, ensure Mooncake.jl is loaded.")
end

function ChainRulesCore.rrule(
        ::typeof(Integrals.__solvebp), cache, alg, sensealg, domain,
        p;
        kwargs...
    )
    # TODO: integrate the primal and dual in the same call to the quadrature library
    out = Integrals.__solvebp_call(cache, alg, sensealg, domain, p; kwargs...)

    # the adjoint will be the integral of the input sensitivities, so it maps the
    # sensitivity of the output to an object of the type of the parameters
    function quadrature_adjoint(Δ)
        # https://juliadiff.org/ChainRulesCore.jl/dev/design/many_tangents.html#manytypes
        # Dispatch to extension-specific implementations based on VJP type
        dfdp, _f = Integrals._compute_dfdp_and_f(sensealg.vjp, cache, p, Δ)

        # Compute dp (gradient w.r.t. p) only if p is not NullParameters
        # When p is NullParameters, the parameters being differentiated are captured
        # in closures, not passed as p, so dp should be NoTangent()
        if p isa SciMLBase.NullParameters
            dp = NoTangent()
        else
            prob = Integrals.build_problem(cache)
            # dp_prob = remake(prob, f = dfdp)  # fails because we change iip
            dp_prob = IntegralProblem(dfdp, prob.domain, prob.p; prob.kwargs...)
            # the infinity transformation was already applied to f so we don't apply it to dfdp
            dp_cache = init(
                dp_prob,
                alg;
                sensealg = sensealg,
                cache.kwargs...
            )

            project_p = ProjectTo(p)
            dp = project_p(solve!(dp_cache).u)
        end

        lb, ub = domain
        if lb isa Number
            # TODO replace evaluation at endpoint (which anyone can do without Integrals.jl)
            # with integration of dfdx uing the same quadrature
            dlb = cache.f isa BatchIntegralFunction ? -batch_unwrap(_f([lb])) : -_f(lb)
            dub = cache.f isa BatchIntegralFunction ? batch_unwrap(_f([ub])) : _f(ub)
            # Extract tangent value - Mooncake wraps tangents differently than Zygote/ChainRules
            du_adj = _extract_tangent(Δ)
            return (
                NoTangent(),
                NoTangent(),
                NoTangent(),
                NoTangent(),
                Tangent{typeof(domain)}(dot(dlb, du_adj), dot(dub, du_adj)),
                dp,
            )
        else
            # we need to compute 2*length(lb) integrals on the faces of the hypercube, as we
            # can see from writing the multidimensional integral as an iterated integral
            # alternatively we can use Stokes' theorem to replace the integral on the
            # boundary with a volume integral of the flux of the integrand
            # ∫∂Ω ω = ∫Ω dω, which would be better since we won't have to change the
            # dimensionality of the integral or the quadrature used (such as quadratures
            # that don't evaluate points on the boundaries) and it could be generalized to
            # other kinds of domains. The only question is to determine ω in terms of f and
            # the deformation of the surface (e.g. consider integral over an ellipse and
            # asking for the derivative of the result w.r.t. the semiaxes of the ellipse)
            return (NoTangent(), NoTangent(), NoTangent(), NoTangent(), NoTangent(), dp)
        end
    end
    return out, quadrature_adjoint
end

@adjoint function literal_getproperty(
        sol::SciMLBase.IntegralSolution,
        ::Val{:u}
    )
    sol.u, Δ -> (SciMLBase.build_solution(sol.prob, sol.alg, Δ, sol.resid),)
end
end

module Integrals

using Reexport: Reexport, @reexport
using MonteCarloIntegration: MonteCarloIntegration, vegas
using QuadGK: QuadGK, quadgk, quadgk!, BatchIntegrand
using HCubature: HCubature, hcubature, hquadrature
@reexport using SciMLBase: SciMLBase, IntegralFunction, BatchIntegralFunction,
    IntegralProblem, SampledIntegralProblem, ReturnCode,
    isinplace, remake, init, solve!, solve
using SciMLBase: init, solve!
using LinearAlgebra: LinearAlgebra, /, norm
using Random: Random
using ArrayInterface: ArrayInterface
using SciMLLogging: SciMLLogging, @SciMLMessage, MessageLevel, Silent,
    InfoLevel, WarnLevel, @verbosity_specifier, AbstractVerbositySpecifier,
    AbstractVerbosityPreset, None, Minimal, Standard, Detailed, All

include("verbosity.jl")
include("algorithms_meta.jl")
include("common.jl")
include("algorithms.jl")
include("algorithms_sampled.jl")
include("algorithms_extension.jl")
include("infinity_handling.jl")
include("quadrules.jl")
include("sampled.jl")
include("trapezoidal.jl")
include("simpsons.jl")

"""
    QuadSensitivityAlg

Abstract type for quadrature sensitivity algorithms.

## Interface

Subtypes are used as `sensealg` values in `init` and `solve` for `IntegralProblem`s.
Concrete algorithms must provide or select a vector-Jacobian product path compatible
with the integrand calling convention and the active automatic differentiation backend.
"""
abstract type QuadSensitivityAlg end
"""
    ReCallVJP{V}

Wrapper for custom vector-Jacobian product functions in automatic differentiation.

## Arguments

  - `vjp`: Vector-Jacobian product strategy or callable object.

# Fields

  - `vjp::V`: Stored vector-Jacobian product strategy.

## Returns

Returns a `ReCallVJP` sensitivity wrapper for the `sensealg` keyword.

## Example

```julia
using Integrals

prob = IntegralProblem((x, p) -> p[1] * x, (0.0, 1.0), [2.0])
cache = init(prob, QuadGKJL(); sensealg = Integrals.ReCallVJP(Integrals.ZygoteVJP()))
```
"""
struct ReCallVJP{V}
    vjp::V
end

"""
    IntegralVJP

Abstract type for vector-Jacobian product (VJP) methods used in automatic differentiation
of integrals.

## Interface

Subtypes identify an automatic differentiation backend. Extension methods implement the
backend-specific `_compute_dfdp_and_f` dispatch used during differentiated solves. The
method must return both the parameter derivative information and the integrand wrapper
needed by the quadrature solve.
"""
abstract type IntegralVJP end
"""
    ZygoteVJP <: IntegralVJP

Uses Zygote.jl for vector-Jacobian products in automatic differentiation of integrals.

## Returns

Returns a `ZygoteVJP` backend marker for `ReCallVJP`.
"""
struct ZygoteVJP <: IntegralVJP end
"""
    ReverseDiffVJP <: IntegralVJP

Uses ReverseDiff.jl for vector-Jacobian products in automatic differentiation of integrals.

# Fields

  - `compile::Bool`: Whether to compile the ReverseDiff tape.

## Returns

Returns a `ReverseDiffVJP` backend marker for `ReCallVJP`.
"""
struct ReverseDiffVJP <: IntegralVJP
    compile::Bool
end

"""
    MooncakeVJP <: IntegralVJP

Uses Mooncake.jl for vector-Jacobian products in automatic differentiation of integrals.

## Returns

Returns a `MooncakeVJP` backend marker for `ReCallVJP`.
"""
struct MooncakeVJP <: IntegralVJP end

# Dispatch function for computing dfdp and _f based on VJP type
# Extensions add methods for specific VJP types (ZygoteVJP, MooncakeVJP, etc.)
function _compute_dfdp_and_f end

function scale_x!(_x, ub, lb, x)
    _x .= (ub .- lb) .* x .+ lb
    return _x
end

function scale_x(ub, lb, x)
    return (ub .- lb) .* x .+ lb
end

# Type-stable check for real scalar values (handles both Number and 1-element arrays)
_is_real_scalar(y::Real) = true
_is_real_scalar(y::AbstractArray) = length(y) == 1 && eltype(y) <: Real
_is_real_scalar(y) = false

const allowedkeywords = (:maxiters, :abstol, :reltol)
const KWARGERROR_MESSAGE = """
Unrecognized keyword arguments found.
The only allowed keyword arguments to `solve` are:
$allowedkeywords
See https://docs.sciml.ai/Integrals/stable/basics/solve/ for more details.
"""
"""
    CommonKwargError <: Exception

Exception thrown when unrecognized keyword arguments are passed to `solve`.

# Fields

  - `kwargs`: Keyword arguments that were passed to `solve`.

## Returns

Constructs an exception object. `showerror` reports the allowed common solver keywords
and the unrecognized names.
"""
struct CommonKwargError <: Exception
    kwargs::Any
end
function Base.showerror(io::IO, e::CommonKwargError)
    println(io, KWARGERROR_MESSAGE)
    notin = collect(map(x -> x.first ∉ allowedkeywords, e.kwargs))
    unrecognized = collect(map(x -> x.first, e.kwargs))[notin]
    print(io, "Unrecognized keyword arguments: ")
    printstyled(io, unrecognized; bold = true, color = :red)
    return print(io, "\n\n")
end
function checkkwargs(kwargs...)
    if any(x -> x.first ∉ allowedkeywords, kwargs)
        throw(CommonKwargError(kwargs))
    end
    return nothing
end

# Give a layer for meta algorithms above AD
__solve(args...; kwargs...) = __solvebp(args...; kwargs...)
# Give a layer to intercept with AD
__solvebp(args...; kwargs...) = __solvebp_call(args...; kwargs...)

function init_cacheval(alg::ChangeOfVariables, prob::IntegralProblem)
    f, domain = alg.fu2gv(prob.f, prob.domain)
    cache_alg = init_cacheval(alg.alg, remake(prob, f = f, domain = domain))
    return (alg = cache_alg,)
end

function __solve(
        cache::IntegralCache, alg::ChangeOfVariables, sensealg, udomain, p;
        kwargs...
    )
    @SciMLMessage("Applying coordinate transformation", cache.verbosity, :domain_transformation)

    cacheval = cache.cacheval.alg
    g, vdomain = alg.fu2gv(cache.f, udomain)

    @SciMLMessage(
        lazy"Domain transformed: $udomain → $vdomain",
        cache.verbosity, :domain_transformation
    )

    _cache = IntegralCache(
        Val(isinplace(g)),
        g,
        vdomain,
        p,
        cache.prob_kwargs,
        alg.alg,
        sensealg,
        cache.kwargs,
        cacheval
        ,
        cache.verbosity
    )
    sol = __solve(_cache, alg.alg, sensealg, vdomain, p; kwargs...)
    prob = build_problem(cache)
    return SciMLBase.build_solution(
        prob, alg.alg, sol.u, sol.resid, chi = sol.chi, retcode = sol.retcode, stats = sol.stats
    )
end

function get_prototype(prob::IntegralProblem)
    f = prob.f
    f.integrand_prototype !== nothing && return f.integrand_prototype
    isinplace(f) && throw(ArgumentError("in-place integral functions require a prototype"))
    lb, ub = prob.domain
    mid = (lb + ub) / 2
    p = prob.p
    return if f isa BatchIntegralFunction
        mid isa Number ? f(eltype(mid)[], p) :
            f(Matrix{eltype(mid)}(undef, length(mid), 0), p)
    else
        f(mid, p)
    end
end

function init_cacheval(alg::QuadGKJL, prob::IntegralProblem)
    alg.buffer === nothing && return
    lb, ub = map(first, prob.domain)
    mid = (lb + ub) / 2
    prototype = get_prototype(prob) * mid
    TX = typeof(mid)
    TI = typeof(prototype)
    TE = typeof(alg.norm(prototype))
    return QuadGK.alloc_segbuf(TX, TI, TE)
end

function __solvebp_call(
        cache::IntegralCache, alg::QuadGKJL, sensealg, domain, p;
        reltol = 1.0e-8, abstol = 1.0e-8,
        maxiters = typemax(Int)
    )
    @SciMLMessage(
        lazy"QuadGKJL: starting 1D integration with reltol=$reltol, abstol=$abstol, order=$(alg.order)",
        cache.verbosity, :algorithm_selection
    )

    prob = build_problem(cache)
    lb, ub = map(first, domain)
    if any(!isone ∘ length, domain)
        error("QuadGKJL only accepts one-dimensional quadrature problems.")
    end

    f = cache.f
    mid = (lb + ub) / 2

    if cache.cacheval !== nothing
        @SciMLMessage("Using pre-allocated buffer for QuadGKJL", cache.verbosity, :buffer_allocation)
    end
    if f isa BatchIntegralFunction
        @SciMLMessage("Using batch evaluation mode", cache.verbosity, :batch_mode)
        if isinplace(f)
            @SciMLMessage("Batch integrand: in-place evaluation", cache.verbosity, :batch_mode)
            # quadgk only works with vector buffers. If the buffer is an array, we have to
            # turn it into a vector of arrays
            prototype = f.integrand_prototype
            _f = if prototype isa AbstractVector
                BatchIntegrand((y, u) -> f(y, u, p), similar(prototype))
            else
                fsize = size(prototype)[begin:(end - 1)]
                BatchIntegrand{Array{eltype(prototype), length(fsize)}}() do v, u
                    let y = similar(v, eltype(eltype(v)), fsize..., length(v))
                        f(y, u, p)
                        map!(collect, v, eachslice(y; dims = ndims(y)))
                    end
                    return
                end
            end
            val,
                err = quadgk(
                _f, lb, ub, segbuf = cache.cacheval, maxevals = maxiters,
                rtol = reltol, atol = abstol, order = alg.order, norm = alg.norm
            )
        else
            @SciMLMessage("Batch integrand: out-of-place evaluation", cache.verbosity, :batch_mode)
            prototype = f(typeof(mid)[], p)
            _f = if prototype isa AbstractVector
                BatchIntegrand((y, u) -> y .= f(u, p), prototype)
            else
                BatchIntegrand{Array{eltype(prototype), ndims(prototype) - 1}}() do v, u
                    y = f(u, p)
                    map!(collect, v, eachslice(y; dims = ndims(y)))
                    return
                end
            end
            val,
                err = quadgk(
                _f, lb, ub, segbuf = cache.cacheval, maxevals = maxiters,
                rtol = reltol, atol = abstol, order = alg.order, norm = alg.norm
            )
        end
    else
        if isinplace(f)
            @SciMLMessage("Using in-place evaluation", cache.verbosity, :batch_mode)
            result = f.integrand_prototype * mid   # result may have different units than prototype
            _f = (y, u) -> f(y, u, p)
            val,
                err = quadgk!(
                _f, result, lb, ub, segbuf = cache.cacheval,
                maxevals = maxiters,
                rtol = reltol, atol = abstol, order = alg.order, norm = alg.norm
            )
        else
            @SciMLMessage("Using out-of-place evaluation", cache.verbosity, :batch_mode)
            _f = u -> f(u, p)
            val,
                err = quadgk(
                _f, lb, ub, segbuf = cache.cacheval, maxevals = maxiters,
                rtol = reltol, atol = abstol, order = alg.order, norm = alg.norm
            )
        end
    end
    @SciMLMessage(lazy"QuadGKJL converged: val=$val, err=$err", cache.verbosity, :convergence_result)
    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end

function init_cacheval(alg::HCubatureJL, prob::IntegralProblem)
    alg.buffer === nothing && return
    prototype = get_prototype(prob)
    lb, ub = map(x -> x isa Number ? tuple(x) : x, prob.domain)
    return HCubature.hcubature_buffer(x -> prototype, lb, ub; norm = alg.norm)
end
function __solvebp_call(
        cache::IntegralCache, alg::HCubatureJL, sensealg, domain, p;
        reltol = 1.0e-8, abstol = 1.0e-8,
        maxiters = typemax(Int)
    )
    @SciMLMessage(
        lazy"HCubatureJL: starting multidimensional h-adaptive integration with reltol=$reltol, abstol=$abstol, initdiv=$(alg.initdiv)",
        cache.verbosity, :algorithm_selection
    )

    prob = build_problem(cache)
    lb, ub = domain
    f = cache.f

    if cache.cacheval !== nothing
        @SciMLMessage("Using pre-allocated buffer for HCubatureJL", cache.verbosity, :buffer_allocation)
    end

    @assert f isa IntegralFunction
    if isinplace(f)
        # allocate a new output array at each evaluation since HCubature.jl doesn't support
        # inplace ops
        prototype = f.integrand_prototype
        _f = let f = f.f
            u -> (y = similar(prototype); f(y, u, p); y)
        end
    else
        _f = let f = f.f
            u -> f(u, p)
        end
    end

    val,
        err = if lb isa Number
        hquadrature(
            _f, lb, ub;
            rtol = reltol, atol = abstol, buffer = cache.cacheval,
            maxevals = maxiters, norm = alg.norm, initdiv = alg.initdiv
        )
    else
        ret = get_prototype(prob) * (prod(ub - lb) / 2) # this calculation for type stability with vector endpoints
        hcubature(
            _f, lb, ub;
            rtol = reltol, atol = abstol, buffer = cache.cacheval,
            maxevals = maxiters, norm = alg.norm,
            initdiv = alg.initdiv
        )::Tuple{typeof(ret), typeof(alg.norm(ret))}
    end
    @SciMLMessage(lazy"HCubatureJL converged: val=$val, err=$err", cache.verbosity, :convergence_result)
    return SciMLBase.build_solution(prob, alg, val, err, retcode = ReturnCode.Success)
end

function __solvebp_call(
        cache::IntegralCache, alg::VEGAS, sensealg, domain, p;
        reltol = 1.0e-4, abstol = 1.0e-4,
        maxiters = 1000
    )
    @SciMLMessage(
        lazy"VEGAS: starting Monte Carlo integration with nbins=$(alg.nbins), ncalls=$(alg.ncalls), maxiters=$maxiters",
        cache.verbosity, :algorithm_selection
    )

    prob = build_problem(cache)
    lb, ub = domain
    mid = (lb + ub) / 2
    f = prob.f

    if alg.seed !== nothing
        Random.seed!(alg.seed)
        @SciMLMessage(lazy"Random seed set to $(alg.seed)", cache.verbosity, :algorithm_selection)
    end
    if f isa BatchIntegralFunction
        @SciMLMessage("Using batch Monte Carlo sampling", cache.verbosity, :batch_mode)
        # MonteCarloIntegration v0.0.x passes points as rows of a matrix
        # MonteCarloIntegration v0.1 passes batches as a vector of views of
        # a matrix with points as columns of a matrix
        # see https://github.com/ranjanan/MonteCarloIntegration.jl/issues/16
        # This is an ugly hack that is compatible with both
        wrangle = x -> begin
            xx = eltype(x) <: SubArray ? parent(first(x)) : x'
            mid isa Number ? vec(xx) : xx
        end
        if isinplace(prob)
            y = similar(
                prob.f.integrand_prototype,
                size(prob.f.integrand_prototype)[begin:(end - 1)]...,
                prob.f.max_batch
            )
            _f = x -> (f(y, wrangle(x), p); vec(y))
        else
            y = mid isa Number ? f(typeof(mid)[], p) :
                f(Matrix{eltype(mid)}(undef, length(mid), 0), p)
            _f = x -> vec(f(wrangle(x), p))
        end
    else
        if isinplace(prob)
            @assert prob.f.integrand_prototype isa
                AbstractArray{<:Real}&&length(prob.f.integrand_prototype) == 1 "VEGAS only supports Float64-valued integrands"
            y = similar(prob.f.integrand_prototype)
            _f = x -> (prob.f(y, mid isa Number ? only(x) : x, p); only(y))
        else
            y = prob.f(mid, p)
            _f = x -> only(prob.f(mid isa Number ? only(x) : x, prob.p))
        end
    end

    if f isa BatchIntegralFunction
        @assert prod(size(y)[begin:(end - 1)]) == 1&&eltype(y) <: Real "VEGAS only supports Float64-valued scalar integrands"
    else
        @assert _is_real_scalar(y) "VEGAS only supports Float64-valued scalar integrands"
    end

    ncalls = alg.ncalls
    out = vegas(
        _f, lb, ub, rtol = reltol, atol = abstol,
        maxiter = maxiters, nbins = alg.nbins, debug = alg.debug,
        ncalls = ncalls, batch = prob.f isa BatchIntegralFunction
    )
    val, err,
        chi = out isa Tuple ? out :
        (out.integral_estimate, out.standard_deviation, out.chi_squared_average)
    @SciMLMessage(lazy"VEGAS converged: val=$val, err=$err, χ²=$chi", cache.verbosity, :convergence_result)
    return SciMLBase.build_solution(prob, alg, val, err, chi = chi, retcode = ReturnCode.Success)
end

export QuadGKJL, HCubatureJL, VEGAS, VEGASMC, GaussLegendre, QuadratureRule,
    TrapezoidalRule, SimpsonsRule
export CubaVegas, CubaSUAVE, CubaDivonne, CubaCuhre
export CubatureJLh, CubatureJLp
export ArblibJL
export HAdaptiveIntegrationJL
export FastTanhSinhQuadratureJL
export ChangeOfVariables
export transformation_if_inf, transformation_tan_inf, transformation_cot_inf

end # module

# Numerically Solving Integrals

For basic multidimensional quadrature, we can construct and solve a `IntegralProblem`.
The integral we want to evaluate is:

```math
\int_1^3\int_1^3\int_1^3 \sum_1^3 \sin(u_i) du_1du_2du_3.
```

We can numerically approximate this integral:

```@example integrate1
using Integrals
f(u, p) = sum(sin.(u))
domain = (ones(3), 3ones(3)) # (lb, ub)
prob = IntegralProblem(f, domain)
sol = solve(prob, HCubatureJL(); reltol = 1e-3, abstol = 1e-3)
sol.u
```

where the first argument of `IntegralProblem` is the integrand,
the second argument is the domain (a tuple of lower and upper bounds),
and the optional third argument contains the parameters.
`p` are the parameters of the integrand. In this case, there are no parameters,
but still `f` must be defined as `f(x,p)` and **not** `f(x)`.
For an example with parameters, see the next tutorial.
The first argument of `solve` is the problem we are solving,
the second is an algorithm to solve the problem with.
Then there are keywords which provides details how the algorithm should work,
in this case tolerances how precise the numerical approximation should be.

We can also evaluate multiple integrals at once.
We could create two `IntegralProblem`s for this,
but that is wasteful if the integrands share a lot of computation.
For example, we also want to evaluate:

```math
\int_1^3\int_1^3\int_1^3 \sum_1^3 \cos(u_i) du_1du_2du_3.
```

```@example integrate2
using Integrals
f(u, p) = [sum(sin.(u)), sum(cos.(u))]
domain = (ones(3), 3ones(3)) # (lb, ub)
prob = IntegralProblem(f, domain)
sol = solve(prob, HCubatureJL(); reltol = 1e-3, abstol = 1e-3)
sol.u
```

Another way to think about this is that the integrand is now a vector valued function.
In general, we should be able to integrate any type that is in a vector space
and supports addition and scalar multiplication, although Integrals.jl allows
scalars and arrays.
In the above example, the integrand was defined out-of-place.
This means that a new output vector is created every time the function `f` is called.
If we do not want these allocations, we can also define `f` in-place.

```@example integrate3
using Integrals, Cubature
function f(y, u, p)
    y[1] = sum(sin.(u))
    y[2] = sum(cos.(u))
end
prototype = zeros(2)
domain = (ones(3), 3ones(3)) # (lb, ub)
prob = IntegralProblem(IntegralFunction(f, prototype), domain)
sol = solve(prob, CubatureJLh(); reltol = 1e-3, abstol = 1e-3)
sol.u
```

where `y` is a cache to store the evaluation of the integrand and `prototype` is
an instance of `y` with the desired type and shape.
We needed to change the algorithm to `CubatureJLh()`
because `HCubatureJL()` does not support in-place under the hood.
`f` evaluates the integrand at a certain point,
but most adaptive quadrature algorithms need to evaluate the integrand at multiple points
in each step of the algorithm.
We would thus often like to parallelize the computation.
The batch interface allows us to compute multiple points at once.
For example, here we do allocation-free multithreading with Cubature.jl:

```@example integrate4
using Integrals, Cubature, Base.Threads
function f(y, u, p)
    Threads.@threads for i in 1:size(u, 2)
        y[1, i] = sum(sin, @view(u[:, i]))
        y[2, i] = sum(cos, @view(u[:, i]))
    end
end
prototype = zeros(2, 0)
domain = (ones(3), 3ones(3)) # (lb, ub)
prob = IntegralProblem(BatchIntegralFunction(f, prototype), domain)
sol = solve(prob, CubatureJLh(); reltol = 1e-3, abstol = 1e-3)
sol.u
```

Both `u` and `y` changed from vectors to matrices,
where each column is respectively a point the integrand is evaluated at or
the evaluation of the integrand at the corresponding point.
The `prototype` now has an extra dimension for batching that can be of size zero.
Try to create yourself an out-of-place version of the above problem.
For the full details of the batching interface, see the [problem page](@ref prob).

If we would like to compare the results against Cuba.jl's `Cuhre` method, then
the change is a one-argument change:

```@example integrate5
using Integrals
using Cuba
f(u, p) = sum(sin.(u))
domain = (ones(3), 3ones(3)) # (lb, ub)
prob = IntegralProblem(f, domain)
sol = solve(prob, CubaCuhre(); reltol = 1e-3, abstol = 1e-3)
sol.u
```

However, `Cuhre` does not support vector valued integrands.
The [solvers page](@ref solvers) gives an overview of which arguments each algorithm can handle.

## One-dimensional integrals

Integrals.jl also has specific solvers for integrals in a single dimension, such as `QuadGKJL`.
For example, we can create our own sine function by integrating the cosine function from 0 to x.

```@example integrate6
using Integrals
my_sin(x) = solve(IntegralProblem((x, p) -> cos(x), (0.0, x)), QuadGKJL()).u
x = 0:0.1:(2 * pi)
all(@. my_sin(x) ≈ sin(x))
```

## Infinity handling

Integrals.jl can also handle infinite integration bounds.
For infinite upper bounds $u$ is substituted with $a+\frac{t}{1-t}$,
and the integral is thus transformed to:

```math
\int_a^\infty f(u)du = \int_0^1 f\left(a+\frac{t}{1-t}\right)\frac{1}{(1-t)^2}dt
```

Integrals with an infinite lower bound are handled in the same way.
If both upper and lower bound are infinite, $u$ is substituted with $\frac{t}{1-t^2}$,

```math
\int_{-\infty}^\infty f(u)du = \int_{-1}^1 f\left(\frac{t}{1-t^2}\right)\frac{1+t^2}{(1-t^2)^2}dt
```

For multidimensional integrals, each variable with infinite bounds is substituted the same way.
The details of the math behind these transforms can be found
[here](https://en.wikipedia.org/wiki/Integration_by_substitution#Substitution_for_multiple_variables).

As an example, let us integrate the standard bivariate normal probability distribution
over the area above the horizontal axis, which should be equal to $0.5$.

```@example integrate6
using Distributions
using Integrals
dist = MvNormal(ones(2))
f = (x, p) -> pdf(dist, x)
domain = ([-Inf, 0.0], [Inf, Inf]) # (lb, ub)
prob = IntegralProblem(f, domain)
solve(prob, HCubatureJL(), reltol = 1e-3, abstol = 1e-3)
```

# Verbosity Control

## Verbosity Specification with SciMLLogging.jl

Integrals.jl uses SciMLLogging.jl to provide users with fine-grained control over logging and diagnostic output during integration. The `IntegralVerbosity` struct allows you to customize which messages are displayed, from deprecation warnings to detailed debugging information about algorithm selection, convergence, and iteration progress.

## Basic Usage

Pass an `IntegralVerbosity` object to `solve` or `init` using the `verbose` keyword argument:

```julia
using Integrals
using Integrals: IntegralVerbosity

# Define an integral problem
f(x, p) = x^2  # p is unused but required by the IntegralProblem interface
prob = IntegralProblem(f, 0.0, 1.0)

# Solve with detailed verbosity to see algorithm info and convergence
verbose = IntegralVerbosity(Detailed())
sol = solve(prob, QuadGKJL(), verbose = verbose)

# Solve with completely silent output (no deprecation warnings)
sol = solve(prob, QuadGKJL(), verbose = IntegralVerbosity(None()))

# Solve with default verbosity (only deprecation warnings)
sol = solve(prob, QuadGKJL())  # equivalent to verbose = IntegralVerbosity()
```

## API Reference

```@docs
Integrals.IntegralVerbosity
```

# [Integral Solver Algorithms](@id solvers)

The following algorithms are available:

  - `QuadGKJL`: Uses QuadGK.jl, which supports one-dimensional integration of scalar and array-valued integrands with in-place or batched forms. Integrands that are both in-place and batched are implemented in the wrapper but are not supported under the hood.
  - `HCubatureJL`: Uses HCubature.jl, which supports scalar and array-valued integrands and works best in low dimensions, e.g. ≤ 8. In-place integrands are implemented in the wrapper but are not supported under the hood. Batching is not supported.
  - `VEGAS`: Uses MonteCarloIntegration.jl, which requires scalar, `Float64`-valued integrands and works in any number of dimensions.
  - `VEGASMC`: Uses MCIntegration.jl. Requires `using MCIntegration`. Doesn't support batching.
  - `CubatureJLh`: h-Cubature from Cubature.jl. Requires `using Cubature`.
  - `CubatureJLp`: p-Cubature from Cubature.jl. Requires `using Cubature`.
  - `CubaVegas`: Vegas from Cuba.jl. Requires `using Cuba`.
  - `CubaSUAVE`: SUAVE from Cuba.jl. Requires `using Cuba`.
  - `CubaDivonne`: Divonne from Cuba.jl. Requires `using Cuba`. Works only for `>1`-dimensional integrations.
  - `CubaCuhre`: Cuhre from Cuba.jl. Requires `using Cuba`. Works only for `>1`-dimensional integrations.
  - `GaussLegendre`: Performs fixed-order Gauss-Legendre quadrature. Requires `using FastGaussQuadrature`.
  - `QuadratureRule`: Accepts a user-defined function that returns nodes and weights.
  - `ArblibJL`: real- and complex-valued univariate integration of holomorphic
    and meromorphic functions from Arblib.jl. Requires `using Arblib`.

```@docs
QuadGKJL
HCubatureJL
CubatureJLp
CubatureJLh
VEGAS
VEGASMC
CubaVegas
CubaSUAVE
CubaDivonne
CubaCuhre
GaussLegendre
QuadratureRule
ArblibJL
HAdaptiveIntegrationJL
FastTanhSinhQuadratureJL
ChangeOfVariables
```

# Frequently Asked Questions

## How should I use the in-place interface?

The in-place interface allows evaluating vector-valued integrands without
allocating an output array. This can be beneficial for reducing allocations when
integrating many functions simultaneously or to make use of existing in-place
code. However, note that not all algorithms use in-place operations under the
hood, i.e. [`HCubatureJL`](@ref), and may still allocate.

You can construct an `IntegralFunction(f, prototype)`, where `f` is of the form
`f(y, u, p)` where `prototype` is of the desired type and shape of `y`.

For small array outputs of a known size, consider using StaticArrays.jl for the
return value of your integrand.

## How should I use the batch interface?

The batch interface allows evaluating one (or more) integrals simultaneously at
different points, which maximizes the parallelism for a given algorithm.

You can construct an out-of-place `BatchIntegralFunction(bf)` where `bf` is of
the form `bf(u, p) = stack(x -> f(x, p), eachslice(u; dims=ndims(u)))`, where
`f` is the (unbatched) integrand.
For interoperability with as many algorithms as possible, it is important that your out-of-place batch integrand accept an **empty** array of quadrature points and still return an output with a size and type consistent with the non-empty case.

You can construct an in-place `BatchIntegralFunction(bf, prototype)`, where `bf`
is of the form `bf(y, u, p) = foreach((y,x) -> f(y,x,p), eachslice(y, dims=ndims(y)), eachslice(x, dims=ndims(x)))`.

Note that not all algorithms use in-place batched operations under the hood,
i.e. [`QuadGKJL`](@ref).

## What should I do if my solution is not converged?

Certain algorithms, such as [`QuadratureRule`](@ref), use a fixed number of points to
calculate an integral and cannot provide an error estimate. In this case, you
have to increase the number of points and check the convergence yourself, which
will depend on the accuracy of the rule you choose.

For badly-behaved integrands, such as (nearly) singular and highly oscillatory
functions, most algorithms will fail to converge and either throw an error or
silently return the incorrect result. In some cases Integrals.jl can provide an
error code when things go wrong, but otherwise you can always check if the error
estimate for the integral is less than the requested tolerance, e.g.
`sol.resid < max(abstol, reltol*norm(sol.u))`.
Sometimes using a larger tolerance or higher
precision arithmetic may help.

## How can I integrate arbitrarily-spaced data?

See the Integrating pre-sampled data page.

## How can I integrate on arbitrary geometries?

You can't, since Integrals.jl currently supports integration on hypercubes
because that is what lower-level packages implement.

## I don't see algorithm X or quadrature scheme Y

Fixed quadrature rules from other packages can be used with `QuadratureRule`.
Otherwise, feel free to open an issue or pull request.

## My integrand works with algorithm X but fails on algorithm Y

While bugs are not out of the question, certain algorithms, especially those implemented in C, are not compatible with arbitrary Julia types and have to return specific numeric types or arrays thereof.
In some cases, such as [`ArblibJL`](@ref), it is also expected that the integrand work with a custom quadrature point type.
Moreover, some algorithms, such as [`VEGAS`](@ref), only support scalar integrands.
For more details see the [solver page](@ref solvers).

## Can I take derivatives with respect to the limits of integration?

Currently this is not implemented.

# Differentiating Integrals

Integrals.jl is a fully differentiable quadrature library. Thus, it adds the
ability to perform automatic differentiation over any of the libraries that it
calls. It integrates with ForwardDiff.jl for forward-mode automatic differentiation
and Zygote.jl for reverse-mode automatic differentiation. For example:

```@example AD
using Integrals, ForwardDiff, FiniteDiff
f(x, p) = sum(sin.(x .* p))
domain = (ones(2), 3ones(2)) # (lb, ub)
p = ones(2)

function testf(p)
    prob = IntegralProblem(f, domain, p)
    sin(solve(prob, HCubatureJL(), reltol = 1e-6, abstol = 1e-6)[1])
end
testf(p)
dp1 = ForwardDiff.gradient(testf, p)
dp2 = FiniteDiff.finite_difference_gradient(testf, p)
dp1 ≈ dp2
```

Zygote.jl is also supported for reverse-mode AD:

```julia
using Zygote
dp3 = Zygote.gradient(testf, p)
```

# Integrating pre-sampled data

In some cases, instead of a function that acts as integrand,
one only possesses a list of data points `y` at a set of sampling
locations `x`, that must be integrated. This package contains functionality
for doing that.

## Example

Say, by some means we have generated a dataset `x` and `y`:

```@example 1
using Integrals # hide
f = x -> x^2
x = range(0, 1, length = 20)
y = f.(x)
```

Now, we can integrate this data set as follows:

```@example 1
problem = SampledIntegralProblem(y, x)
method = TrapezoidalRule()
solve(problem, method)
```

The exact answer is of course ``1/3``.

## Details

`SampledIntegralProblem` and the generic `solve` interface are provided by SciMLBase
and reexported by Integrals.jl for convenience. The following sections describe how
Integrals.jl algorithms use sampled data.

### Non-equidistant grids

If the sampling points `x` are provided as an `AbstractRange`
(constructed with the `range` function for example), faster methods are used that take advantage of
the fact that the points are equidistantly spaced. Otherwise, general methods are used for
non-uniform grids.

Example:

```@example 2
using Integrals # hide
f = x -> x^7
x = [0.0; sort(rand(1000)); 1.0]
y = f.(x)
problem = SampledIntegralProblem(y, x)
method = TrapezoidalRule()
solve(problem, method)
```

### Evaluating multiple integrals at once

If the provided data set `y` is a multidimensional array, the integrals are evaluated across only one
of its axes. For performance reasons, the last axis of the array `y` is chosen by default, but this can be modified with the `dim`
keyword argument to the problem definition.

```@example 3
using Integrals # hide
f1 = x -> x^2
f2 = x -> x^3
f3 = x -> x^4
x = range(0, 1, length = 20)
y = [f1.(x) f2.(x) f3.(x)]
problem = SampledIntegralProblem(y, x; dim = 1)
method = SimpsonsRule()
solve(problem, method)
```

### Supported methods

Right now, only the [`TrapezoidalRule`](https://en.wikipedia.org/wiki/Trapezoidal_rule) and [`SimpsonsRule`](https://en.wikipedia.org/wiki/Simpson%27s_rule) are supported.

```@docs
TrapezoidalRule
SimpsonsRule
```

# [Integral Functions](@id func)

`IntegralFunction` and `BatchIntegralFunction` are SciMLBase problem-interface
wrappers reexported by Integrals.jl for convenience. Their API is documented by
SciMLBase; Integrals.jl supplies algorithms that solve problems built with them.

# Common Solver Options (Solve Keyword Arguments)

`solve` is the generic SciMLBase interface reexported by Integrals.jl. Integrals.jl
implements it for integral problems and the algorithms documented on this site.

```@docs
solve(prob::IntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm)
solve(prob::SampledIntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm)
```

## Related SciML interface utilities

`init`, `solve!`, `isinplace`, `remake`, and `ReturnCode` are SciMLBase interface
utilities reexported by Integrals.jl. Their API is documented by SciMLBase.

```@docs
init(prob::IntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm)
init(prob::SampledIntegralProblem, alg::SciMLBase.AbstractIntegralAlgorithm)
solve!(cache::Integrals.IntegralCache)
solve!(cache::Integrals.SampledIntegralCache)
isinplace(cache::Integrals.IntegralCache)
```

# [Integral Problems](@id prob)

`IntegralProblem` is a SciMLBase problem type reexported by Integrals.jl for
convenience. Its construction API is documented by SciMLBase; this page describes the
integrand shapes accepted by Integrals.jl algorithms.

The correct shape of the variables (inputs) `u` and the values (outputs) `y` of the integrand `f`
depends on whether batching is used. Batching is enabled by using
[`BatchIntegralFunction`](@ref func) instead of [`IntegralFunction`](@ref func).

**Without batching (using `IntegralFunction`)**

|                       | single variable `f`              | multiple variable `f`            |
|:--------------------- |:-------------------------------- |:-------------------------------- |
| **scalar valued `f`** | `u` is a scalar, `y` is a scalar | `u` is a vector, `y` is a scalar |
| **vector valued `f`** | `u` is a scalar, `y` is a vector | `u` is a vector, `y` is a vector |

**With batching (using `BatchIntegralFunction`)**

|                       | single variable `f`              | multiple variable `f`            |
|:--------------------- |:-------------------------------- |:-------------------------------- |
| **scalar valued `f`** | `u` is a vector, `y` is a vector | `u` is a matrix, `y` is a vector |
| **vector valued `f`** | `u` is a vector, `y` is a matrix | `u` is a matrix, `y` is a matrix |

The last dimension is always used as the batching dimension,
e.g., if `u` is a matrix, then `u[:,i]` is the `i`th point where the integrand will be evaluated.

# Integrals with Caching Interface

Often, integral solvers allocate memory or reuse quadrature rules for solving different
problems. For example, if one is going to solve the same integral for several parameters

```julia
using Integrals

prob = IntegralProblem((x, p) -> sin(x * p), (0, 1), 14.0)
alg = QuadGKJL()

solve(prob, alg)

prob = remake(prob, p = 15.0)
solve(prob, alg)
```

then it would be more efficient to allocate the heap used by `quadgk` across several calls,
shown below by directly calling the library

```julia
using QuadGK
segbuf = QuadGK.alloc_segbuf()
quadgk(x -> sin(14x), 0, 1, segbuf = segbuf)
quadgk(x -> sin(15x), 0, 1, segbuf = segbuf)
```

Integrals.jl's caching interface automates this process to reuse resources if an algorithm
supports it and if the necessary types to build the cache can be inferred from `prob`. To do
this with Integrals.jl, you simply `init` a cache, `solve!`, replace `p`, and solve again.
This uses the [SciML `init` interface](https://docs.sciml.ai/SciMLBase/stable/interfaces/Init_Solve/#init-and-the-Iterator-Interface)

```@example cache1
using Integrals

prob = IntegralProblem((x, p) -> sin(x * p), (0, 1), 14.0)
alg = QuadGKJL()

cache = init(prob, alg)
sol1 = solve!(cache)
```

```@example cache1
cache.p = 15.0
sol2 = solve!(cache)
```

The caching interface is intended for updating `p` and `domain`.
Note that the types of these variables is not allowed to change.
If it is necessary to change the integrand `f` instead of defining a new
`IntegralProblem`, consider using
[FunctionWrappers.jl](https://github.com/JuliaLang/FunctionWrappers.jl).

## Caching for sampled integral problems

For sampled integral problems, it is possible to cache the weights and reuse
them for multiple data sets.

```@example cache2
using Integrals

x = 0.0:0.1:1.0
y = sin.(x)

prob = SampledIntegralProblem(y, x)
alg = TrapezoidalRule()

cache = init(prob, alg)
sol1 = solve!(cache)
```

```@example cache2
cache.y = cos.(x)   # use .= to update in-place
sol2 = solve!(cache)
```

If the grid is modified, the weights are recomputed.

```@example cache2
cache.x = 0.0:0.2:2.0
cache.y = sin.(cache.x)
sol3 = solve!(cache)
```

For multi-dimensional datasets, the integration dimension can also be changed

```@example cache3
using Integrals

x = 0.0:0.1:1.0
y = sin.(x) .* cos.(x')

prob = SampledIntegralProblem(y, x)
alg = TrapezoidalRule()

cache = init(prob, alg)
sol1 = solve!(cache)
```

```@example cache3
cache.dim = 1
sol2 = solve!(cache)
```

# Infinite Domain Transformations

When integrating over infinite domains, Integrals.jl automatically applies a change of
variables to map the infinite interval to a finite one. This page explains the available
transformations and how to choose between them.

## Background

Many numerical integration algorithms (like Gauss-Kronrod quadrature) are designed for
finite intervals. To handle infinite domains, a substitution is applied:

```math
\int_a^\infty f(u) du = \int_{\text{finite}} g(v) dv
```

where the transformation `u = h(v)` maps the finite interval to the infinite one, and
`g(v) = f(h(v)) \cdot h'(v)` includes the Jacobian of the transformation.

The choice of transformation can significantly affect accuracy, especially for integrands
with specific decay behavior.

## Available Transformations

Integrals.jl provides three built-in transformations for handling infinite bounds:

```@docs
transformation_if_inf
transformation_tan_inf
transformation_cot_inf
```

### Default: `transformation_if_inf`

The default transformation uses rational functions to map infinite domains to finite intervals:

- For doubly-infinite domains `(-∞, ∞)`: uses `u = t/(1-t²)` mapping `[-1, 1] → (-∞, ∞)`
- For semi-infinite domains `[a, ∞)`: uses `u = a + t/(1-t)` mapping `[0, 1] → [a, ∞)`
- For semi-infinite domains `(-∞, b]`: uses `u = b + t/(1+t)` mapping `[-1, 0] → (-∞, b]`

This transformation is applied automatically when using algorithms like `QuadGKJL()` or `HCubatureJL()` with infinite bounds.

### Alternative: `transformation_tan_inf`

Uses trigonometric (arctan/tan) transformations:

- For doubly-infinite domains: uses `u = tan(πt/2)` mapping `[-1, 1] → (-∞, ∞)`
- For semi-infinite domains: uses similar tan-based transformations

This can provide better accuracy than the default for integrands that decay like `1/(1+x²)`, such as Lorentzian distributions.

### Alternative: `transformation_cot_inf`

Uses cotangent-based transformations for semi-infinite domains:

- For doubly-infinite domains: falls back to tan transformation
- For semi-infinite `[a, ∞)`: uses a cot-based transformation
- For semi-infinite `(-∞, b]`: uses a cot-based transformation

This can be useful for integrands with specific singularity behavior at finite endpoints or oscillatory integrands.

## Using Custom Transformations

To use an alternative transformation, wrap your algorithm with `ChangeOfVariables`:

```julia
alg = ChangeOfVariables(transformation_function, base_algorithm)
```

where `transformation_function` is one of `transformation_if_inf`, `transformation_tan_inf`, or `transformation_cot_inf`, and `base_algorithm` is the underlying quadrature method like `QuadGKJL()` or `HCubatureJL()`.

## Comparison Example

Let's compare the different transformations on a Gaussian integral. Note that for this
particular integrand, all transformations perform well, but the example demonstrates
the syntax for using alternative transformations.

```@example transforms
using Integrals

# Gaussian function
f(x, p) = exp(-x^2)
prob = IntegralProblem(f, (-Inf, Inf))

# True value: √π
true_value = sqrt(π)

# Default algorithm (uses transformation_if_inf internally)
sol_default = solve(prob, QuadGKJL())
println("Default:     ", sol_default.u, " (error: ", abs(sol_default.u - true_value), ")")
```

You can also explicitly specify which transformation to use with `ChangeOfVariables`:

```julia
# Explicit default transformation
alg_default = ChangeOfVariables(transformation_if_inf, QuadGKJL())
sol_explicit = solve(prob, alg_default)

# Tan transformation
alg_tan = ChangeOfVariables(transformation_tan_inf, QuadGKJL())
sol_tan = solve(prob, alg_tan)

# Cot transformation
alg_cot = ChangeOfVariables(transformation_cot_inf, QuadGKJL())
sol_cot = solve(prob, alg_cot)
```

## Semi-Infinite Integrals

For semi-infinite integrals, the choice of transformation can be more important.
Here's an example integrating `exp(-x)` from 0 to ∞ (true value = 1):

```@example transforms
# Integrating exp(-x) from 0 to ∞ (true value = 1)
f(x, p) = exp(-x)
prob = IntegralProblem(f, (0.0, Inf))

sol_default = solve(prob, QuadGKJL())
println("Default: ", sol_default.u)
```

Alternative transformations can be specified similarly:

```julia
alg_tan = ChangeOfVariables(transformation_tan_inf, QuadGKJL())
sol_tan = solve(prob, alg_tan)

alg_cot = ChangeOfVariables(transformation_cot_inf, QuadGKJL())
sol_cot = solve(prob, alg_cot)
```

## When to Use Alternative Transformations

- **`transformation_if_inf` (default)**: Good general-purpose choice, works well for most
  smooth, rapidly decaying integrands.

- **`transformation_tan_inf`**: Consider when the integrand decays like `1/(1+x²)` or has
  polynomial-like tails. The arctan transformation naturally matches this decay behavior.

- **`transformation_cot_inf`**: Consider for semi-infinite integrals where the integrand
  has specific behavior near the finite boundary, or when other transformations show
  poor convergence.

## Implementing Custom Transformations

You can implement your own transformation by creating a function with signature:

```julia
my_transformation(f, domain) -> (g, new_domain)
```

where:
- `f` is the `IntegralFunction` or `BatchIntegralFunction`
- `domain` is a tuple `(lb, ub)` of bounds
- `g` is the transformed integral function
- `new_domain` is the new finite bounds

Then use it via:

```julia
alg = ChangeOfVariables(my_transformation, QuadGKJL())
```

For implementation details, see the source code of the built-in transformations in
`src/infinity_handling.jl`.
